package cn.iocoder.yudao.module.shipment.service.box;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import cn.iocoder.yudao.framework.apollo.core.event.Order.OrderApprovalTypeCheckEvent;
import cn.iocoder.yudao.framework.common.exception.ServiceException;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.code.CodeUtils;
import cn.iocoder.yudao.framework.common.util.date.DateUtils;
import cn.iocoder.yudao.framework.common.util.spring.enums.CommonStatusEnum;
import cn.iocoder.yudao.framework.dict.core.dto.DictDataRespDTO;
import cn.iocoder.yudao.framework.dict.core.util.DictFrameworkUtils;
import cn.iocoder.yudao.framework.i18n.core.I18nMessage;
import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQuery;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.framework.mybatis.core.service.AbstractService;
import cn.iocoder.yudao.framework.mybatis.core.util.MyBatisUtils;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.framework.security.core.util.SecurityFrameworkUtils;
import cn.iocoder.yudao.module.bpm.enums.BpmProcessInstanceResultEnum;
import cn.iocoder.yudao.module.customer.dal.dataobject.customerContacts.CustomerContactsDO;
import cn.iocoder.yudao.module.customer.service.customerContacts.CustomerContactsService;
import cn.iocoder.yudao.module.depository.convert.warehouse.WarehouseConvert;
import cn.iocoder.yudao.module.depository.dal.dataobject.warehouse.*;
import cn.iocoder.yudao.module.depository.dal.mysql.warehouse.WarehouseLineMapper;
import cn.iocoder.yudao.module.depository.dto.LogisticsInfoDto;
import cn.iocoder.yudao.module.depository.service.warehouse.WarehouseAreaPositionService;
import cn.iocoder.yudao.module.depository.service.warehouse.WarehouseAreaService;
import cn.iocoder.yudao.module.depository.service.warehouse.WarehouseService;
import cn.iocoder.yudao.module.depository.vo.dept.DeptWarehouseBaseVO;
import cn.iocoder.yudao.module.depository.vo.warehouse.WarehouseLineBaseVO;
import cn.iocoder.yudao.module.depository.vo.warehouse.WarehouseRespVO;
import cn.iocoder.yudao.module.ecw.api.internalMessage.ClientInternalMessageApi;
import cn.iocoder.yudao.module.ecw.api.internalMessage.dto.InternalMessageCreateDto;
import cn.iocoder.yudao.module.ecw.controller.admin.cabinet.vo.CabinetExportReqVO;
import cn.iocoder.yudao.module.ecw.controller.admin.cabinet.vo.CabinetRespVO;
import cn.iocoder.yudao.module.ecw.convert.cabinet.CabinetConvert;
import cn.iocoder.yudao.module.ecw.dal.dataobject.busiPwd.BusiPwdDO;
import cn.iocoder.yudao.module.ecw.dal.dataobject.cabinet.CabinetDO;
import cn.iocoder.yudao.module.ecw.dal.dataobject.ladingTemplate.LadingTemplateDO;
import cn.iocoder.yudao.module.ecw.dal.dataobject.region.RegionDO;
import cn.iocoder.yudao.module.ecw.dal.mysql.ladingTemplate.LadingTemplateMapper;
import cn.iocoder.yudao.module.ecw.service.busiPwd.BusiPwdService;
import cn.iocoder.yudao.module.ecw.service.cabinet.CabinetService;
import cn.iocoder.yudao.module.ecw.service.region.RegionService;
import cn.iocoder.yudao.module.member.api.ScoreProducerApi;
import cn.iocoder.yudao.module.member.api.user.MemberUserApi;
import cn.iocoder.yudao.module.member.api.user.dto.UserRespDTO;
import cn.iocoder.yudao.module.member.enums.ScoreRuleTypeEnum;
import cn.iocoder.yudao.module.order.convert.orderLocation.OrderLocationConvert;
import cn.iocoder.yudao.module.order.dal.dataobject.approval.OrderApprovalDO;
import cn.iocoder.yudao.module.order.dal.dataobject.order.OrderDO;
import cn.iocoder.yudao.module.order.dal.dataobject.order.zTest;
import cn.iocoder.yudao.module.order.dal.dataobject.orderCargoControl.OrderCargoControlDO;
import cn.iocoder.yudao.module.order.dal.dataobject.orderConsignee.OrderConsigneeDO;
import cn.iocoder.yudao.module.order.dal.dataobject.orderConsignor.OrderConsignorDO;
import cn.iocoder.yudao.module.order.dal.dataobject.orderGuanlian.OrderGuanlianDO;
import cn.iocoder.yudao.module.order.dal.dataobject.orderItem.OrderItemDO;
import cn.iocoder.yudao.module.order.dal.dataobject.orderLocation.OrderLocationDO;
import cn.iocoder.yudao.module.order.dal.dataobject.orderSplit.OrderSplitDO;
import cn.iocoder.yudao.module.order.dal.dataobject.orderSplitItem.OrderSplitItemDO;
import cn.iocoder.yudao.module.order.dal.mysql.order.ZTestMapper2;
import cn.iocoder.yudao.module.order.dal.mysql.orderSplitItem.OrderSplitItemMapper;
import cn.iocoder.yudao.module.order.dto.ContainerNumberSummaryDto;
import cn.iocoder.yudao.module.order.dto.OrderRemindExceptionDto;
import cn.iocoder.yudao.module.order.enums.*;
import cn.iocoder.yudao.module.order.service.approval.OrderApprovalService;
import cn.iocoder.yudao.module.order.service.order.*;
import cn.iocoder.yudao.module.order.service.orderCargoControl.OrderCargoControlService;
import cn.iocoder.yudao.module.order.service.orderException.OrderExceptionService;
import cn.iocoder.yudao.module.order.service.orderSplit.OrderSplitCheckService;
import cn.iocoder.yudao.module.order.service.orderSplit.OrderSplitService;
import cn.iocoder.yudao.module.order.service.targetLog.TargetLogService;
import cn.iocoder.yudao.module.order.vo.order.OrderBackPageVO;
import cn.iocoder.yudao.module.order.vo.order.OrderBackVO;
import cn.iocoder.yudao.module.order.vo.order.OrderQueryVO;
import cn.iocoder.yudao.module.order.vo.orderConsignee.OrderConsigneeBackVO;
import cn.iocoder.yudao.module.order.vo.orderConsignor.OrderConsignorBackVO;
import cn.iocoder.yudao.module.order.vo.orderException.OrderExceptionCreateReqVO;
import cn.iocoder.yudao.module.order.vo.orderException.OrderExceptionDescVO;
import cn.iocoder.yudao.module.order.vo.orderLocation.OrderLocationBaseVO;
import cn.iocoder.yudao.module.order.vo.orderLocation.OrderLocationCreateReqVO;
import cn.iocoder.yudao.module.order.vo.orderSplit.OrderSplitApplyDetailDto;
import cn.iocoder.yudao.module.order.vo.orderSplit.OrderSplitBackVO;
import cn.iocoder.yudao.module.order.vo.orderSplit.OrderSplitCreateReqVO;
import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductAttrDO;
import cn.iocoder.yudao.module.product.dal.dataobject.product.ProductPriceDO;
import cn.iocoder.yudao.module.product.service.product.ProductAttrService;
import cn.iocoder.yudao.module.product.service.product.ProductPriceService;
import cn.iocoder.yudao.module.sale.convert.channel.ChannelConvert;
import cn.iocoder.yudao.module.sale.dal.dataobject.channel.ChannelDO;
import cn.iocoder.yudao.module.sale.service.channel.ChannelService;
import cn.iocoder.yudao.module.sale.vo.channel.ChannelRespVO;
import cn.iocoder.yudao.module.shipment.convert.*;
import cn.iocoder.yudao.module.shipment.convert.boxAirFly.BoxAirFlyConvert;
import cn.iocoder.yudao.module.shipment.convert.boxOrderExit.BoxOrderExitConvert;
import cn.iocoder.yudao.module.shipment.dal.dataobject.*;
import cn.iocoder.yudao.module.shipment.dal.dataobject.boxAirFly.BoxAirFlyDO;
import cn.iocoder.yudao.module.shipment.dal.dataobject.boxAirNumberRecord.BoxAirNumberRecordDO;
import cn.iocoder.yudao.module.shipment.dal.dataobject.boxArrivalOrder.BoxArrivalOrderDO;
import cn.iocoder.yudao.module.shipment.dal.dataobject.boxClearanceOrder.BoxClearanceOrderDO;
import cn.iocoder.yudao.module.shipment.dal.dataobject.boxCustomsSplit.BoxCustomsSplitDO;
import cn.iocoder.yudao.module.shipment.dal.dataobject.boxOrderCheckInfo.BoxOrderCheckInfoDO;
import cn.iocoder.yudao.module.shipment.dal.dataobject.boxOrderExit.BoxOrderExitDO;
import cn.iocoder.yudao.module.shipment.dal.dataobject.makeBillOfLading.MakeBillOfLadingDO;
import cn.iocoder.yudao.module.shipment.dal.mysql.BoxMapper;
import cn.iocoder.yudao.module.shipment.dal.mysql.BoxNumberRecordMapper;
import cn.iocoder.yudao.module.shipment.enums.*;
import cn.iocoder.yudao.module.shipment.service.boxAbnormal.BoxAbnormalService;
import cn.iocoder.yudao.module.shipment.service.boxAgent.BoxAgentService;
import cn.iocoder.yudao.module.shipment.service.boxAirCheckout.BoxAirCheckoutService;
import cn.iocoder.yudao.module.shipment.service.boxAirFly.BoxAirFlyService;
import cn.iocoder.yudao.module.shipment.service.boxAirNumberRecord.BoxAirNumberRecordService;
import cn.iocoder.yudao.module.shipment.service.boxAirShipment.BoxAirShipmentService;
import cn.iocoder.yudao.module.shipment.service.boxApproval.BoxApprovalService;
import cn.iocoder.yudao.module.shipment.service.boxArrival.BoxArrivalService;
import cn.iocoder.yudao.module.shipment.service.boxArrivalAir.BoxArrivalAirService;
import cn.iocoder.yudao.module.shipment.service.boxArrivalOrder.BoxArrivalOrderService;
import cn.iocoder.yudao.module.shipment.service.boxBarge.BoxBargeService;
import cn.iocoder.yudao.module.shipment.service.boxBookAir.BoxBookAirService;
import cn.iocoder.yudao.module.shipment.service.boxBookSea.BoxBookSeaService;
import cn.iocoder.yudao.module.shipment.service.boxCabinet.BoxCabinetService;
import cn.iocoder.yudao.module.shipment.service.boxCabinetUnload.BoxCabinetUnloadService;
import cn.iocoder.yudao.module.shipment.service.boxClearance.BoxClearanceService;
import cn.iocoder.yudao.module.shipment.service.boxClearanceDoc.BoxClearanceDocService;
import cn.iocoder.yudao.module.shipment.service.boxClearanceOrder.BoxClearanceOrderService;
import cn.iocoder.yudao.module.shipment.service.boxCustoms.BoxCustomsService;
import cn.iocoder.yudao.module.shipment.service.boxCustomsSplit.BoxCustomsSplitService;
import cn.iocoder.yudao.module.shipment.service.boxLadingBill.BoxLadingBillService;
import cn.iocoder.yudao.module.shipment.service.boxLadingCopy.BoxLadingCopyService;
import cn.iocoder.yudao.module.shipment.service.boxLoadInfo.BoxLoadInfoService;
import cn.iocoder.yudao.module.shipment.service.boxMergePkg.BoxMergePkgService;
import cn.iocoder.yudao.module.shipment.service.boxOpLog.BoxOpLogService;
import cn.iocoder.yudao.module.shipment.service.boxOrderCheckInfo.BoxOrderCheckInfoService;
import cn.iocoder.yudao.module.shipment.service.boxOrderExit.BoxOrderExitService;
import cn.iocoder.yudao.module.shipment.service.boxOrderSmsLog.BoxOrderSmsLogService;
import cn.iocoder.yudao.module.shipment.service.boxPkgOrder.BoxPkgOrderService;
import cn.iocoder.yudao.module.shipment.service.boxPreloadGoods.BoxPreloadGoodsService;
import cn.iocoder.yudao.module.shipment.service.boxSettlement.BoxSettlementService;
import cn.iocoder.yudao.module.shipment.service.boxShipConfig.BoxShipConfigService;
import cn.iocoder.yudao.module.shipment.service.boxShipping.BoxShippingService;
import cn.iocoder.yudao.module.shipment.service.boxTakeoff.BoxTakeoffService;
import cn.iocoder.yudao.module.shipment.service.boxTally.BoxTallyService;
import cn.iocoder.yudao.module.shipment.service.boxTrailer.BoxTrailerService;
import cn.iocoder.yudao.module.shipment.service.makeBillOfLading.MakeBillOfLadingService;
import cn.iocoder.yudao.module.shipment.utils.NumberUtils;
import cn.iocoder.yudao.module.shipment.vo.box.*;
import cn.iocoder.yudao.module.shipment.vo.boxAgent.BoxAgentBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxAirCheckout.BoxAirCheckoutBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxAirFly.BoxAirFlyBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxAirShipment.BoxAirShipmentBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxApproval.BoxApprovalBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxApproval.BoxApprovalCreateReqVO;
import cn.iocoder.yudao.module.shipment.vo.boxArrival.BoxArrivalBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxArrivalAir.BoxArrivalAirBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxBarge.BoxBargeBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxBookAir.BoxBookAirBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxBookSea.BoxBookSeaBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxCabinet.BoxCabinetApplyReq;
import cn.iocoder.yudao.module.shipment.vo.boxCabinet.BoxCabinetBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxCabinet.BoxCabinetLoadVO;
import cn.iocoder.yudao.module.shipment.vo.boxCabinetUnload.BoxCabinetUnloadBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxCabinetUnload.BoxUnloadApplyReq;
import cn.iocoder.yudao.module.shipment.vo.boxClearance.BoxClearanceBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxClearanceDoc.BoxClearanceDocBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxCustoms.BoxCustomsApplyReq;
import cn.iocoder.yudao.module.shipment.vo.boxCustoms.BoxCustomsBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxLadingBill.BoxLadingBillBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxLadingCopy.BoxLadingCopyBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxLoadInfo.BoxLoadBatchRemoveReqVO;
import cn.iocoder.yudao.module.shipment.vo.boxLoadInfo.BoxLoadInfoBatchAddReqVO;
import cn.iocoder.yudao.module.shipment.vo.boxLoadInfo.BoxLoadInfoCreateReqVO;
import cn.iocoder.yudao.module.shipment.vo.boxLoadInfo.BoxLoadInfoQueryVO;
import cn.iocoder.yudao.module.shipment.vo.boxMergePkg.BoxMergePkgBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxOrderExit.BoxOrderExitCreateReqVO;
import cn.iocoder.yudao.module.shipment.vo.boxPreloadGoods.BoxLoadOrderVO;
import cn.iocoder.yudao.module.shipment.vo.boxPreloadGoods.BoxPreloadGoodsBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxPreloadSection.BoxLoadDetailBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxPreloadSection.BoxLoadSectionBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxSettlement.BoxSettlementBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxShipConfig.BoxShipConfigBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxShipping.BoxShippingBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxTakeoff.BoxTakeoffBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxTally.BoxGuanlianOrderBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxTally.BoxOrderLocationUpdateReq;
import cn.iocoder.yudao.module.shipment.vo.boxTally.BoxTallyBackVO;
import cn.iocoder.yudao.module.shipment.vo.boxTally.BoxTallyVO;
import cn.iocoder.yudao.module.shipment.vo.boxTrailer.BoxTrailerBackVO;
import cn.iocoder.yudao.module.system.api.sms.SmsSendApi;
import cn.iocoder.yudao.module.system.api.sms.dto.send.SmsSendSingleToUserReqDTOV2;
import cn.iocoder.yudao.module.system.api.user.AdminUserApi;
import cn.iocoder.yudao.module.system.controller.admin.dict.vo.data.DictDataPageReqVO;
import cn.iocoder.yudao.module.system.dal.dataobject.dict.DictDataDO;
import cn.iocoder.yudao.module.system.enums.sms.SmsIsOrdersEnum;
import cn.iocoder.yudao.module.system.enums.sms.SmsIsTransportEnum;
import cn.iocoder.yudao.module.system.enums.sms.SmsMessageTypeEnum;
import cn.iocoder.yudao.module.system.enums.sms.SmsNodeEnum;
import cn.iocoder.yudao.module.system.service.dict.DictDataService;
import cn.iocoder.yudao.module.wealth.dal.dataobject.receivable.ReceivableDO;
import cn.iocoder.yudao.module.wealth.service.receivable.ReceivableService;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.google.common.base.Joiner;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.context.ApplicationContext;
import org.springframework.context.annotation.Lazy;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.DigestUtils;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.order.enums.ErrorCodeConstants.ORDER_LINE_CHANNEL_NOT_NULL;
import static cn.iocoder.yudao.module.shipment.enums.BoxAirStatusEnum.TO_WAREHOUSED;
import static cn.iocoder.yudao.module.shipment.enums.BoxStatusEnum.UNLOADED;
import static cn.iocoder.yudao.module.shipment.enums.ErrorCodeConstants.*;
import static cn.iocoder.yudao.module.system.enums.ErrorCodeConstants.DEPT_NOT_FOUND;

/**
 * 出货 Service 实现类
 *
 * @author lalala
 */
@Service
@Validated
@Slf4j
public class BoxServiceImpl extends AbstractService<BoxMapper, BoxDO> implements BoxService {

    @Resource
    private ZTestMapper2 zTestMapper2;

    @Resource
    private BoxMapper boxMapper;

    @Resource
    private BoxAirNumberRecordService boxAirNumberRecordService;
    @Resource
    private WarehouseLineMapper warehouseLineMapper;

    @Resource
    private LadingTemplateMapper ladingTemplateMapper;

    @Resource
    private BoxOpLogService boxOpLogService;

    @Resource
    private BoxShipConfigService boxShipConfigService;
    @Resource
    private BoxAgentService boxAgentService;

    @Resource
    private BoxNumberRecordMapper boxNumberRecordMapper;

    @Resource
    private CabinetService cabinetService;
    @Resource
    private WarehouseService warehouseService;

    @Resource
    private RegionService regionService;
    @Resource
    private ChannelService channelService;
    @Resource
    @Lazy
    private BoxPreloadGoodsService boxPreloadGoodsService;

    @Resource
    private OrderGuanlianService orderGuanlianService;

    @Resource
    private BoxAirShipmentService boxAirShipmentService;

    @Resource
    private BoxAirCheckoutService boxAirCheckoutService;

    @Resource
    AdminUserApi adminUserApi;
    @Resource
    private BoxBookSeaService boxBookSeaService;
    @Resource
    private BoxAbnormalService boxAbnormalService;
    @Resource
    private BoxApprovalService boxApprovalService;
    @Resource
    private BoxTrailerService boxTrailerService;
    @Resource
    private BoxCabinetService boxCabinetService;
    @Resource
    private BoxCustomsService boxCustomsService;
    @Resource
    private BoxLadingBillService boxLadingBillService;
    @Resource
    private BoxBargeService boxBargeService;
    @Resource
    private BoxShippingService boxShippingService;
    @Resource
    private BoxLadingCopyService boxLadingCopyService;
    @Resource
    private BoxClearanceDocService boxClearanceDocService;
    @Resource
    private BoxArrivalService boxArrivalService;
    @Resource
    private BoxClearanceService boxClearanceService;

    @Resource
    private BoxTakeoffService boxTakeoffService;
    @Resource
    private BoxArrivalAirService boxArrivalAirService;

    @Resource
    private BoxCabinetUnloadService boxCabinetUnloadService;
    @Resource
    private BoxSettlementService boxSettlementService;
    @Resource
    private OrderService orderService;
    @Resource
    private OrderBusinessService orderBusinessService;
    @Resource
    private OrderQueryService orderQueryService;

    @Resource
    private BoxOrderSmsLogService boxOrderSmsLogService;
    @Resource
    private SmsSendApi smsSendApi;
    @Resource
    private TargetLogService targetLogService;
    @Resource
    private BoxLoadInfoService boxLoadInfoService;
    @Resource
    private BoxTallyService boxTallyService;
    @Resource
    private OrderLocationService orderLocationService;
    @Resource
    private WarehouseAreaService warehouseAreaService;
    @Resource
    private WarehouseAreaPositionService warehouseAreaPositionService;
    @Resource
    private BusiPwdService busiPwdService;
    @Resource
    private BoxOrderExitService boxOrderExitService;

    @Resource
    private OrderSplitService orderSplitService;
    @Resource
    private OrderSplitCheckService orderSplitCheckService;

    @Resource
    private OrderSplitItemMapper orderSplitItemMapper;

    @Resource
    private DictDataService dictDataService;

    @Resource
    private OrderExceptionService orderExceptionService;
    @Resource
    private OrderItemService orderItemService;
    @Resource
    private ProductPriceService productPriceService;
    @Resource
    private OrderApprovalService orderApprovalService;
    @Resource
    private OrderSpecialNeedService orderSpecialNeedService;
    @Resource
    private CustomerContactsService customerContactsService;
    @Resource
    private OrderConsigneeService orderConsigneeService;
    @Resource
    private OrderConsignorService orderConsignorService;
    @Resource
    private OrderCargoControlService orderCargoControlService;
    @Resource
    private MemberUserApi memberUserApi;
    @Resource
    private ClientInternalMessageApi clientInternalMessageApi;
    @Resource
    private OrderTimeService orderTimeService;
    @Lazy
    @Resource
    private MakeBillOfLadingService makeBillOfLadingService;

    @Resource
    private BoxAirFlyService boxAirFlyService;

    @Resource
    private BoxBookAirService boxBookAirService;

    @Resource
    private ApplicationContext applicationContext;

    private static final Long NIGERIA = 4174L;

    private static Map<String, Integer> minNumMap = new HashMap<>();

    @Resource
    private ProductAttrService productAttrService;

    @Resource
    private BoxCustomsSplitService boxCustomsSplitService;

    @Resource
    private BoxArrivalOrderService boxArrivalOrderService;
    @Resource
    private BoxClearanceOrderService boxClearanceOrderService;
    @Resource
    ReceivableService receivableService;

    @Resource
    @Lazy
    private BoxMergePkgService boxMergePkgService;

    @Resource
    @Lazy
    private BoxOrderCheckInfoService boxOrderCheckInfoService;

    @Resource
    @Lazy
    private BoxPkgOrderService boxPkgOrderService;

    @Resource
    private ScoreProducerApi scoreProducerApi;

    static {
        String key = "130-4174-1";
        minNumMap.put(key, 3633);
        key = "130-4174-3";
        minNumMap.put(key, 793);
        key = "130-4175";
        minNumMap.put(key, 323);
        key = "130-4191";
        minNumMap.put(key, 24);
        key = "130-4178";
        minNumMap.put(key, 33);
        key = "130-4177";
        minNumMap.put(key, 46);
        key = "130-4176";
        minNumMap.put(key, 64);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Long createBox(BoxCreateReqVO createReqVO) {
        // 插入
        Long startWarehouseId = createReqVO.getStartWarehouseId();
        Long destWarehouseId = createReqVO.getDestWarehouseId();
        String transportType = createReqVO.getTransportType();

        BoxDO box = BoxConvert.INSTANCE.convert(createReqVO);
        String orderNo = "";
        if (StringUtils.equals(TransportTypeEnum.AIR.getType(), transportType)) {
            Long channelId = createReqVO.getShippingChannelId();
            WarehouseDO destWarehouse = warehouseService.getWarehouse(destWarehouseId);
            Long destId = destWarehouse.getShi();
            orderNo = getAirOrderNo(channelId, destId, transportType);
        } else {
            orderNo = getOrderNo(startWarehouseId, destWarehouseId, transportType, box);
        }

        box.setSelfNo(orderNo);
        boxMapper.insert(box);

        BookStatusEnum bookStatusEnum = BookStatusEnum.WAITING_BOOKING;
        //创建操作日志
        boxOpLogService.createBoxOpLog(box.getId(), bookStatusEnum.getBkStatus(), bookStatusEnum.getStatusNameZh(), bookStatusEnum.getStatusNameEn(), null);
        return box.getId();
    }

    private String getAirOrderNo(Long channelId, Long destId, String transportType) {
        BoxAirNumberRecordDO boxAirNumberRecordDO = boxAirNumberRecordService.getBoxAirNumberRecord(Integer.parseInt(transportType), destId, channelId);
        return boxAirNumberRecordDO.getNumber();
    }

    private String chargeChannelAirOrderNo(String selfNo, Long channelId, Long destId, String transportType) {
        BoxAirNumberRecordDO boxAirNumberRecordDO = boxAirNumberRecordService.chargeChannelBoxAirNumberRecord(selfNo, Integer.parseInt(transportType), destId, channelId);
        return boxAirNumberRecordDO.getNumber();
    }

    /**
     * 获取提单模板
     *
     * @return
     */
    private String getOrderNo(Long startWarehouseId, Long destWarehouseId, String transportType, BoxDO boxDO) {
        //1.首先查询出prefix
        WarehouseLineBaseVO vo = new WarehouseLineBaseVO();
        vo.setStartWarehouseId(startWarehouseId);
        vo.setDestWarehouseId(destWarehouseId);
        vo.setTransportType(transportType);
        vo.setStatus(CommonStatusEnum.ENABLE.getStatus());

        //查找线路
        List<WarehouseLineDO> lineDOList = warehouseLineMapper.selectList(vo);
        if (CollectionUtil.isEmpty(lineDOList)) {
            throw exception(LINE_NOT_OPEN);
        }
        WarehouseLineDO warehouseLineDO = lineDOList.get(0);

        //找到提单模板
        LadingTemplateDO ladingTemplateDO = ladingTemplateMapper.selectOne(LadingTemplateDO::getLineId, warehouseLineDO.getId());
        if (ladingTemplateDO == null) {
            throw exception(LADING_TEMPLATE_NOT_SET);
        }
        String prefixCounter = ladingTemplateDO.getPrefixCounter();
        if (StringUtils.isEmpty(prefixCounter)) prefixCounter = "";


        //找到始发和目的国家
        WarehouseDO startWarehouse = warehouseService.getWarehouse(startWarehouseId);
        Long startCountryId = startWarehouse.getGuojia();

        WarehouseDO destWarehouse = warehouseService.getWarehouse(destWarehouseId);
        Long destCountryId = destWarehouse.getGuojia();

        //开始国家是尼日利亚，则根据开始仓库->目的国家来生成序号
        //                   否则根据开始国家->目的国家来生成序号
        //  首先查找这个条件的出货单有没有中断的序号
        Long warehouseId = null;
        Long sCountryId = null;
        String key = "";
        if (destCountryId.equals(NIGERIA)) {
            warehouseId = startWarehouseId;
            key = startCountryId + "-" + destCountryId + "-" + startWarehouseId;
        } else {
            sCountryId = startCountryId;
            key = startCountryId + "-" + destCountryId;
        }
        Integer number;

        Integer minNumber = minNumMap.get(key);
        if (minNumber == null) {
            minNumber = 0;
        }
        List<MissNumberDO> missNumberList = boxMapper.getMissNumber(warehouseId, sCountryId, destCountryId, minNumber);
        if (CollectionUtil.isNotEmpty(missNumberList)) {
            for (MissNumberDO missNumberDO : missNumberList) {
                log.info("缺失数据为:" + missNumberDO.getMissingNumStart() + "-" + missNumberDO.getMissingNumEnd());
            }
            //有缺失的数据,从缺失数据还原
            number = MissNumberDO.getSmallestMissingNumber(missNumberList);
            log.info("最新的缺失数据为:" + number);
        } else {
            //找到是否有删除的，
            Long minNum = boxMapper.getMinNumDeleteBox(warehouseId, sCountryId, destCountryId);
            if (minNum != null) {
                number = minNum.intValue();
                log.info("最小的删除数据为:" + number);
            } else {
                BoxNumberRecordDO numberRecordDO;
                //判断是否是尼日利亚，尼日利亚需要根据始发仓库ID判断
                if (destCountryId.equals(NIGERIA)) {
                    numberRecordDO = boxNumberRecordMapper.selectOne(new LambdaQueryWrapperX<BoxNumberRecordDO>()
                            .eq(BoxNumberRecordDO::getStartWarehouseId, startWarehouseId)
                            .eq(BoxNumberRecordDO::getDestCountryId, destCountryId)
                    );
                } else {
                    numberRecordDO = boxNumberRecordMapper.selectOne(new LambdaQueryWrapperX<BoxNumberRecordDO>()
                            .eq(BoxNumberRecordDO::getStartCountryId, startCountryId)
                            .eq(BoxNumberRecordDO::getDestCountryId, destCountryId)
                    );
                }
                if (numberRecordDO == null) {
                    numberRecordDO = new BoxNumberRecordDO();
                    numberRecordDO.setTransportType(transportType);
                    numberRecordDO.setNum(1);
                    numberRecordDO.setStartCountryId(startCountryId);
                    numberRecordDO.setStartWarehouseId(startWarehouseId);
                    numberRecordDO.setDestCountryId(destCountryId);
                    numberRecordDO.setDestWarehouseId(destWarehouseId);
                    boxNumberRecordMapper.insert(numberRecordDO);
                } else {
                    numberRecordDO.setNum(numberRecordDO.getNum() + 1);
                    boxNumberRecordMapper.updateById(numberRecordDO);
                }
                number = numberRecordDO.getNum();
                log.info("record表number为：" + number);

                //找出库里面最大的
                BoxDO maxBox = getOne(new LambdaQueryWrapperX<BoxDO>()
                        .eq(warehouseId != null, BoxDO::getStartWarehouseId, warehouseId)
                        .eq(sCountryId != null, BoxDO::getStartCountryId, sCountryId)
                        .eq(BoxDO::getDestCountryId, destCountryId)
                        .orderByDesc(BoxDO::getNum)
                        .ne(BoxDO::getNum, 0)
                        .last("limit 1")
                );
                if (maxBox != null) {
                    log.info("BOX最大数为:" + maxBox.getNum());
                    if (maxBox.getNum() < number) {
                        //如果现有自编号比记录里面的小，说明有删除或者改线路
                        number = maxBox.getNum() + 1;
                    }
                }
            }
        }

        boxDO.setStartCountryId(startCountryId);
        boxDO.setDestCountryId(destCountryId);

        boxDO.setNum(number);

        //获取年份
        String year = NumberUtils.getYear2Number();
        DecimalFormat df = new DecimalFormat("0000");
        String numberStr = df.format(number);
        return prefixCounter + year + numberStr;
    }


    @Override
    @Transactional(rollbackFor = Exception.class)
    public void updateBox(BoxUpdateReqVO updateReqVO) {
        // 校验存在
        this.validateBoxExists(updateReqVO.getId());

        BoxDO boxDO = boxMapper.selectById(updateReqVO.getId());

        String transportType = updateReqVO.getTransportType();
        Long channelId = updateReqVO.getShippingChannelId();

        //校验出货是否有订单
        Set<Long> idSet = boxPreloadGoodsService.getShipOrderIdList(boxDO.getId());
        if (CollectionUtil.isNotEmpty(idSet)) {
            throw new ServiceException(500, "已预装了订单，不能修改");
        }
        if (StringUtils.equals(TransportTypeEnum.AIR.getType(), transportType) && (channelId == null || channelId == 0)) {
            throw exception(ORDER_LINE_CHANNEL_NOT_NULL);
        }
        Long oldChannelId = boxDO.getShippingChannelId();
        Long oldStartWarehouseId = boxDO.getStartWarehouseId();
        WarehouseDO oldStartWarehouse = warehouseService.getWarehouse(oldStartWarehouseId);
        WarehouseDO oldDestWarehouse = warehouseService.getWarehouse(boxDO.getDestWarehouseId());
        Long oldStartCountryId = oldStartWarehouse.getGuojia();
        Long oldDestCountryId = oldDestWarehouse.getGuojia();
        Long oldDestId = oldDestWarehouse.getShi();


        Long newStartWarehouseId = updateReqVO.getStartWarehouseId();
        Long destWarehouseId = updateReqVO.getDestWarehouseId();
        WarehouseDO newStartWarehouse = warehouseService.getWarehouse(newStartWarehouseId);
        WarehouseDO newDestWarehouse = warehouseService.getWarehouse(destWarehouseId);
        Long newStartCountryId = newStartWarehouse.getGuojia();
        Long newDestCountryId = newDestWarehouse.getGuojia();
        Long newDestId = newDestWarehouse.getShi();

        // 更新
        BoxDO updateObj = BoxConvert.INSTANCE.convert(updateReqVO);
        if (StringUtils.equals(TransportTypeEnum.AIR.getType(), transportType)) {
            if (!Objects.equals(channelId, oldChannelId) || !Objects.equals(oldDestId, newDestId)) {
                // 当箱子的渠道或者目的变更时，都需要重新生成自编号
                boxAirNumberRecordService.updateBoxAirNumberRecordUsedStatus(boxDO.getSelfNo());
                // 再重新获取自编号
                String selfNo = getAirOrderNo(channelId, newDestId, transportType);
                updateObj.setSelfNo(selfNo);
            }
        } else {
            if (!oldStartCountryId.equals(newStartCountryId) || !oldDestCountryId.equals(newDestCountryId)) {
                String selfNo = getOrderNo(newStartWarehouseId, destWarehouseId, transportType, updateObj);
                updateObj.setSelfNo(selfNo);
            } else {
                if (newDestCountryId.equals(NIGERIA)) {
                    if (!oldStartWarehouseId.equals(newStartWarehouseId)) {
                        String selfNo = getOrderNo(newStartWarehouseId, destWarehouseId, transportType, updateObj);
                        updateObj.setSelfNo(selfNo);
                    }
                }
            }
        }
        boxMapper.updateById(updateObj);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void updateAgent(Long shipmentId, Long agentId) {
        // 校验存在
        this.validateBoxExists(shipmentId);
        BoxAgentDO boxAgentDO = boxAgentService.selectOne("shipment_id", shipmentId);
        if (boxAgentDO == null) {
            boxAgentDO = new BoxAgentDO();
            boxAgentDO.setShipmentId(shipmentId);
        }
        boxAgentDO.setAgentId(agentId);
        boxAgentService.saveOrUpdate(boxAgentDO);
        boxLadingBillService.update(new LambdaUpdateWrapper<BoxLadingBillDO>().set(BoxLadingBillDO::getAgentId, agentId).eq(BoxLadingBillDO::getShipmentId, shipmentId));
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void shipConfigure(Long shipmentId, Integer saExmtStatus, Integer operateType, String configTime) {
        // 校验存在
        BoxDO boxDO = this.validateBoxExists(shipmentId);

        BoxShipConfigDO boxShipConfigDO = boxShipConfigService.selectOne("shipment_id", shipmentId);

        if (boxShipConfigDO == null) {
            boxShipConfigDO = new BoxShipConfigDO();
            boxShipConfigDO.setShipmentId(shipmentId);
        }
        if (configTime != null) {
            SimpleDateFormat sdf = new SimpleDateFormat(DateUtils.FORMAT_YEAR_MONTH_DAY);
            try {
                boxShipConfigDO.setConfigTime(sdf.parse(configTime));
            } catch (ParseException e) {
                e.printStackTrace();
            }
        }
        boxShipConfigDO.setSaExmtStatus(saExmtStatus);
        boxShipConfigService.saveOrUpdate(boxShipConfigDO);

        if (operateType == OperateTypeEnum.COMMIT.getType()) {
            boxDO.setSaStatus(SaStatueEnum.HAS_SHIP.getSaStatus());
        }
        boxMapper.updateById(boxDO);
    }

    @Override
    public void deleteBox(Long id) {
        // 校验存在
        BoxDO boxDO = this.validateBoxExists(id);

        //校验出货单是否已经订舱，如果已经订舱则不能删除
        Integer bkStatus = boxDO.getBkStatus();
        if (bkStatus == BookStatusEnum.BOOKED.getBkStatus()) {
            throw new ServiceException(500, "已订舱，不能删除");
        }
        // 删除前需要将空运自编号记录状态修改为未使用
        boxAirNumberRecordService.updateBoxAirNumberRecordUsedStatus(boxDO.getSelfNo());
        // 删除
        boxMapper.deleteById(id);
    }

    private BoxDO validateBoxExists(Long id) {
        BoxDO boxDO = boxMapper.selectById(id);
        if (boxDO == null) {
            throw exception(BOX_NOT_EXISTS);
        }
        return boxDO;
    }

    public BoxDO getBox(Long id) {
        return boxMapper.selectById(id);
    }

    @Override
    public BoxBaseBackVO getBaseBoxInfo(Long shipmentId) {
        BoxDO boxDO = boxMapper.selectById(shipmentId);
        if (boxDO == null) throw new ServiceException(500, "出货单已被删除");

        BoxBackVO boxBackVO = BoxConvert.INSTANCE.convert(boxDO);

        CabinetDO cabinetDO = cabinetService.getCabinet(boxDO.getCabinetId());
        CabinetRespVO cabinetRespVO = CabinetConvert.INSTANCE.convert(cabinetDO);
        boxBackVO.setCabinetRespVO(cabinetRespVO);

        WarehouseDO startWarehouse = warehouseService.getWarehouse(boxDO.getStartWarehouseId());
        WarehouseRespVO startWarehouseResp = WarehouseConvert.INSTANCE.convert(startWarehouse);

        WarehouseDO destWarehouse = warehouseService.getWarehouse(boxDO.getDestWarehouseId());
        WarehouseRespVO destWarehouseResp = WarehouseConvert.INSTANCE.convert(destWarehouse);

        boxBackVO.setStartWarehouseResp(startWarehouseResp);
        boxBackVO.setDestWarehouseResp(destWarehouseResp);

        if (boxDO.getShippingChannelId() != null) {
            ChannelDO channelDO = channelService.getChannel(boxDO.getShippingChannelId());
            ChannelRespVO channelRespVO = ChannelConvert.INSTANCE.convert(channelDO);
            if (channelRespVO != null) {
                String attrIds = channelRespVO.getAttrId();
                channelRespVO.setAttrNameList(getAttrNameByIdList(attrIds));
            }
            boxBackVO.setChannelRespVO(channelRespVO);
        }

        //统计信息
        BoxGoodsStatistics boxStatistics = boxPreloadGoodsService.getBoxStatistics(shipmentId);
        boxBackVO.setBoxStatistics(boxStatistics);

        String documentInfo = boxPreloadGoodsService.getDocumentInfo(shipmentId);
        boxBackVO.setDocumentInfo(documentInfo);

        if (StringUtils.isNotEmpty(documentInfo)) {
            String[] documentInfoArray = documentInfo.split(",");
            if (documentInfoArray.length == 1) {
                boxBackVO.setDocumentInfoShow(documentInfoArray[0]);
            } else {
                //混合报关
                boxBackVO.setDocumentInfoShow("3");
            }
        }

        //查询反审信息
        Integer backApprovalType = boxApprovalService.getBackApprovalType(boxBackVO.getId());
        boxBackVO.setBackApprovalType(backApprovalType);

        //设置正常报关订单
        boxBackVO.setNormalOrderList(boxPreloadGoodsService.getNormalOrderList(shipmentId));
        return boxBackVO;
    }

    @Override
    public List<String> getAttrNameByIdList(String attrIds) {
        if (StringUtils.isNotBlank(attrIds)) {
            String[] attrIdArray = attrIds.split(",");
            List<Long> attrIdList = new ArrayList<>();
            for (String attrId : attrIdArray) {
                attrIdList.add(Long.valueOf(attrId));
            }
            List<ProductAttrDO> attrDOList = productAttrService.getAttrByIds(attrIdList);
            List<String> attrNameList = attrDOList.stream()
                    .map(ProductAttrDO::getAttrName)
                    .collect(Collectors.toList());
            return attrNameList;
        }
        return null;
    }

    @Override
    public BoxBackVO getBoxDetail(Long id) {
        BoxBaseBackVO boxBaseBackVO = getBaseBoxInfo(id);

        BoxBackVO boxBackVO = new BoxBackVO();
        BeanUtils.copyProperties(boxBaseBackVO, boxBackVO);

        boolean airShipment = boxBaseBackVO.getTransportType().equals(TransportTypeEnum.AIR.getType());

        List<BoxAbnormalDO> abnormalList = getAbnormalList(id);

        //查询正在审核的出货
        BoxApprovalDO existDO = boxApprovalService.selectOne(new LambdaQueryWrapperX<BoxApprovalDO>()
                .eq(BoxApprovalDO::getShipmentId, id)
                .eq(BoxApprovalDO::getApprovalStatus, BpmProcessInstanceResultEnum.PROCESS.getResult())
                .last("limit 1")
        );
        if (existDO != null) {
            boxBackVO.setApprovalType(existDO.getApprovalType());
            boxBackVO.setApprovaling(true);
        }

        //================================空运================================
        if (TransportTypeEnum.AIR.getType().equals(boxBaseBackVO.getTransportType())) {
            //订舱
            BoxBookAirDO boxBookAirDO = boxBookAirService.getOne(new LambdaQueryWrapperX<BoxBookAirDO>()
                    .eq(BoxBookAirDO::getShipmentId, id)
                    .last("limit 1"));

            Date flyTime = null;
            if (boxBookAirDO != null) {
                BoxBookAirBackVO boxBookAirBackVO = BoxBookAirConvert.INSTANCE.convert(boxBookAirDO);
                boxBookAirBackVO.setOperator(getUserName(boxBookAirDO.getCreator()));
                boxBackVO.setBookAirInfo(boxBookAirBackVO);
                flyTime = boxBookAirDO.getFlyTime();
            }

            //分拣信息
            BoxApprovalDO boxApprovalDO = boxApprovalService.getOne(new LambdaQueryWrapperX<BoxApprovalDO>()
                    .eq(BoxApprovalDO::getShipmentId, id)
                    .eq(BoxApprovalDO::getApprovalType, BoxApprovalTypeEnum.AIR_SORTING.getType())
                    .orderByDesc(BoxApprovalDO::getId)
                    .last("limit 1")
            );
            if (boxApprovalDO != null) {
                BoxApprovalBackVO boxApprovalBackVO = BoxApprovalConvert.INSTANCE.convert(boxApprovalDO);
                boxApprovalBackVO.setOperator(getUserName(boxApprovalDO.getCreator()));
                boxBackVO.setPreInstallInfo(boxApprovalBackVO);
            }

            //分拣反审信息
            BoxApprovalDO preInstallBackApprovalDO = boxApprovalService.getOne(new LambdaQueryWrapperX<BoxApprovalDO>()
                    .eq(BoxApprovalDO::getShipmentId, id)
                    .eq(BoxApprovalDO::getApprovalType, BoxApprovalTypeEnum.AIR_SORTING_BACK.getType())
                    .orderByDesc(BoxApprovalDO::getId)
                    .last("limit 1")
            );
            if (preInstallBackApprovalDO != null) {
                boxBackVO.setPreInstallBackInfo(BoxApprovalConvert.INSTANCE.convert(preInstallBackApprovalDO));
            }

            //起飞
            BoxAirFlyDO boxAirFlyDO = boxAirFlyService.getOne(new LambdaQueryWrapperX<BoxAirFlyDO>().
                    eq(BoxAirFlyDO::getShipmentId, id).last(" limit 1"));
            long abnormalCount = abnormalList.stream()
                    .filter(t -> t.getOpStep().equals(AbnormalStepAirEnum.FLYING.getStep()))
                    .count();
            boolean flyingHasAbnormal = abnormalCount > 0;
            boxBackVO.setFlyingHasAbnormal(flyingHasAbnormal);

            if (boxAirFlyDO != null) {
                BoxAirFlyBackVO boxAirFlyBackVO = BoxAirFlyConvert.INSTANCE.convert(boxAirFlyDO);
                boxBackVO.setBoxAirFlyInfo(boxAirFlyBackVO);
                boxAirFlyBackVO.setOperator(getUserName(boxAirFlyDO.getCreator()));
                Date dtRealFlyTime = boxAirFlyDO.getDtRealFlyTime();
                int diff = getDateInterval(dtRealFlyTime, flyTime);
                boxAirFlyBackVO.setDelayDays(diff);
                boolean showAbnormal = getShowAbnormal(diff, "inspection_time_flying");
                boxAirFlyBackVO.setShowAbnormal(showAbnormal && !flyingHasAbnormal);
            }

            BoxMergePkgDO boxMergePkgDO =
                    boxMergePkgService.selectOne(new LambdaQueryWrapperX<BoxMergePkgDO>().
                            eq(BoxMergePkgDO::getShipmentId, id).
                            orderByDesc(BaseDO::getCreateTime).last(" limit 1"));
            if (boxMergePkgDO != null) {
                BoxMergePkgBackVO boxMergePkgBackVO = BoxMergePkgConvert.INSTANCE.convert(boxMergePkgDO);
                boxMergePkgBackVO.setOperator(getUserName(boxMergePkgDO.getCreator()));
                boxBackVO.setBoxMergePkgBackVO(boxMergePkgBackVO);
            }

            //出货
            BoxAirShipmentDO boxAirShipmentDO =
                    boxAirShipmentService.getAirShipmentByShipmentId(id);
            if (boxAirShipmentDO != null) {
                BoxAirShipmentBackVO boxAirShipmentBackVO = BoxAirShipmentConvert.INSTANCE.convert(boxAirShipmentDO);
                boxBackVO.setBoxAirShipmentBackVO(boxAirShipmentBackVO);
                boxAirShipmentBackVO.setOperator(getUserName(boxAirShipmentDO.getCreator()));
            }

            //出货审核
            BoxApprovalDO airShipmentApprovalDO =
                    boxApprovalService.getOne(new LambdaQueryWrapperX<BoxApprovalDO>()
                            .eq(BoxApprovalDO::getShipmentId, id)
                            .eq(BoxApprovalDO::getApprovalType, BoxApprovalTypeEnum.AIR_SHIPMENT.getType())
                            .orderByDesc(BoxApprovalDO::getId)
                            .last("limit 1")
                    );
            if (airShipmentApprovalDO != null) {
                boxBackVO.setAirShipmentApprovalInfo(BoxApprovalConvert.INSTANCE.convert(airShipmentApprovalDO));
            }

            //出货反审
            BoxApprovalDO airShipmentBackApprovalDO =
                    boxApprovalService.getOne(
                            new LambdaQueryWrapperX<BoxApprovalDO>()
                                    .eq(BoxApprovalDO::getShipmentId, id)
                                    .eq(BoxApprovalDO::getApprovalType, BoxApprovalTypeEnum.AIR_SHIPMENT_BACK.getType())
                                    .orderByDesc(BoxApprovalDO::getId)
                                    .last("limit 1")
                    );
            if (airShipmentBackApprovalDO != null) {
                boxBackVO.setAirShipmentBackApprovalInfo(BoxApprovalConvert.INSTANCE.convert(airShipmentBackApprovalDO));
            }

            //出仓
            BoxAirCheckoutDO boxAirCheckoutDO = boxAirCheckoutService.getOne(new LambdaQueryWrapperX<BoxAirCheckoutDO>().eq(BoxAirCheckoutDO::getShipmentId, id).orderByDesc(BoxAirCheckoutDO::getId).last("limit 1"));
            if (boxAirCheckoutDO != null) {
                BoxAirCheckoutBackVO boxAirCheckoutBackVO = BoxAirCheckoutConvert.INSTANCE.convert(boxAirCheckoutDO);
                boxBackVO.setBoxAirCheckoutBackVO(boxAirCheckoutBackVO);
                boxAirCheckoutBackVO.setOperator(getUserName(boxAirCheckoutDO.getCreator()));
                boxBackVO.setRealNum(boxAirCheckoutDO.getRealNum());
            }

            boxBackVO.setPlanNum(getPlanNum(id));
            boxBackVO.setRealNum(getRealNum(id));

            //删单退场
            BoxApprovalDO deleteExitApproval =
                    boxApprovalService.getOne(
                            new LambdaQueryWrapperX<BoxApprovalDO>()
                                    .eq(BoxApprovalDO::getShipmentId, id)
                                    .eq(BoxApprovalDO::getApprovalType, BoxApprovalTypeEnum.DELETE_EXIT.getType())
                                    .orderByDesc(BoxApprovalDO::getId)
                                    .last("limit 1")
                    );
            if (deleteExitApproval != null) {
                boxBackVO.setCustomsDeleteExitApprovalInfo(BoxApprovalConvert.INSTANCE.convert(deleteExitApproval));
            }

            //到港
            // 修改有多条记录是报错的BUG
            BoxArrivalAirDO boxArrivalAirDO =
                    boxArrivalAirService.getOne(
                            new LambdaQueryWrapper<BoxArrivalAirDO>()
                                    .eq(BoxArrivalAirDO::getShipmentId, id)
                                    .orderByDesc(BoxArrivalAirDO::getId)
                                    .last("limit 1")
                    );

            abnormalCount = abnormalList.stream()
                    .filter(t -> t.getOpStep().equals(AbnormalStepAirEnum.ARRIVAL.getStep()))
                    .count();
            boolean arrivalHasAbnormal = abnormalCount > 0;
            boxBackVO.setArrivalHasAbnormal(arrivalHasAbnormal);
            if (boxArrivalAirDO != null) {
                BoxArrivalAirBackVO boxArrivalAirBackVO = BoxArrivalAirConvert.INSTANCE.convert(boxArrivalAirDO);
                boxArrivalAirBackVO.setOperator(getUserName(boxArrivalAirDO.getCreator()));

                //查询到港订单
                List<BoxArrivalOrderDO> arrivalOrderDOList = boxArrivalOrderService.list(new LambdaQueryWrapper<BoxArrivalOrderDO>()
                        .eq(BoxArrivalOrderDO::getShipmentId, id)
                );
                boxArrivalAirBackVO.setArrivalOrderList(BoxArrivalOrderConvert.INSTANCE.convertList(arrivalOrderDOList));

                boxBackVO.setAirArrivalInfo(boxArrivalAirBackVO);

                //异常
                boxArrivalAirBackVO.setOperator(getUserName(boxArrivalAirDO.getCreator()));
                Date actTime = boxArrivalAirDO.getActTime();
                Date estTime = boxArrivalAirDO.getEstTime();

                int diff = getDateInterval(actTime, estTime);
                boxArrivalAirBackVO.setDelayDays(diff);

                boolean showAbnormal = getShowAbnormal(diff, "inspection_time_arrival");
                boxArrivalAirBackVO.setShowAbnormal(showAbnormal && !arrivalHasAbnormal);
            }

            //批量加价审核查询
            BoxApprovalDO batchAddPriceApproval = boxApprovalService.getOne(new LambdaQueryWrapperX<BoxApprovalDO>()
                    .eq(BoxApprovalDO::getShipmentId, id)
                    .eq(BoxApprovalDO::getApprovalType, BoxApprovalTypeEnum.BATCH_ADD_PRICE.getType())
                    .orderByDesc(BoxApprovalDO::getId)
                    .last("limit 1")
            );
            if (batchAddPriceApproval != null) {
                boxBackVO.setBatchAddPriceApprovalInfo(BoxApprovalConvert.INSTANCE.convert(batchAddPriceApproval));
            }

            //到仓审核信息
            BoxApprovalDO unloadBoxApprovalDO = boxApprovalService.getOne(new LambdaQueryWrapperX<BoxApprovalDO>()
                    .eq(BoxApprovalDO::getShipmentId, id)
                    .eq(BoxApprovalDO::getApprovalType, BoxApprovalTypeEnum.AIR_TO_WAREHOUSE.getType())
                    .orderByDesc(BoxApprovalDO::getId)
                    .last("limit 1")
            );
            if (unloadBoxApprovalDO != null) {
                boxBackVO.setCabinetUnloadApprovalInfo(BoxApprovalConvert.INSTANCE.convert(unloadBoxApprovalDO));
            }
            //到仓反审核信息
            BoxApprovalDO unloadBoxBackApprovalDO = boxApprovalService.getOne(new LambdaQueryWrapperX<BoxApprovalDO>()
                    .eq(BoxApprovalDO::getShipmentId, id)
                    .eq(BoxApprovalDO::getApprovalType, BoxApprovalTypeEnum.AIR_TO_WAREHOUSE_BACK.getType())
                    .orderByDesc(BoxApprovalDO::getId)
                    .last("limit 1")
            );
            if (unloadBoxBackApprovalDO != null) {
                boxBackVO.setCabinetUnloadBackApprovalInfo(BoxApprovalConvert.INSTANCE.convert(unloadBoxBackApprovalDO));
            }
        }
        //=================================海运================================
        else {
            //1.查询订舱详情
            BoxBookSeaDO boxBookSeaDO = boxBookSeaService.getOne(new LambdaQueryWrapperX<BoxBookSeaDO>()
                    .eq(BoxBookSeaDO::getShipmentId, id)
                    .last("limit 1")
            );
            Date sailTime = null;
            if (boxBookSeaDO != null) {
                sailTime = boxBookSeaDO.getSailTime();
                BoxBookSeaBackVO boxBookSeaBackVO = BoxBookSeaConvert.INSTANCE.convert(boxBookSeaDO);
                boxBookSeaBackVO.setOperator(getUserName(boxBookSeaDO.getCreator()));
                boxBackVO.setBookSeaInfo(boxBookSeaBackVO);
            }

            //2.查询预装
            BoxApprovalDO boxApprovalDO = boxApprovalService.getOne(new LambdaQueryWrapperX<BoxApprovalDO>()
                    .eq(BoxApprovalDO::getShipmentId, id)
                    .eq(BoxApprovalDO::getApprovalType, BoxApprovalTypeEnum.PRELOAD.getType())
                    .orderByDesc(BoxApprovalDO::getId)
                    .last("limit 1")
            );
            if (boxApprovalDO != null) {
                BoxApprovalBackVO boxApprovalBackVO = BoxApprovalConvert.INSTANCE.convert(boxApprovalDO);
                boxApprovalBackVO.setOperator(getUserName(boxApprovalDO.getCreator()));
                boxBackVO.setPreInstallInfo(boxApprovalBackVO);
            }

            //2.1预装反审信息
            BoxApprovalDO preInstallBackApprovalDO = boxApprovalService.getOne(new LambdaQueryWrapperX<BoxApprovalDO>()
                    .eq(BoxApprovalDO::getShipmentId, id)
                    .eq(BoxApprovalDO::getApprovalType, BoxApprovalTypeEnum.PRELOAD_UMPIRE.getType())
                    .orderByDesc(BoxApprovalDO::getId)
                    .last("limit 1")
            );
            if (preInstallBackApprovalDO != null) {
                boxBackVO.setPreInstallBackInfo(BoxApprovalConvert.INSTANCE.convert(preInstallBackApprovalDO));
            }

            //3.查询拖车
            BoxTrailerDO boxTrailerDO = boxTrailerService.getOne(new LambdaQueryWrapperX<BoxTrailerDO>()
                    .eq(BoxTrailerDO::getShipmentId, id)
                    .last("limit 1")
            );
            if (boxTrailerDO != null) {
                BoxTrailerBackVO boxTrailerBackVO = BoxTrailerConvert.INSTANCE.convert(boxTrailerDO);
                boxTrailerBackVO.setOperator(getUserName(boxTrailerDO.getCreator()));
                boxBackVO.setTrailerInfo(boxTrailerBackVO);
            }

            //5.查询装柜
            BoxCabinetDO boxCabinetDO = getBoxCabinetDO(id);

            if (boxCabinetDO != null) {
                BoxCabinetBackVO boxCabinetBackVO = BoxCabinetConvert.INSTANCE.convert(boxCabinetDO);
                boxCabinetBackVO.setOperator(getUserName(boxCabinetDO.getCreator()));
                boxBackVO.setCabinetInfo(boxCabinetBackVO);
            }

            //5.1装柜审核信息
            BoxApprovalDO cabinetBoxApprovalDO = boxApprovalService.getOne(new LambdaQueryWrapperX<BoxApprovalDO>()
                    .eq(BoxApprovalDO::getShipmentId, id)
                    .eq(BoxApprovalDO::getApprovalType, BoxApprovalTypeEnum.SEALING_CABINET.getType())
                    .orderByDesc(BoxApprovalDO::getId)
                    .last("limit 1")
            );
            if (cabinetBoxApprovalDO != null) {
                boxBackVO.setCabinetApprovalInfo(BoxApprovalConvert.INSTANCE.convert(cabinetBoxApprovalDO));
            }

            //5.2预装反审信息
            BoxApprovalDO cabinetBackApprovalDO = boxApprovalService.getOne(new LambdaQueryWrapperX<BoxApprovalDO>()
                    .eq(BoxApprovalDO::getShipmentId, id)
                    .eq(BoxApprovalDO::getApprovalType, BoxApprovalTypeEnum.SEALING_CABINET_UMPIRE.getType())
                    .orderByDesc(BoxApprovalDO::getId)
                    .last("limit 1")
            );
            if (cabinetBackApprovalDO != null) {
                boxBackVO.setCabinetBackInfo(BoxApprovalConvert.INSTANCE.convert(cabinetBackApprovalDO));
            }

            //5.2装柜拆单审核信息
            BoxApprovalDO cabinetSplitApproval = boxApprovalService.getOne(new LambdaQueryWrapperX<BoxApprovalDO>()
                    .eq(BoxApprovalDO::getShipmentId, id)
                    .eq(BoxApprovalDO::getApprovalType, BoxApprovalTypeEnum.SPLIT_ORDER.getType())
                    .orderByDesc(BoxApprovalDO::getId)
                    .last("limit 1")
            );
            if (cabinetSplitApproval != null) {
                boxBackVO.setCabinetSplitInfo(BoxApprovalConvert.INSTANCE.convert(cabinetSplitApproval));
            }

            //7.查询配船
            BoxShipConfigDO boxShipConfigDO = boxShipConfigService.getOne(new LambdaQueryWrapperX<BoxShipConfigDO>()
                    .eq(BoxShipConfigDO::getShipmentId, id)
                    .last("limit 1")
            );
            if (boxShipConfigDO != null) {
                BoxShipConfigBackVO boxShipConfigBackVO = BoxShipConfigConvert.INSTANCE.convert(boxShipConfigDO);
                boxShipConfigBackVO.setOperator(getUserName(boxShipConfigDO.getCreator()));
                boxBackVO.setShipConfigInfo(boxShipConfigBackVO);
            }

            //9.查询驳船
            BoxBargeDO boxBargeDO = boxBargeService.getOne(new LambdaQueryWrapperX<BoxBargeDO>()
                    .eq(BoxBargeDO::getShipmentId, id)
                    .last("limit 1")
            );
            if (boxBargeDO != null) {
                BoxBargeBackVO boxBargeBackVO = BoxBargeConvert.INSTANCE.convert(boxBargeDO);
                boxBargeBackVO.setOperator(getUserName(boxBargeDO.getCreator()));
                boxBackVO.setBargeInfo(boxBargeBackVO);
            }

            //10.查询起运
            BoxShippingDO boxShippingDO = boxShippingService.getOne(new LambdaQueryWrapperX<BoxShippingDO>()
                    .eq(BoxShippingDO::getShipmentId, id)
                    .last("limit 1")
            );

            Date dtEstArrivalTime = null;
            long abnormalCount = abnormalList.stream()
                    .filter(t -> t.getOpStep().equals(AbnormalStepEnum.SHIPPING.getStep()))
                    .count();
            boolean shippingHasAbnormal = abnormalCount > 0;
            boxBackVO.setShippingHasAbnormal(shippingHasAbnormal);

            if (boxShippingDO != null) {
                dtEstArrivalTime = boxShippingDO.getDtEstArrivalTime();

                BoxShippingBackVO boxShippingBackVO = BoxShippingConvert.INSTANCE.convert(boxShippingDO);
                boxShippingBackVO.setOperator(getUserName(boxShippingDO.getCreator()));

                Date dtRealShipTime = boxShippingDO.getDtRealShipTime();
                int diff = getDateInterval(dtRealShipTime, sailTime);
                boxShippingBackVO.setDelayDays(diff);
                boolean showAbnormal = getShowAbnormal(diff, "inspection_time_shipping");

                boxShippingBackVO.setShowAbnormal(showAbnormal && !shippingHasAbnormal);
                boxBackVO.setShippingInfo(boxShippingBackVO);
            }

            //11.查询提单COPY
            BoxLadingCopyDO boxLadingCopyDO = boxLadingCopyService.getOne(new LambdaQueryWrapperX<BoxLadingCopyDO>()
                    .eq(BoxLadingCopyDO::getShipmentId, id)
                    .last("limit 1")
            );
            if (boxLadingCopyDO != null) {
                BoxLadingCopyBackVO boxLadingCopyBackVO = BoxLadingCopyConvert.INSTANCE.convert(boxLadingCopyDO);
                boxLadingCopyBackVO.setOperator(getUserName(boxLadingCopyDO.getCreator()));
                boxBackVO.setLadingCopyInfo(boxLadingCopyBackVO);
            }

            //13.查询到港
            BoxArrivalDO boxArrivalDO = boxArrivalService.getOne(new LambdaQueryWrapperX<BoxArrivalDO>()
                    .eq(BoxArrivalDO::getShipmentId, id)
                    .last("limit 1")
            );
            abnormalCount = abnormalList.stream()
                    .filter(t -> t.getOpStep().equals(AbnormalStepEnum.ARRIVAL.getStep()))
                    .count();
            boolean arrivalHasAbnormal = abnormalCount > 0;
            boxBackVO.setArrivalHasAbnormal(arrivalHasAbnormal);

            if (boxArrivalDO != null) {
                BoxArrivalBackVO boxArrivalBackVO = BoxArrivalConvert.INSTANCE.convert(boxArrivalDO);
                boxArrivalBackVO.setOperator(getUserName(boxArrivalDO.getCreator()));
                Date apRealTime = boxArrivalDO.getApRealTime();


                int diff = getDateInterval(apRealTime, dtEstArrivalTime);
                boxArrivalBackVO.setDelayDays(diff);

                boolean showAbnormal = getShowAbnormal(diff, "inspection_time_arrival");
                boxArrivalBackVO.setShowAbnormal(showAbnormal && !arrivalHasAbnormal);
                boxBackVO.setArrivalInfo(boxArrivalBackVO);
            }

            //15.1卸柜审核信息
            BoxApprovalDO unloadBoxApprovalDO = boxApprovalService.getOne(new LambdaQueryWrapperX<BoxApprovalDO>()
                    .eq(BoxApprovalDO::getShipmentId, id)
                    .eq(BoxApprovalDO::getApprovalType, BoxApprovalTypeEnum.UNLOAD_CABINET.getType())
                    .orderByDesc(BoxApprovalDO::getId)
                    .last("limit 1")
            );
            if (unloadBoxApprovalDO != null) {
                boxBackVO.setCabinetUnloadApprovalInfo(BoxApprovalConvert.INSTANCE.convert(unloadBoxApprovalDO));
            }
            //15.6卸柜反审核信息
            BoxApprovalDO unloadBoxBackApprovalDO = boxApprovalService.getOne(new LambdaQueryWrapperX<BoxApprovalDO>()
                    .eq(BoxApprovalDO::getShipmentId, id)
                    .eq(BoxApprovalDO::getApprovalType, BoxApprovalTypeEnum.UNLOAD_UMPIRE.getType())
                    .orderByDesc(BoxApprovalDO::getId)
                    .last("limit 1")
            );
            if (unloadBoxBackApprovalDO != null) {
                boxBackVO.setCabinetUnloadBackApprovalInfo(BoxApprovalConvert.INSTANCE.convert(unloadBoxBackApprovalDO));
            }
        }


        //理货
        if (boxBackVO.getTyTime() != null) {
            BoxTallyVO boxTallyVO = new BoxTallyVO();
            String tyOperator = boxBackVO.getTyOperator();
            if (StringUtils.isEmpty(tyOperator)) {
                //bug导致没保存，从订单理货表取
                BoxTallyDO boxTallyDO = boxTallyService.getOne(new LambdaQueryWrapperX<BoxTallyDO>()
                        .eq(BoxTallyDO::getShipmentId, id)
                        .last("limit 1")
                );
                if (boxTallyDO != null) {
                    tyOperator = getUserName(boxTallyDO.getCreator());
                }
            }
            boxTallyVO.setTyOperator(tyOperator);
            boxTallyVO.setOperator(tyOperator);
            boxTallyVO.setTyTime(boxBackVO.getTyTime());
            boxBackVO.setTallyInfo(boxTallyVO);
        }


        //4.查询agent
        BoxAgentDO boxAgentDO = boxAgentService.getOne(new LambdaQueryWrapperX<BoxAgentDO>()
                .eq(BoxAgentDO::getShipmentId, id)
                .last("limit 1")
        );
        if (boxAgentDO != null) {
            BoxAgentBackVO boxAgentBackVO = BoxAgentConvert.INSTANCE.convert(boxAgentDO);
            boxAgentBackVO.setOperator(getUserName(boxAgentDO.getCreator()));
            boxBackVO.setAgentInfo(boxAgentBackVO);
        }

        //部分退场拆单审核信息
        BoxApprovalDO partRefundSplitApproval = boxApprovalService.getOne(new LambdaQueryWrapperX<BoxApprovalDO>()
                .eq(BoxApprovalDO::getShipmentId, id)
                .eq(BoxApprovalDO::getApprovalType, BoxApprovalTypeEnum.PART_REFUND_SPLIT_ORDER.getType())
                .orderByDesc(BoxApprovalDO::getId)
                .last("limit 1")
        );
        if (partRefundSplitApproval != null) {
            boxBackVO.setCabinetSplitInfo(BoxApprovalConvert.INSTANCE.convert(partRefundSplitApproval));
        }

        //6.查询报关
        BoxCustomsDO boxCustomsDO = boxCustomsService.getOne(new LambdaQueryWrapperX<BoxCustomsDO>()
                .eq(BoxCustomsDO::getShipmentId, id)
                .last("limit 1")
        );
        int opStep = AbnormalStepEnum.CUSTOMS.getStep();
        if (airShipment) {
            opStep = AbnormalStepAirEnum.CUSTOMS.getStep();
        }
        int finalOpStep = opStep;
        long abnormalCount = abnormalList.stream()
                .filter(t -> t.getOpStep() == finalOpStep)
                .count();
        boolean customsHasAbnormal = abnormalCount > 0;
        boxBackVO.setCustomsHasAbnormal(customsHasAbnormal);
        if (boxCustomsDO != null) {
            BoxCustomsBackVO boxCustomsBackVO = BoxCustomsConvert.INSTANCE.convert(boxCustomsDO);
            boxCustomsBackVO.setOperator(getUserName(boxCustomsDO.getCreator()));

            //放行时间
            Date dcPassTime = boxCustomsDO.getDcPassTime();
            //报关时间
            Date dcDecTime = boxCustomsDO.getDcDecTime();
            int diff = getDateInterval(dcPassTime, dcDecTime);
            boxCustomsBackVO.setDelayDays(diff);

            boolean showAbnormal = getShowAbnormal(diff, "inspection_time_customs");
            boxCustomsBackVO.setShowAbnormal(showAbnormal && !customsHasAbnormal);

            boxBackVO.setCustomsInfo(boxCustomsBackVO);

            int approvalType = 0;
            if (boxCustomsDO.getDcCheckStatus() == 1) {
                approvalType = BoxApprovalTypeEnum.CUSTOMS_FULL_REFUND.getType();
            } else if (boxCustomsDO.getDcCheckStatus() == 2) {
                approvalType = BoxApprovalTypeEnum.CUSTOMS_PART_REFUND.getType();
            }
            if (approvalType != 0) {
                BoxApprovalDO customsApprovalDO = boxApprovalService.getOne(new LambdaQueryWrapperX<BoxApprovalDO>()
                        .eq(BoxApprovalDO::getShipmentId, id)
                        .eq(BoxApprovalDO::getApprovalType, approvalType)
                        .orderByDesc(BoxApprovalDO::getId)
                        .last("limit 1")
                );
                if (customsApprovalDO != null) {
                    boxBackVO.setCustomsApprovalInfo(BoxApprovalConvert.INSTANCE.convert(customsApprovalDO));
                }
            }

        }

        //8.查询提单补料
        BoxLadingBillDO boxLadingBillDO = boxLadingBillService.getOne(new LambdaQueryWrapperX<BoxLadingBillDO>()
                .eq(BoxLadingBillDO::getShipmentId, id)
                .last("limit 1")
        );
        if (boxLadingBillDO != null) {
            BoxLadingBillBackVO boxLadingBillBackVO = BoxLadingBillConvert.INSTANCE.convert(boxLadingBillDO);
            boxLadingBillBackVO.setOperator(getUserName(boxLadingBillDO.getCreator()));
            boxBackVO.setLadingBillInfo(boxLadingBillBackVO);
        }

        //12.查询清关文件
        BoxClearanceDocDO boxClearanceDocDO = boxClearanceDocService.getOne(new LambdaQueryWrapperX<BoxClearanceDocDO>()
                .eq(BoxClearanceDocDO::getShipmentId, id)
                .last("limit 1")
        );
        if (boxClearanceDocDO != null) {
            BoxClearanceDocBackVO boxClearanceDocBackVO = BoxClearanceDocConvert.INSTANCE.convert(boxClearanceDocDO);
            boxClearanceDocBackVO.setOperator(getUserName(boxClearanceDocDO.getCreator()));
            boxBackVO.setClearanceDocInfo(boxClearanceDocBackVO);
        }

        //14.查询清关
        BoxClearanceDO boxClearanceDO = boxClearanceService.getOne(new LambdaQueryWrapperX<BoxClearanceDO>()
                .eq(BoxClearanceDO::getShipmentId, id)
                .last("limit 1")
        );
        if (boxClearanceDO != null) {
            BoxClearanceBackVO boxClearanceBackVO = BoxClearanceConvert.INSTANCE.convert(boxClearanceDO);
            boxClearanceBackVO.setOperator(getUserName(boxClearanceDO.getCreator()));
            boxBackVO.setClearanceInfo(boxClearanceBackVO);

            //查询清关订单
            List<BoxClearanceOrderDO> arrivalOrderDOList = boxClearanceOrderService.list(new LambdaQueryWrapper<BoxClearanceOrderDO>()
                    .eq(BoxClearanceOrderDO::getShipmentId, id)
            );
            boxClearanceBackVO.setClearanceOrderList(BoxClearanceOrderConvert.INSTANCE.convertList(arrivalOrderDOList));

            List<BoxApprovalDO> approvalDOList = boxApprovalService.list(new LambdaQueryWrapper<BoxApprovalDO>()
                    .eq(BoxApprovalDO::getShipmentId, id)
                    .eq(BoxApprovalDO::getApprovalType, BoxApprovalTypeEnum.CLEARANCE_BACK.getType())
            );
            Map<Long, List<BoxApprovalDO>> approvalMap = approvalDOList.stream().collect(Collectors.groupingBy(BoxApprovalDO::getOrderId));
            List<BoxApprovalDO> backList = new ArrayList<>();
            for (Map.Entry<Long, List<BoxApprovalDO>> entry : approvalMap.entrySet()) {
                List<BoxApprovalDO> resultList = entry.getValue();
                resultList.sort(new Comparator<BoxApprovalDO>() {
                    @Override
                    public int compare(BoxApprovalDO o1, BoxApprovalDO o2) {
                        return o2.getCreateTime().compareTo(o1.getCreateTime());
                    }
                });
                backList.add(resultList.get(0));
            }
            boxClearanceBackVO.setClearanceOrderBackList(BoxApprovalConvert.INSTANCE.convertList(backList));
        }

        //如果是海空联运
        if (boxBackVO.getTransportType().equals(TransportTypeEnum.SEA_AIR.getType())) {
            //查询二程起飞
            BoxTakeoffDO boxTakeoffDO = boxTakeoffService.getOne(new LambdaQueryWrapper<BoxTakeoffDO>()
                    .eq(BoxTakeoffDO::getShipmentId, id)
            );
            if (boxTakeoffDO != null) {
                BoxTakeoffBackVO boxTakeoffBackVO = BoxTakeoffConvert.INSTANCE.convert(boxTakeoffDO);
                boxTakeoffBackVO.setOperator(getUserName(boxTakeoffDO.getCreator()));
                boxBackVO.setTakeOffInfo(boxTakeoffBackVO);
            }

            //查询二程到港
            BoxArrivalAirDO boxArrivalAirDO = boxArrivalAirService.getOne(new LambdaQueryWrapper<BoxArrivalAirDO>()
                    .eq(BoxArrivalAirDO::getShipmentId, id)
            );
            if (boxArrivalAirDO != null) {
                BoxArrivalAirBackVO boxArrivalAirBackVO = BoxArrivalAirConvert.INSTANCE.convert(boxArrivalAirDO);
                boxArrivalAirBackVO.setOperator(getUserName(boxArrivalAirDO.getCreator()));
                boxBackVO.setAirArrivalInfo(boxArrivalAirBackVO);
            }

        }

        //15.查询卸柜
        BoxCabinetUnloadDO boxCabinetUnloadDO = boxCabinetUnloadService.getOne(new LambdaQueryWrapperX<BoxCabinetUnloadDO>()
                .eq(BoxCabinetUnloadDO::getShipmentId, id)
                .last("limit 1")
        );
        if (boxCabinetUnloadDO != null) {
            BoxCabinetUnloadBackVO boxCabinetUnloadBackVO = BoxCabinetUnloadConvert.INSTANCE.convert(boxCabinetUnloadDO);
            boxCabinetUnloadBackVO.setOperator(getUserName(boxCabinetUnloadDO.getCreator()));
            boxBackVO.setCabinetUnloadInfo(boxCabinetUnloadBackVO);
        }

        //16.查询结算
        BoxSettlementDO boxSettlementDO = boxSettlementService.getOne(new LambdaQueryWrapperX<BoxSettlementDO>()
                .eq(BoxSettlementDO::getShipmentId, id)
                .last("limit 1")
        );
        if (boxSettlementDO != null) {
            BoxSettlementBackVO boxSettlementBackVO = BoxSettlementConvert.INSTANCE.convert(boxSettlementDO);
            boxSettlementBackVO.setOperator(getUserName(boxSettlementDO.getCreator()));
            boxBackVO.setSettlementInfo(boxSettlementBackVO);
        }
        return boxBackVO;
    }

    /*
     获取计划数
     */
    public Integer getPlanNum(Long id) {
        int planNum = 0;
        //ecw_box_merge_pkg 合包箱表
        List<BoxMergePkgDO> boxMergePkgDOS =
                boxMergePkgService.selectList(BoxMergePkgDO::getShipmentId, id);
        //预装货物  ecw_box_preload_goods
        List<BoxPreloadGoodsDO> boxPreloadGoodsDOS =
                boxPreloadGoodsService.selectList(
                        new LambdaQueryWrapperX<BoxPreloadGoodsDO>().eq(BoxPreloadGoodsDO::getShipmentId, id).eq(BoxPreloadGoodsDO::getIsRemove, 0));

        List<Long> preloadOrderIds =
                boxPreloadGoodsDOS.stream().map(BoxPreloadGoodsDO::getOrderId).distinct().collect(Collectors.toList());

        if (CollectionUtil.isNotEmpty(boxMergePkgDOS)) {
            List<Long> pkgIds = boxMergePkgDOS.stream().
                    map(BoxMergePkgDO::getId).collect(Collectors.toList());

            List<BoxPkgOrderDO> boxPkgOrderDOS =
                    boxPkgOrderService.selectList(BoxPkgOrderDO::getPkgId, pkgIds);

            if (CollectionUtil.isNotEmpty(boxPkgOrderDOS)) {
                List<Long> pkgOrderIds =
                        boxPkgOrderDOS.stream().map(BoxPkgOrderDO::getOrderId).collect(Collectors.toList());
                preloadOrderIds.removeAll(pkgOrderIds);
            }
            planNum = planNum + boxMergePkgDOS.size();
        }
        if (CollectionUtil.isNotEmpty(preloadOrderIds)) {
            List<OrderDO> orderDOS =
                    orderService.selectList(OrderDO::getOrderId, preloadOrderIds);
            planNum = planNum + orderDOS.stream().mapToInt(OrderDO::getSumNum).sum();
        }
        return planNum;
    }

    private Integer getDateInterval(Date endDate, Date startDate) {
        if (endDate != null && startDate != null) {
            long diffInMillis = Math.abs(endDate.getTime() - startDate.getTime());
//            long diff = TimeUnit.DAYS.convert(diffInMillis, TimeUnit.MILLISECONDS);
            long yu = diffInMillis % (1000 * 60 * 60 * 24);
            int diff = (int) (diffInMillis / (1000 * 60 * 60 * 24));
            if (yu != 0) {
                diff += 1;
            }
            return diff;
        }
        return 0;
    }

    private boolean getShowAbnormal(long diff, String type) {
        DictDataRespDTO data = DictFrameworkUtils.parseDictDataFromCache(type, "数据值");
        long defineDay = Long.parseLong(data.getValue());
        return diff >= defineDay;
    }

    private String getUserName(String userId) {
        if (StringUtils.isEmpty(userId)) {
            return null;
        }
        return adminUserApi.getUser(Long.valueOf(userId)).getNickname();
    }

    @Override
    public List<BoxDO> getBoxList(Collection<Long> ids) {
        return boxMapper.selectBatchIds(ids);
    }

    @Override
    public PageResult<BoxBackVO> getBoxPage(BoxQueryVO query, PageVO page) {
        Long countryId = query.getCountryId();
        String format = "yyyy-MM-dd HH:mm:ss";
        String[] timeRange = query.getDateRangeCreateTime();
        if (timeRange != null) {
            String beginDate = timeRange[0];
            String endDate = timeRange[1];
            if (query.getDateType() == null) {
                query.setBeginYzDate(DateUtil.parse(beginDate, format));
                query.setEndYzDate(DateUtil.parse(endDate, format));
                query.setBeginZgDate(DateUtil.parse(beginDate, format));
                query.setEndZgDate(DateUtil.parse(endDate, format));
                query.setBeginQyDate(DateUtil.parse(beginDate, format));
                query.setEndQyDate(DateUtil.parse(endDate, format));
                query.setBeginDgDate(DateUtil.parse(beginDate, format));
                query.setEndDgDate(DateUtil.parse(endDate, format));
                query.setBeginQgDate(DateUtil.parse(beginDate, format));
                query.setEndQgDate(DateUtil.parse(endDate, format));
                query.setBeginCkDate(DateUtil.parse(beginDate, format));
                query.setEndCkDate(DateUtil.parse(endDate, format));
                query.setBeginThDate(DateUtil.parse(beginDate, format));
                query.setEndThDate(DateUtil.parse(endDate, format));
            } else {
                if (query.getDateType() == 1) {
                    query.setBeginYzDate(DateUtil.parse(beginDate, format));
                    query.setEndYzDate(DateUtil.parse(endDate, format));
                } else if (query.getDateType() == 2) {
                    query.setBeginZgDate(DateUtil.parse(beginDate, format));
                    query.setEndZgDate(DateUtil.parse(endDate, format));
                } else if (query.getDateType() == 3) {
                    query.setBeginQyDate(DateUtil.parse(beginDate, format));
                    query.setEndQyDate(DateUtil.parse(endDate, format));
                } else if (query.getDateType() == 4) {
                    query.setBeginDgDate(DateUtil.parse(beginDate, format));
                    query.setEndDgDate(DateUtil.parse(endDate, format));
                } else if (query.getDateType() == 5) {
                    query.setBeginQgDate(DateUtil.parse(beginDate, format));
                    query.setEndQgDate(DateUtil.parse(endDate, format));
                } else if (query.getDateType() == 6) {
                    //卸柜
                    query.setBeginThDate(DateUtil.parse(beginDate, format));
                    query.setEndThDate(DateUtil.parse(endDate, format));
                } else if (query.getDateType() == 7) {
                    //出仓
                    query.setBeginCkDate(DateUtil.parse(beginDate, format));
                    query.setEndCkDate(DateUtil.parse(endDate, format));
                }
            }
        }

        List<Long> warehouseIdList;
        if (countryId != null) {
            List<WarehouseDO> warehouseList =
                    warehouseService.findByCountryIdList(Collections.singletonList(countryId));
            warehouseIdList = warehouseList.stream().map(WarehouseDO::getId).collect(Collectors.toList());
            query.setWarehouseIdList(warehouseIdList);
        }

        if (CollectionUtil.isNotEmpty(query.getCountryIdList()) || CollectionUtil.isNotEmpty(query.getDestCityIdList())) {
            List<WarehouseDO> warehouseList =
                    warehouseService.findByCountryIdListAndCityIdList(query.getCountryIdList(), query.getDestCityIdList());
            if (CollectionUtil.isNotEmpty(warehouseList)){
                warehouseIdList = warehouseList.stream().map(WarehouseDO::getId).collect(Collectors.toList());
                Set<Long> destWarehouseIdSet = new HashSet<>();
                if (CollectionUtil.isNotEmpty(query.getDestWarehouseIdList())) {
                    destWarehouseIdSet.addAll(query.getDestWarehouseIdList());
                }
                destWarehouseIdSet.addAll(warehouseIdList);
                query.setDestWarehouseIdList(new ArrayList<>(destWarehouseIdSet));
            }
        }
        //上面都是处理查询条件相关逻辑
        return boxInfoQuery1(boxMapper.selectPage2(page, query), false);
    }

    @Override
    public List<BoxDO> getBoxList(BoxQueryVO query) {
        return boxMapper.selectList(query);
    }


    @Override
    public void sendSms(Long shipmentId, SmsNodeEnum smsNodeEnum) {
//        log.info("出货单【{}】, 暂停出货短信通知发送", shipmentId);
//        if (Boolean.TRUE){
//            return;
//        }
        Set<Long> orderIdList = boxPreloadGoodsService.getShipOrderIdList(shipmentId);
        //订单不存在
        if (CollectionUtil.isEmpty(orderIdList)) {
            log.error("出货单【{}】, 未找到订单，发送短信失败", shipmentId);
            return;
        }
        log.info("出货单【{}】, {}短信发送", shipmentId, smsNodeEnum.getDescription());
        sendSms(shipmentId, orderIdList, smsNodeEnum);
    }

    @Override
    public void sendSms(Long shipmentId, Collection<Long> orderIdList, SmsNodeEnum smsNodeEnum) {

        // 对订单列表进行分组, 统计通知发送人的订单数量，当通知人的订单数量大于1，切换模板，合并订单号逗号连接发送一次
        Map<String, List<Map<String, String>>> sendPhoneMap = new HashMap<>();
        Map<String, Object> templateParams = new HashMap<>();
        List<BoxOrderSmsLogDO> boxOrderSmsLogDOList = new ArrayList<>();
        // 目的仓
        LogisticsInfoDto logisticsInfoDto =null;
        // 封装需要发送短信的手机号与订单信息
        for (Long orderId : orderIdList) {
            // 判断当前货柜的当前订单是否发送过当前的场景短信
            long count = boxOrderSmsLogService.count(new LambdaQueryWrapper<BoxOrderSmsLogDO>()
                    .eq(BoxOrderSmsLogDO::getOrderId, orderId)
                    .eq(BoxOrderSmsLogDO::getShipmentId, shipmentId)
                    .eq(BoxOrderSmsLogDO::getNodeValue, smsNodeEnum.getNodeValue()));
            if (count > 0) {
                // 当前货柜的当前订单已发送过短信，则不再发送
                log.info("出货单【{}】,订单ID【{}】, {}短信已发送过", shipmentId, orderId, smsNodeEnum.getDescription());
                continue;
            }
            OrderBackVO orderBackVO = orderQueryService.getOrder(orderId);
            if (logisticsInfoDto == null) {
                logisticsInfoDto = warehouseLineMapper.getStartInfoAndDestInfoByLineId(orderBackVO.getLineId());
            }
            String orderNo = orderBackVO.getOrderNo();
            String marks = orderBackVO.getMarks();
            // 封装货柜订单短信发送记录
            this.addBoxOrderSmsLog(shipmentId, smsNodeEnum, boxOrderSmsLogDOList, orderId, orderNo, marks);

            Map<String, String> orderMap = new HashMap<>(2);
            orderMap.put("orderNo", orderNo);
            orderMap.put("marks", marks);
            OrderConsignorBackVO orderConsignorDO = orderBackVO.getConsignorVO();
            String consignorPhone = orderConsignorDO.getCountryCode() + StrUtil.DASHED + orderConsignorDO.getPhone();
            List<Map<String, String>> consignorOrderNoList = sendPhoneMap.get(consignorPhone);
            this.addSmsSendPhoneInfo(sendPhoneMap, orderNo, orderMap, consignorPhone, consignorOrderNoList);
            OrderConsigneeBackVO orderConsigneeDO = orderBackVO.getConsigneeVO();
            if (Objects.nonNull(orderConsigneeDO)) {
                String consigneePhone = orderConsigneeDO.getCountryCode() + StrUtil.DASHED + orderConsigneeDO.getPhone();
                List<Map<String, String>> consigneeOrderNoList = sendPhoneMap.get(consigneePhone);
                this.addSmsSendPhoneInfo(sendPhoneMap, orderNo, orderMap, consigneePhone, consigneeOrderNoList);
            }
        }
        BoxDO boxDO = getBox(shipmentId);
        // 货柜自编号
        String selfNo = boxDO.getSelfNo();

        // 短信模板中所有柜号为自编号
        templateParams.put("number", selfNo);
        boxOrderSmsLogDOList = boxOrderSmsLogDOList.stream().peek(smsLog -> smsLog.setSelfNo(selfNo)).collect(Collectors.toList());
        for (Map.Entry<String, List<Map<String, String>>> entry : sendPhoneMap.entrySet()) {
            String[] codePhone = entry.getKey().split(StrUtil.DASHED);
            String phone = codePhone[1];
            String areaCode = codePhone[0];
            List<Map<String, String>> orderNoList = entry.getValue();
            StringBuilder orders = null;
            StringBuilder marks = null;
            for (int i = 1; i <= orderNoList.size(); i++) {
                Map<String, String> map = orderNoList.get(i - 1);
                if (orders != null) {
                    orders.append(StrUtil.COMMA).append(map.get("orderNo"));
                } else {
                    orders = new StringBuilder();
                    orders.append(map.get("orderNo"));
                }
                String m = map.get("marks");
                // 控制单个marks长度 超出12个字符，截取后面的字符串替换为...
                if (StringUtils.isNotBlank(m) && m.length() > 12) m = m.replaceAll(m.substring(10), "...");
                if (marks != null) {
                    marks.append(StrUtil.COMMA).append(m);
                } else {
                    marks = new StringBuilder();
                    marks.append(m);
                }
                if (i % 3 == 0 || i == orderNoList.size()) {
                    String nodeValue = smsNodeEnum.getNodeValue();
                    Integer isOrders = SmsIsOrdersEnum.SMS_ORDERS_0.getValue();
                    this.setTimeParams(templateParams);
                    templateParams.put("marks", marks);
                    switch (smsNodeEnum) {
                        case SHIPMENT_CABINET:
                            BoxCabinetDO boxCabinetDO = boxCabinetService.getByShipmentId(boxDO.getId());
                            if (Objects.nonNull(boxCabinetDO) && Objects.nonNull(boxCabinetDO.getLdBoxTime())) {
                                DateTime ldBoxTime = DateTime.of(boxCabinetDO.getLdBoxTime());
                                // 这里需要重置时间参数，这里的时间参数为填写的实际装柜时间
                                templateParams.put("date", DateUtils.formatDateTime(ldBoxTime));
                                templateParams.put("year", ldBoxTime.year());
                                templateParams.put("month", ldBoxTime.month() + 1);
                                templateParams.put("day", ldBoxTime.dayOfMonth());
                            }
                            // 装柜通知
                            if (orderNoList.size() > 1) {
                                nodeValue = SmsNodeEnum.SHIPMENT_CABINET.getNodeValue();
                                isOrders = SmsIsOrdersEnum.SMS_ORDERS_1.getValue();
                                templateParams.put("orders", orders.toString());
                            } else {
                                templateParams.put("order", orders.toString());
                            }
                            break;
                        case AIR_SHIPMENT_WAREHOUSE:
                            BoxAirCheckoutDO boxAirCheckoutDO = boxAirCheckoutService.getAirCheckoutByShipmentId(boxDO.getId());
                            if (Objects.nonNull(boxAirCheckoutDO) && Objects.nonNull(boxAirCheckoutDO.getCheckoutTime())) {
                                DateTime shipmentWarehouseTime = DateTime.of(boxAirCheckoutDO.getCheckoutTime());
                                // 这里需要重置时间参数，这里的时间参数为填写的出仓时间
                                templateParams.put("date", DateUtils.formatDateTime(shipmentWarehouseTime));
                                templateParams.put("year", shipmentWarehouseTime.year());
                                templateParams.put("month", shipmentWarehouseTime.month() + 1);
                                templateParams.put("day", shipmentWarehouseTime.dayOfMonth());
                            }
                            if (orderNoList.size() > 1) {
                                nodeValue = SmsNodeEnum.AIR_SHIPMENT_WAREHOUSE.getNodeValue();
                                isOrders = SmsIsOrdersEnum.SMS_ORDERS_1.getValue();
                                templateParams.put("orders", orders.toString());
                            } else {
                                templateParams.put("order", orders.toString());
                            }
                            break;
                        case SHIPMENT_CLOSE_CONTAINER:
                            // 装柜反审通知
                            templateParams.put("order", orders.toString());
                            break;
                        case SHIPMENT_ARRIVAL:
                            // 到港通知
                            // 空运到港通知
                            // 单号：${orders}（ 航班号：${number}）的货物已到港，清关中。如您的是控货单请及时放货，客服电话：400 9009962（9:00--18:00）
                            if (orderNoList.size() > 1) {
                                nodeValue = SmsNodeEnum.SHIPMENT_ARRIVAL.getNodeValue();
                                isOrders = SmsIsOrdersEnum.SMS_ORDERS_1.getValue();
                                templateParams.put("orders", orders.toString());
                            } else {
                                templateParams.put("order", orders.toString());
                            }
                            break;
                        case SHIPMENT_CUSTOMS_CLEARANCE:
                            //清关通知2023.2.9号新excel模板调整为 柜号{number},具体如下：
                            //【捷道货运】单号${orders}（柜号${number}）已清关。为了避免产生目的港仓租，请及时放货/提货。客服电话：400 9009962（9:00--18:00）。
                            //清关通知2023.2.9号新excel模板调整为 柜号{number},具体如下：
                            // 单号${orders}（航班号${number}）已清关。为了避免产生目的港仓租，请及时放货/提货。客服电话：400 9009962（9:00--18:00）。
                            if (orderNoList.size() > 1) {
                                nodeValue = SmsNodeEnum.SHIPMENT_CUSTOMS_CLEARANCE.getNodeValue();
                                isOrders = SmsIsOrdersEnum.SMS_ORDERS_1.getValue();
                                templateParams.put("orders", orders.toString());
                            } else {
                                templateParams.put("order", orders.toString());
                            }
                            break;
                        default:
                            return;
                    }

                    SmsSendSingleToUserReqDTOV2 reqDTO = new SmsSendSingleToUserReqDTOV2();
                    reqDTO.setTemplateParams(templateParams);
                    reqDTO.setNodeValue(nodeValue);
                    reqDTO.setUserId(0L);
                    reqDTO.setMobile(phone);
                    reqDTO.setAreaCode(areaCode);
                    reqDTO.setIsTransport(SmsIsTransportEnum.SMS_IS_TRANSPORT_1.getValue());
                    reqDTO.setTransportId(Integer.valueOf(boxDO.getTransportType()));
                    reqDTO.setIsOrders(isOrders);
                    reqDTO.setMessageType(SmsMessageTypeEnum.SMS_MESSAGE_TYPE_1.getValue());

                    //给收发货人发送短信
                    smsSendApi.sendSingleSmsToAdminV2(reqDTO,logisticsInfoDto.getDestCountryId()+ Constants.COLON+logisticsInfoDto.getDestCityId()+Constants.COLON
                    +logisticsInfoDto.getChannelId());
                    // 发送短信后初始化参数值
                    orders = null;
                    marks = null;
                }
            }
        }
        // 将货柜下的每个订单短信发送信息做记录
        boxOrderSmsLogService.insertBatch(boxOrderSmsLogDOList);
    }

    private void addSmsSendPhoneInfo(Map<String, List<Map<String, String>>> sendPhoneMap, String orderNo, Map<String, String> orderMap, String consigneePhone, List<Map<String, String>> consigneeOrderNoList) {
        if (Objects.nonNull(consigneeOrderNoList) && CollectionUtil.isNotEmpty(consigneeOrderNoList)) {
            long num = consigneeOrderNoList.stream().filter(m -> StringUtils.equals(m.get("orderNo"), orderNo)).count();
            if (num == 0) {
                consigneeOrderNoList.add(orderMap);
                sendPhoneMap.put(consigneePhone, consigneeOrderNoList);
            }
        } else {
            consigneeOrderNoList = new ArrayList<>();
            consigneeOrderNoList.add(orderMap);
            sendPhoneMap.put(consigneePhone, consigneeOrderNoList);
        }
    }

    private void addBoxOrderSmsLog(Long shipmentId, SmsNodeEnum smsNodeEnum, List<BoxOrderSmsLogDO> boxOrderSmsLogDOList, Long orderId, String orderNo, String marks) {
        BoxOrderSmsLogDO boxOrderSmsLogDO = new BoxOrderSmsLogDO();
        boxOrderSmsLogDO.setShipmentId(shipmentId);
        boxOrderSmsLogDO.setOrderId(orderId);
        boxOrderSmsLogDO.setOrderNo(orderNo);
        boxOrderSmsLogDO.setMarks(marks);
        boxOrderSmsLogDO.setNodeValue(smsNodeEnum.getNodeValue());
        boxOrderSmsLogDO.setTemplateCode(smsNodeEnum.getTemplateCode());
        boxOrderSmsLogDO.setDescription(smsNodeEnum.getDescription());
        boxOrderSmsLogDO.setCreator(SecurityFrameworkUtils.getLoginUserId().toString());
        boxOrderSmsLogDO.setCreateTime(new Date());
        boxOrderSmsLogDOList.add(boxOrderSmsLogDO);
    }

    private void setTimeParams(Map<String, Object> templateParams) {
        Calendar calendar = Calendar.getInstance();
        int year = calendar.get(Calendar.YEAR);
        int month = calendar.get(Calendar.MONTH) + 1;
        int day = calendar.get(Calendar.DATE);
        templateParams.put("date", DateUtils.formatDateTime(calendar.getTime()));
        templateParams.put("year", year);
        templateParams.put("month", month);
        templateParams.put("day", day);
    }

    /**
     * 销售添加业绩日志
     *
     * @param shipmentId 出货单ID
     */
    @Override
    public void addTargetLog(Long shipmentId, TargetLogEnum targetLogEnum, Date date) {
        //业绩日志
        Set<Long> orderIdList = boxPreloadGoodsService.getShipOrderIdList(shipmentId);
        if (CollectionUtil.isEmpty(orderIdList)) return;
        orderIdList.forEach(t -> targetLogService.addTargetLog(t, date, targetLogEnum));//TargetLogEnum.LOADING));
    }

    @Override
    public void updateOrderStatus(Long orderId, Integer orderStatus, Integer inWarehouseState, Integer shipmentState, Integer auditType, String auditResult, Boolean isAddOrderOperateLog, Integer hasExit) {
        orderService.updateStatus(orderId, null, orderStatus, null, inWarehouseState, shipmentState, auditType, auditResult, null, isAddOrderOperateLog, hasExit);
    }

    @Override
    public void updateOrderStatus(Long orderId, Integer orderStatus, Integer inWarehouseState, Integer shipmentState, Integer auditType, String auditResult, Boolean isAddOrderOperateLog) {
        orderService.updateStatus(orderId, null, orderStatus, null, inWarehouseState, shipmentState, auditType, auditResult, null, isAddOrderOperateLog);
    }

    @Override
    public void updateOrderStatusByShipmentId(Long shipmentId, Integer orderStatus, Integer inWarehouseState, Integer shipmentState, Integer auditType, String auditResult) {
        this.updateOrderStatusByShipmentId(shipmentId, orderStatus, inWarehouseState, shipmentState, auditType, auditResult, null);
    }

    @Override
    public void updateOrderStatusByShipmentIdAndTransportType(Long shipmentId, Integer orderStatus, Integer inWarehouseState, Integer shipmentState, Integer auditType, String auditResult, Integer transportType) {
        this.updateOrderStatusByShipmentIdAndTransportType(shipmentId, orderStatus, inWarehouseState, shipmentState, auditType, auditResult, null, transportType);
    }

    /**
     * 更新出货单下的订单状态
     *
     * @param shipmentId 出货单ID
     */
    @Override
    public void updateOrderStatusByShipmentIdAndTransportType(Long shipmentId, Integer orderStatus, Integer inWarehouseState, Integer shipmentState, Integer auditType, String auditResult, Date businessTime, Integer transportType) {
        Set<Long> orderIdList = boxPreloadGoodsService.getShipOrderIdList(shipmentId);
        //订单不存在
        if (CollectionUtil.isEmpty(orderIdList)) return;

        for (Long orderId : orderIdList) {
            orderService.updateStatus(orderId, null, orderStatus, null, inWarehouseState, shipmentState, auditType, auditResult, businessTime, "出货操作", null);
        }
        if (Objects.nonNull(shipmentState)) {
            if (transportType == 1) {
                this.shipmentSeaOrderTimeLog(orderIdList, null, businessTime, shipmentState);
            } else if (transportType == 3) {
                if (shipmentState == BoxStatusEnum.CLEARANCE_WAIT_UNLOAD.getStatus()) {
                    // 空运清关
                    addOrderAirTimeLog(orderIdList, OrderAirTimeEnum.AIR_CLEARED, null, null,null, null, businessTime, null);
                } else if (shipmentState == BoxStatusEnum.ARRIVAL_WAIT_DISCHARGE.getStatus() || shipmentState == BoxStatusEnum.DISCHARGE_WAIT_CLEARANCE.getStatus()) {
                    // 空运到港
                    addOrderAirTimeLog(orderIdList, OrderAirTimeEnum.AIR_ARRIVED, null, null,null, null, businessTime, null);
                } else {
                    this.shipmentAirOrderTimeLog(orderIdList, null, businessTime, shipmentState);
                }
            }
        }
    }


    /**
     * 更新出货单下的订单状态
     *
     * @param shipmentId 出货单ID
     */
    @Override
    public void updateOrderStatusByShipmentIdAndTransportType(Long shipmentId, Integer orderStatus, Integer inWarehouseState, Integer shipmentState, Integer auditType, String auditResult, Date businessTime, Date estTime, Integer transportType) {
        Set<Long> orderIdList = boxPreloadGoodsService.getShipOrderIdList(shipmentId);
        //订单不存在
        if (CollectionUtil.isEmpty(orderIdList)) return;
        updateOrderStatusByOrderIdAndTransportType(orderIdList, orderStatus, inWarehouseState, shipmentState, auditType, auditResult, businessTime, estTime, transportType);
        if (Objects.equals(orderStatus, OrderStatusEnum.IN_SHIPPING.getValue())) {
            for (Long orderId : orderIdList) {
                scoreProducerApi.sendOderMessage(ScoreRuleTypeEnum.ORDER_V, orderId, null);
            }
        }
    }

    @Override
    public void updateOrderStatusByOrderIdAndTransportType(Collection<Long> orderIdList, Integer orderStatus, Integer inWarehouseState, Integer shipmentState, Integer auditType, String auditResult, Date businessTime, Date estTime, Integer transportType) {
        for (Long orderId : orderIdList) {
            orderService.updateStatus(orderId, null, orderStatus, null, inWarehouseState, shipmentState, auditType, auditResult, businessTime, "出货操作", null);
        }
        if (Objects.nonNull(shipmentState)) {
            if (transportType == 1) {
                this.shipmentSeaOrderTimeLog(orderIdList, estTime, businessTime, shipmentState);
            } else if (transportType == 3) {
                if (shipmentState == BoxStatusEnum.CLEARANCE_WAIT_UNLOAD.getStatus()) {
                    // 空运清关
                    addOrderAirTimeLog(orderIdList, OrderAirTimeEnum.AIR_CLEARED, null, null,null, estTime, businessTime, null);
                } else if (shipmentState == BoxStatusEnum.ARRIVAL_WAIT_DISCHARGE.getStatus() || shipmentState == BoxStatusEnum.DISCHARGE_WAIT_CLEARANCE.getStatus()) {
                    // 空运到港
                    addOrderAirTimeLog(orderIdList, OrderAirTimeEnum.AIR_ARRIVED, null, null,null, estTime, businessTime, null);
                } else {
                    this.shipmentAirOrderTimeLog(orderIdList, estTime, businessTime, shipmentState);
                }
            }
        }
    }

    /**
     * 更新出货单下的订单状态
     *
     * @param shipmentId 出货单ID
     */
    @Override
    public void updateOrderStatusByShipmentId(Long shipmentId, Integer orderStatus, Integer inWarehouseState, Integer shipmentState, Integer auditType, String auditResult, Date businessTime) {
        Set<Long> orderIdList = boxPreloadGoodsService.getShipOrderIdList(shipmentId);
        //订单不存在
        if (CollectionUtil.isEmpty(orderIdList)) return;

        for (Long orderId : orderIdList) {
            orderService.updateStatus(orderId, null, orderStatus, null, inWarehouseState, shipmentState, auditType, auditResult, businessTime, "出货操作", null);
        }
        // 卸柜/到仓操作时，不在此处更新动态
        if (Objects.nonNull(shipmentState) && TO_WAREHOUSED.getStatus() != shipmentState) {
            this.shipmentAirOrderTimeLog(orderIdList, null, businessTime, shipmentState);
        }

    }

    @Override
    public void updateOrderStatusByOrderList(Collection<Long> orderIdList, Integer orderStatus, Integer inWarehouseState, Integer shipmentState, Integer auditType, String auditResult, Date estTime, Date businessTime) {
        //订单不存在
        if (CollectionUtil.isEmpty(orderIdList)) return;

        for (Long orderId : orderIdList) {
            orderService.updateStatus(orderId, null, orderStatus, null, inWarehouseState, shipmentState, auditType, auditResult, businessTime, "出货操作", null);
        }
        this.shipmentAirOrderTimeLog(orderIdList, estTime, businessTime, shipmentState);
    }

    private void shipmentSeaOrderTimeLog(Collection<Long> orderIdList, Date estTime, Date businessTime, Integer shipmentState) {
        if (shipmentState != null) {
            BoxStatusEnum boxStatusEnum = BoxStatusEnum.getStatusEnumByStatus(shipmentState);
            OrderSeaTimeEnum orderSeaTimeEnum = null;
            if (Objects.nonNull(boxStatusEnum)) {
                switch (boxStatusEnum) {
                    case SEAL_EXAMINE_SUCCESS:
                        orderSeaTimeEnum = OrderSeaTimeEnum.SEA_INSTALLED_CABINET;
                        break;
                    case SEALED:
                        orderSeaTimeEnum = OrderSeaTimeEnum.SEA_INSTALLED_CABINET;
                        break;
                    case CUSTOMS_FULL_EXIT:
                        orderSeaTimeEnum = OrderSeaTimeEnum.SEA_CUSTOMS_FULL_EXIT;
                        break;
                    case CUSTOMS_PASS:
                        orderSeaTimeEnum = OrderSeaTimeEnum.SEA_CUSTOMS_PASS_SEA;
                        break;
                    case SHIPPING:
                        orderSeaTimeEnum = OrderSeaTimeEnum.SEA_HAS_TAKEN_OFF;
                        break;

                    case ARRIVAL_WAIT_DISCHARGE:
                        orderSeaTimeEnum = OrderSeaTimeEnum.SEA_ARRIVED;
                        break;
                    case DISCHARGE_WAIT_CLEARANCE:
                        orderSeaTimeEnum = OrderSeaTimeEnum.SEA_ARRIVED;
                        break;
                    case TWO_WAY_ARRIVAL:
                        orderSeaTimeEnum = OrderSeaTimeEnum.SEA_ARRIVED;
                        break;
                    case CLEARANCE_WAIT_UNLOAD:
                        orderSeaTimeEnum = OrderSeaTimeEnum.SEA_CLEARED;
                        break;
                    case UNLOADED:
                        if (Objects.isNull(businessTime)) {
                            // 到仓业务时间为空时，不更新订单到仓动态
                            return;
                        }
                        orderSeaTimeEnum = OrderSeaTimeEnum.SEA_UNLOADED_CABINET;
                        break;
                }
            }

            if (Objects.nonNull(orderSeaTimeEnum)) {
                addOrderSeaTimeLog(orderIdList, orderSeaTimeEnum, null, null,null, estTime, businessTime, null);
            }
        }
    }

    private void shipmentAirOrderTimeLog(Collection<Long> orderIdList, Date estTime, Date businessTime, Integer shipmentState) {
        if (shipmentState != null) {
            BoxAirStatusEnum boxAirStatusEnum = BoxAirStatusEnum.getStatusEnumByStatus(shipmentState);
            OrderAirTimeEnum orderAirTimeEnum = null;
            if (Objects.nonNull(boxAirStatusEnum)) {
                switch (boxAirStatusEnum) {
                    case WAREHOUSED:
                        orderAirTimeEnum = OrderAirTimeEnum.AIR_WAREHOUSED;
                        break;
                    case CUSTOMS_COMPLETE:
                        orderAirTimeEnum = OrderAirTimeEnum.AIR_CUSTOMS_PASS_AIR;
                        break;
                    case CUSTOMS_FULL_EXIT:
                        orderAirTimeEnum = OrderAirTimeEnum.AIR_CUSTOMS_FULL_EXIT;
                        break;
                    case CUSTOMS_PART_EXIT:
                        orderAirTimeEnum = OrderAirTimeEnum.AIR_CUSTOMS_PART_EXIT;
                        break;
                    case FLYING:
                        orderAirTimeEnum = OrderAirTimeEnum.AIR_HAS_TAKEN_OFF;
                        break;
                    case ARRIVAL_WAIT_DISCHARGE:
                        orderAirTimeEnum = OrderAirTimeEnum.AIR_ARRIVED;
                        break;
                    case TO_WAREHOUSED:
                        if (Objects.isNull(businessTime)) {
                            // 到仓业务时间为空时，不在做订单到仓动态更新
                            return;
                        }
                        orderAirTimeEnum = OrderAirTimeEnum.AIR_UNLOADED_CABINET;
                        break;
                }
            }

            if (Objects.nonNull(orderAirTimeEnum)) {
                addOrderAirTimeLog(orderIdList, orderAirTimeEnum, null, null,null, estTime, businessTime, null);
            }
        }
    }

    @Override
    public void addOrderAirTimeLog(Collection<Long> orderIdList, OrderAirTimeEnum orderAirTimeEnum, String reasonZh, String reasonEn, String reasonFr,Date estTime, Date businessTime, Date now) {
        if (Objects.nonNull(orderAirTimeEnum)) {
            orderBusinessService.addAirOrderTimeLog(orderIdList, orderAirTimeEnum, reasonZh, reasonEn,reasonFr,estTime, businessTime, now);
        }
    }

    @Override
    public void addOrderSeaTimeLog(Collection<Long> orderIdList, OrderSeaTimeEnum orderSeaTimeEnum, String reasonZh, String reasonEn,String reasonFr,Date estTime, Date businessTime, Date now) {
        if (Objects.nonNull(orderSeaTimeEnum)) {
            orderBusinessService.addSeaOrderTimeLog(orderIdList, orderSeaTimeEnum, reasonZh, reasonEn,reasonFr,estTime, businessTime, now);
        }
    }

    @Override
    public void checkInstallNum(Long shipmentId) {
        BoxGoodsStatistics boxStatistics = boxPreloadGoodsService.getBoxStatistics(shipmentId);
        long numSum = boxStatistics.getNum();
        long installNum = boxStatistics.getLoadNum();
        if (numSum != installNum) {
            throw exception(BOX_INSTALL_NOT_MATCH);
        }
    }

    @Override
    public void checkOrderTagNum(Long id, Integer type) {
        if (type == 0) {
            List<BoxPreloadGoodsDO> boxPreloadGoodsDOS = boxPreloadGoodsService.selectList(BoxPreloadGoodsDO::getShipmentId, id);
            List<Long> orderIds = boxPreloadGoodsDOS.stream().map(BoxPreloadGoodsDO::getOrderId).distinct().collect(Collectors.toList());
            List<OrderDO> orderDOS = orderService.selectList(OrderDO::getOrderId, orderIds);
            List<BoxOrderCheckInfoDO> boxOrderCheckInfoDOS = boxOrderCheckInfoService.selectList(new LambdaQueryWrapperX<BoxOrderCheckInfoDO>()
                    .eq(BoxOrderCheckInfoDO::getShipmentId, id)
                    .eq(BoxOrderCheckInfoDO::getType, type)
            );
            List<String> orderNoList = new ArrayList<>();
            orderDOS.stream().forEach(item -> {
                List<BoxOrderCheckInfoDO> orderCheckInfoDOS = boxOrderCheckInfoDOS.stream().filter(i -> i.getOrderId().longValue() == item.getOrderId().longValue()).collect(Collectors.toList());
                if (CollectionUtil.isEmpty(orderCheckInfoDOS) || orderCheckInfoDOS.size() != item.getSumNum()) {
                    orderNoList.add(item.getOrderNo());
                }
            });
            if (CollectionUtil.isNotEmpty(orderNoList)) {
                throw exception(ORDER_INSTALL_NOT_MATCH, StringUtils.join(orderNoList, ","));
            }
        } else if (type == 1) {
            List<BoxPkgOrderDO> boxPkgOrderDOS = boxPkgOrderService.selectList(BoxPkgOrderDO::getPkgId, id);
            List<Long> orderIds = boxPkgOrderDOS.stream().map(BoxPkgOrderDO::getOrderId).distinct().collect(Collectors.toList());
            List<OrderDO> orderDOS = orderService.selectList(OrderDO::getOrderId, orderIds);
            List<BoxOrderCheckInfoDO> boxOrderCheckInfoDOS = boxOrderCheckInfoService.selectList(new LambdaQueryWrapperX<BoxOrderCheckInfoDO>()
                    .eq(BoxOrderCheckInfoDO::getPkgId, id)
                    .eq(BoxOrderCheckInfoDO::getType, type)
            );
            List<String> orderNoList = new ArrayList<>();
            orderDOS.stream().forEach(item -> {
                List<BoxOrderCheckInfoDO> orderCheckInfoDOS = boxOrderCheckInfoDOS.stream().filter(i -> i.getOrderId().longValue() == item.getOrderId().longValue()).collect(Collectors.toList());
                if (CollectionUtil.isEmpty(orderCheckInfoDOS) || orderCheckInfoDOS.size() != item.getSumNum()) {
                    orderNoList.add(item.getOrderNo());
                }
            });
            if (CollectionUtil.isNotEmpty(orderNoList)) {
                throw exception(ORDER_INSTALL_NOT_MATCH, StringUtils.join(orderNoList, ","));
            }
        }
    }

    @Override
    public void checkUnLoadNum(Long shipmentId) {
        //找到实装总箱数
        //获取这个预装单的所有已装标签
        BoxLoadInfoQueryVO boxLoadInfoQueryVO = new BoxLoadInfoQueryVO();
        boxLoadInfoQueryVO.setShipmentId(shipmentId);
        List<BoxLoadInfoDO> loadInfoList = boxLoadInfoService.getBoxLoadInfoList(boxLoadInfoQueryVO);
        long unloadNum = loadInfoList.stream()
                .filter(t -> Objects.nonNull(t.getUnloadTime()))
                .count();
        if (unloadNum != loadInfoList.size()) {
            BoxDO boxDO = getBox(shipmentId);
            if (boxDO.getTransportType().equals(TransportTypeEnum.AIR.getType())) {
                throw exception(BOX_WAREHOUSED_NOT_MATCH);
            } else {
                throw exception(BOX_UNLOAD_NOT_MATCH);
            }
        }
    }

    @Override
    public BoxLoadDetailBackVO boxGoodsList(Long shipmentId, Long secId, Integer isCover, Integer isRemove) {
        return boxGoodsList(shipmentId, secId, isCover, isRemove, null);
    }

    public BoxLoadDetailBackVO boxGoodsList(Long shipmentId, Long secId, Integer isCover, Integer isRemove, Integer isDel) {
        return boxPreloadGoodsService.boxGoodsList(shipmentId, secId, isCover, isRemove, isDel);
    }

    @Override
    public List<BoxTallyBackVO> tallyList(Long shipmentId) {
        List<BoxPreloadGoodsBackVO> goodsItemList = boxPreloadGoodsService.getShipGoodItemList(shipmentId);
        //以secId排序
        goodsItemList.sort(Comparator.comparing(BoxPreloadGoodsBackVO::getSecId));

        List<ProductAttrDO> productAttrDOList = productAttrService.getProductAttrList();
        Map<String, String> idNameMap = productAttrDOList.stream()
                .collect(Collectors.toMap(attr -> String.valueOf(attr.getId()), ProductAttrDO::getAttrName));
        //以订单ID分组
        Map<Long, List<BoxPreloadGoodsBackVO>> orderMap = goodsItemList.stream().peek(item ->{
                    item.setAttrNameList(
                            getAttrNameByIds(item.getProdAttrIds(), idNameMap)
                    );
                    item.setWarehouseInAttrNameList(
                            getAttrNameByIds(item.getWarehouseInProdAttrIds(), idNameMap)
                    );
                })
                .collect(Collectors.groupingBy(BoxPreloadGoodsBackVO::getOrderId));
        List<BoxTallyDO> tallyDOList = boxTallyService.list(new LambdaQueryWrapper<BoxTallyDO>()
                .eq(BoxTallyDO::getShipmentId, shipmentId)
        );

        //查询所有库区库域信息
        List<WarehouseAreaDO> areaList = warehouseAreaService.list(new LambdaQueryWrapper<>());
        List<WarehouseAreaPositionDO> positionList = warehouseAreaPositionService.list(new LambdaQueryWrapper<>());

        Map<Long, BoxTallyDO> orderTallyMap = tallyDOList.stream()
                .collect(Collectors.toMap(BoxTallyDO::getOrderId, v -> v, (v1, v2) -> v2));

        List<BoxTallyBackVO> boxTallyBackVOS = new ArrayList<>();

        for (Map.Entry<Long, List<BoxPreloadGoodsBackVO>> entry : orderMap.entrySet()) {
            Long orderId = entry.getKey();
            OrderDO orderDO = orderService.selectOne(OrderDO::getOrderId, orderId);
            List<BoxPreloadGoodsBackVO> orderGoodsItemList = entry.getValue();
            BoxTallyBackVO boxTallyBackVO = new BoxTallyBackVO();
            boxTallyBackVO.setTallyStatus(0);
            BoxTallyDO boxTallyDO = orderTallyMap.get(orderId);
            if (boxTallyDO != null) {
                BeanUtils.copyProperties(boxTallyDO, boxTallyBackVO);
            }
            Set<String> allWarehouseInAttrNameList = orderGoodsItemList.stream().map(BoxPreloadGoodsBackVO::getWarehouseInAttrNameList).flatMap(List::stream).collect(Collectors.toSet());
            boxTallyBackVO.setAllWarehouseInAttrNameList(allWarehouseInAttrNameList);
            BoxPreloadGoodsBackVO boxPreloadGoodsDO = orderGoodsItemList.get(0);
            boxTallyBackVO.setAdvanceType(boxPreloadGoodsDO.getAdvanceType());
            boxTallyBackVO.setOrderNo(boxPreloadGoodsDO.getOrderNo());
            boxTallyBackVO.setOrderItemList(orderGoodsItemList);
            boxTallyBackVO.setMultiSpecification(getMultiSpecification(orderGoodsItemList));
            boxTallyBackVO.setTidanNum(boxPreloadGoodsDO.getTidanNum());
            boxTallyBackVO.setNum(orderDO.getSumNum());
            // 设置混箱状态
            Integer mixStatus = orderGoodsItemList.stream().anyMatch(t -> t.getMixStatus() == 1) ? 1 : 0;
            boxTallyBackVO.setMixStatus(mixStatus);
            // 设置报关方式
            boxTallyBackVO.setCustomsType(boxPreloadGoodsDO.getCustomsType());

            // 设置包装类型
            String units = orderGoodsItemList.stream()
                    .map(boxPreloadGoodsBackVO -> boxPreloadGoodsBackVO.getUnits())
                    .filter(StringUtils::isNotEmpty)
                    .flatMap(t -> Arrays.stream(t.split(",")))
                    .distinct()
                    .collect(Collectors.joining(","));
            boxTallyBackVO.setUnits(units);

            // 是否有关联单
            boolean hasRelationOrder = orderGoodsItemList.stream().anyMatch(t -> t.getGuanLianOrderCount() > 0);
            boxTallyBackVO.setHasRelationOrder(hasRelationOrder);

            Long installNum = boxOrderCheckInfoService.selectCount(new LambdaQueryWrapperX<BoxOrderCheckInfoDO>()
                    .eq(BoxOrderCheckInfoDO::getShipmentId, shipmentId)
                    .eq(BoxOrderCheckInfoDO::getOrderId, orderId)
                    .eq(BoxOrderCheckInfoDO::getType, 0)
            );

            boxTallyBackVO.setInstallNum(installNum == null ? 0 : installNum.intValue());


            //设置储位
            List<OrderLocationDO> orderLocationList = orderLocationService.getOrderLocationListByOrderId(orderId);

            for (BoxPreloadGoodsBackVO itemVO : orderGoodsItemList) {
                matchItemLocation(areaList, positionList, orderLocationList, itemVO);
            }

            String positionNo = matchLocation(areaList, positionList, orderLocationList);
            boxTallyBackVO.setPositionNo(positionNo);

            boxTallyBackVOS.add(boxTallyBackVO);
        }
        boxTallyBackVOS.sort(new Comparator<BoxTallyBackVO>() {
            @Override
            public int compare(BoxTallyBackVO o1, BoxTallyBackVO o2) {
                return o1.getTidanNum().compareTo(o2.getTidanNum());
            }
        });
        return boxTallyBackVOS;
    }

    private List<String> getAttrNameByIds(String attrIds, Map<String, String> idNameMap) {
        if (StringUtils.isNotBlank(attrIds)) {
            String[] attrIdArray = attrIds.split(",");
            List<String> nameList = new ArrayList<>();
            for (String attrId : attrIdArray) {
                //map一定包含数据，否则是数据错误
                nameList.add(idNameMap.get(attrId));
            }
            return nameList;
        }
        return null;
    }

    @Override
    public List<BoxGuanlianOrderBackVO> getGuanLianOrderList(Long orderId) {
        List<BoxGuanlianOrderBackVO> boxGuanlianBackVOS = new ArrayList<>();

        // 通过orderId查询关联订单
        List<OrderGuanlianDO> guanlianList = orderGuanlianService.getGuanlianListByOrderId(orderId);
        if (CollectionUtils.isEmpty(guanlianList)) {
            return boxGuanlianBackVOS;
        }

        List<Long> orderIdList1 = guanlianList.stream().map(OrderGuanlianDO::getOrderId).collect(Collectors.toList());
        List<Long> orderIdList2 = guanlianList.stream().map(OrderGuanlianDO::getRelateOrderId).collect(Collectors.toList());
        // 合并
        orderIdList1.addAll(orderIdList2);
        // 去除orderId
        orderIdList1.remove(orderId);
        // 去重
        orderIdList1 = orderIdList1.stream().distinct().collect(Collectors.toList());

        // 根据orderIdLists查询关联订单
        List<BoxPreloadGoodsBackVO> goodsItemList = boxPreloadGoodsService.getGuanLianGoodItemList(orderIdList1);

        //以订单ID分组
        Map<Long, List<BoxPreloadGoodsBackVO>> orderMap = goodsItemList.stream()
                .collect(Collectors.groupingBy(BoxPreloadGoodsBackVO::getOrderId));

        // 查询所有库区库域信息
        List<WarehouseAreaDO> areaList = warehouseAreaService.list(new LambdaQueryWrapper<>());
        List<WarehouseAreaPositionDO> positionList = warehouseAreaPositionService.list(new LambdaQueryWrapper<>());

        for (Map.Entry<Long, List<BoxPreloadGoodsBackVO>> entry : orderMap.entrySet()) {
            Long orderIdTmp = entry.getKey();

            OrderDO orderDO = orderService.selectOne(OrderDO::getOrderId, orderIdTmp);
            List<BoxPreloadGoodsBackVO> orderGoodsItemList = entry.getValue();
            BoxGuanlianOrderBackVO boxGuanlianOrderBackVO = new BoxGuanlianOrderBackVO();

            BoxPreloadGoodsBackVO boxPreloadGoodsDO = orderGoodsItemList.get(0);
            boxGuanlianOrderBackVO.setAdvanceType(boxPreloadGoodsDO.getAdvanceType());
            boxGuanlianOrderBackVO.setOrderId(boxPreloadGoodsDO.getOrderId());
            boxGuanlianOrderBackVO.setId(boxPreloadGoodsDO.getOrderId());
            boxGuanlianOrderBackVO.setOrderNo(boxPreloadGoodsDO.getOrderNo());
            boxGuanlianOrderBackVO.setOrderItemList(orderGoodsItemList);
            boxGuanlianOrderBackVO.setMultiSpecification(getMultiSpecification(orderGoodsItemList));
            boxGuanlianOrderBackVO.setTidanNum(boxPreloadGoodsDO.getTidanNum());
            boxGuanlianOrderBackVO.setNum(orderDO.getSumNum());

            // 设置混箱状态
            Integer mixStatus = orderGoodsItemList.stream().anyMatch(t -> t.getMixStatus() == 1) ? 1 : 0;
            boxGuanlianOrderBackVO.setMixStatus(mixStatus);
            // 设置报关方式
            boxGuanlianOrderBackVO.setCustomsType(boxPreloadGoodsDO.getCustomsType());

            // 设置包装类型
            String units = orderGoodsItemList.stream()
                    .map(boxPreloadGoodsBackVO -> boxPreloadGoodsBackVO.getUnits())
                    .filter(StringUtils::isNotEmpty)
                    .flatMap(t -> Arrays.stream(t.split(",")))
                    .distinct()
                    .collect(Collectors.joining(","));
            boxGuanlianOrderBackVO.setUnits(units);

            // 是否有关联单
            boolean hasRelationOrder = orderGoodsItemList.stream().anyMatch(t -> t.getGuanLianOrderCount() > 0);
            boxGuanlianOrderBackVO.setHasRelationOrder(hasRelationOrder);

            // Long installNum = boxOrderCheckInfoService.selectCount(new LambdaQueryWrapperX<BoxOrderCheckInfoDO>()
            //         .eq(BoxOrderCheckInfoDO::getShipmentId, shipmentId)
            //         .eq(BoxOrderCheckInfoDO::getOrderId, orderIdTmp)
            //         .eq(BoxOrderCheckInfoDO::getType, 0)
            // );
            // boxGuanlianOrderBackVO.setInstallNum(installNum == null ? 0 : installNum.intValue());

            //设置储位
            List<OrderLocationDO> orderLocationList = orderLocationService.getOrderLocationListByOrderId(orderIdTmp);

            for (BoxPreloadGoodsBackVO itemVO : orderGoodsItemList) {
                matchItemLocation(areaList, positionList, orderLocationList, itemVO);
            }

            String positionNo = matchLocation(areaList, positionList, orderLocationList);
            boxGuanlianOrderBackVO.setPositionNo(positionNo);

            boxGuanlianBackVOS.add(boxGuanlianOrderBackVO);
        }
        boxGuanlianBackVOS.sort(Comparator.comparing(BoxGuanlianOrderBackVO::getOrderId));
        return boxGuanlianBackVOS;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void updateTallyStatus(Long shipmentId, Collection<Long> orderIdList) {
        List<OrderDO> orderDOList = orderQueryService.getOrderList(orderIdList);
        List<BoxTallyDO> boxTallyList = boxTallyService.list(new LambdaQueryWrapperX<BoxTallyDO>()
                .in(BoxTallyDO::getOrderId, orderIdList)
                .eq(BoxTallyDO::getShipmentId, shipmentId)
        );

        Map<Long, BoxTallyDO> boxTallyMap = boxTallyList.stream()
                .collect(Collectors.toMap(BoxTallyDO::getOrderId, v -> v, (v1, v2) -> v2));
        List<BoxTallyDO> updateList = new ArrayList<>();
        for (OrderDO orderDO : orderDOList) {
            Long orderId = orderDO.getOrderId();
            Long installNum = boxOrderCheckInfoService.selectCount(new LambdaQueryWrapperX<BoxOrderCheckInfoDO>()
                    .eq(BoxOrderCheckInfoDO::getShipmentId, shipmentId)
                    .eq(BoxOrderCheckInfoDO::getOrderId, orderId)
                    .eq(BoxOrderCheckInfoDO::getType, 0)
            );
            int tallyStatus = 0;
            BoxTallyDO boxTallyDO = boxTallyMap.get(orderId);
            if (installNum == orderDO.getSumNum().longValue()) {
                //已理货
                tallyStatus = 1;
                if (boxTallyDO == null) {
                    boxTallyDO = new BoxTallyDO();
                    boxTallyDO.setShipmentId(shipmentId);
                    boxTallyDO.setOrderId(orderId);
                }
            }
            if (boxTallyDO != null) {
                boxTallyDO.setTallyStatus(tallyStatus);
                if (tallyStatus == 1) {
                    boxTallyDO.setTallyTime(new Date());
                }
                updateList.add(boxTallyDO);
            }
            boxTallyService.saveOrUpdateBatch(updateList);
        }

    }


    private Set<Long> getDepartWarehouseId() {
        //获取仓库id列表
        Long deptId = SecurityFrameworkUtils.getLoginUser().getDeptId();
        DeptWarehouseBaseVO deptWarehouseBaseVO = new DeptWarehouseBaseVO();
        deptWarehouseBaseVO.setDeptId(deptId);
        List<DeptWarehouseDO> deptWarehouseDOS =
                warehouseService.deptList(deptWarehouseBaseVO);

        if (CollectionUtil.isEmpty(deptWarehouseDOS)) {
            throw exception(DEPT_NOT_FOUND);
        }

        return deptWarehouseDOS.stream()
                .map(DeptWarehouseDO::getWarehouseId)
                .collect(Collectors.toSet());
    }

    @Override
    public PageResult<BoxBackVO> getBoxLoadPage(MyBoxLoadQueryVO query) {
        Set<Long> warehouseIdSet = getDepartWarehouseId();

        Integer status = query.getStatus();
        int tlStatus = TlStatueEnum.HAS_SEND_CAR.getTlStatus();
        int tyStatus = TyStatueEnum.HAS_TALLY.getTyStatus();
        List<Integer> ldStatusList = null;
        if (status != null) {
            ldStatusList = new ArrayList<>();
            if (status == 1) {
                ldStatusList.add(LdStatusEnum.NO_CABINET.getLdStatus());
            } else if (status == 3) {
                //装柜中
                ldStatusList.add(LdStatusEnum.IN_CABINET.getLdStatus());
                ldStatusList.add(LdStatusEnum.INSTALLED_TO_BE_SEALED.getLdStatus());
                ldStatusList.add(LdStatusEnum.CABINET_EXAMINE_FAIL.getLdStatus());
            } else if (status == 5) {
                ldStatusList.add(LdStatusEnum.CABINET_EXAMINE_ING.getLdStatus());
            } else if (status == 7) {
                ldStatusList.add(LdStatusEnum.CABINET_EXAMINE_SUCCESS.getLdStatus());
            }
        }
        PageResult<BoxDO> pageResult = selectPage(query, new LambdaQuery<BoxDO>()
                .likeIfPresent(BoxDO::getSelfNo, query.getSelfNo())
                .eq(BoxDO::getTlStatus, tlStatus)
                //限制需要已理货
                .eq(BoxDO::getTyStatus, tyStatus)
                .in(ldStatusList != null, BoxDO::getLdStatus, ldStatusList)
                .eq(BoxDO::getDcStatus, DcStatueEnum.UNCUSTOMED.getDcStatus())
                .ne(BoxDO::getLdStatus, LdStatusEnum.CABINET_SEALED.getLdStatus())
                .and(
                        i ->
                                i.in(BoxDO::getStartWarehouseId, warehouseIdSet)
                                        .or()
                                        .in(BoxDO::getDestWarehouseId, warehouseIdSet)
                )
                .orderByDesc(BoxDO::getId));

        return boxInfoQuery(pageResult);
    }

    @Override
    public PageResult<BoxBackVO> getBoxTallyPage(MyBoxLoadQueryVO query) {
        Set<Long> warehouseIdSet = getDepartWarehouseId();

        if (CollectionUtil.isEmpty(warehouseIdSet)) return new PageResult<>();

        IPage<BoxDO> mpPage = MyBatisUtils.buildPage(query);

        List<String> transportTypeList = Arrays.asList(TransportTypeEnum.SEA_COMBINED_CABINET.getType(),
                TransportTypeEnum.SEA_WHOLE_CABINET.getType(), TransportTypeEnum.SEA_AIR.getType());

        mpPage = boxMapper.tallyPage(mpPage, warehouseIdSet, query.getSelfNo(), transportTypeList);

        PageResult<BoxDO> pageResult = PageResult.of(mpPage);
        return boxInfoQuery(pageResult);
    }

    @Override
    public PageResult<BoxBackVO> getBoxTallyPageAir(MyBoxLoadQueryVO query) {
        Set<Long> warehouseIdSet = getDepartWarehouseId();

        if (CollectionUtil.isEmpty(warehouseIdSet)) return new PageResult<>();

        IPage<BoxDO> mpPage = MyBatisUtils.buildPage(query);

        List<String> transportTypeList = Arrays.asList(TransportTypeEnum.AIR.getType());

        mpPage = boxMapper.tallyAirPage(mpPage, warehouseIdSet, query.getSelfNo(), transportTypeList);

        PageResult<BoxDO> pageResult = PageResult.of(mpPage);
        return boxInfoQuery(pageResult);
    }

    private PageResult<BoxBackVO> boxInfoQuery(PageResult<BoxDO> pageResult) {
        return boxInfoQuery(pageResult, false);
    }

    private PageResult<BoxBackVO> boxInfoQuery(PageResult<BoxDO> pageResult, boolean searchDcDate) {
        PageResult<BoxBackVO> result = BoxConvert.INSTANCE.convertPage(pageResult);
        return boxInfoQuery1(result, searchDcDate);
    }

    private PageResult<BoxBackVO> boxInfoQuery1(PageResult<BoxBackVO> result,
                                                boolean searchDcDate) {

        List<BoxBackVO> boxBackList = result.getList();
        if (CollectionUtil.isNotEmpty(boxBackList)) {
            List<Long> idList = boxBackList.stream()
                    .map(BoxBaseBackVO::getId)
                    .collect(Collectors.toList());

            //ecw_box_preload_goods 预装货物
            Map<Long, BoxGoodsStatistics> shipmentStatisticsMap =
                    boxPreloadGoodsService.getBoxStatistics(idList);

            List<Long> cabinetIdList = boxBackList.stream()
                    .map(BoxBaseBackVO::getCabinetId)
                    .filter(Objects::nonNull)
                    .collect(Collectors.toList());

            Map<Long, CabinetDO> cabinetMap = new HashMap<>();

            //ecw_cabinet 柜型配置
            if (CollectionUtils.isNotEmpty(cabinetIdList)) {
                List<CabinetDO> cabinetDOList = cabinetService.getCabinetList(cabinetIdList);
                cabinetMap = cabinetDOList.stream()
                        .collect(Collectors.toMap(CabinetDO::getId, v -> v));
            }

            Set<Long> destWarehouseIdList = boxBackList.stream()
                    .map(BoxBaseBackVO::getDestWarehouseId)
                    .collect(Collectors.toSet());
            //ecw_warehouse 仓库相关信息
            List<WarehouseDO> warehouseDOList =
                    warehouseService.getByIdList(new ArrayList<>(destWarehouseIdList));
            Map<Long, WarehouseDO> warehouseDOMap = warehouseDOList.stream()
                    .collect(Collectors.toMap(WarehouseDO::getId, v -> v));

            List<Long> channelIdList = boxBackList.stream()
                    .map(BoxBaseBackVO::getShippingChannelId)
                    .filter(Objects::nonNull)
                    .collect(Collectors.toList());
            Map<Long, ChannelDO> channelMap = new HashMap<>();
            if (CollectionUtils.isNotEmpty(channelIdList)) {
                List<ChannelDO> channelDOList =
                        channelService.getChannelList(channelIdList);
                channelMap = channelDOList.stream()
                        .collect(Collectors.toMap(ChannelDO::getChannelId, v -> v));
            }

            List<BoxApprovalDO> approvalDOList =
                    boxApprovalService.getBackApprovalList(idList);
            Map<Long, List<BoxApprovalDO>> shipmentApprovalMap = approvalDOList.stream()
                    .collect(Collectors.groupingBy(BoxApprovalDO::getShipmentId));

            for (BoxBackVO boxBackVO : boxBackList) {
                Long shipmentId = boxBackVO.getId();
                //设置柜型详情
                Long cabinetId = boxBackVO.getCabinetId();
                if (cabinetId != null) {
                    CabinetDO cabinetDO = cabinetMap.get(cabinetId);
                    CabinetRespVO cabinetRespVO = CabinetConvert.INSTANCE.convert(cabinetDO);
                    boxBackVO.setCabinetRespVO(cabinetRespVO);
                }

                //设置目的地
                WarehouseDO destWarehouse =
                        warehouseDOMap.get(boxBackVO.getDestWarehouseId());
                WarehouseRespVO destWarehouseResp =
                        WarehouseConvert.INSTANCE.convert(destWarehouse);
                boxBackVO.setDestWarehouseResp(destWarehouseResp);

                Long channelId = boxBackVO.getShippingChannelId();
                if (channelId != null && channelId != 0) {
                    ChannelDO channelDO = channelMap.get(channelId);
                    boxBackVO.setChannelRespVO(ChannelConvert.INSTANCE.convert(
                            channelDO));
                }

                //统计信息
                BoxGoodsStatistics boxStatistics =
                        shipmentStatisticsMap.get(shipmentId);
                boxBackVO.setBoxStatistics(boxStatistics);

                if (searchDcDate) {
                    BoxCabinetUnloadDO boxCabinetUnloadDO =
                            boxCabinetUnloadService.getOne(
                                    new LambdaQueryWrapperX<BoxCabinetUnloadDO>()
                                            .eq(BoxCabinetUnloadDO::getShipmentId, shipmentId)
                                            .last("limit 1")
                            );
                    if (boxCabinetUnloadDO != null) {
                        boxBackVO.setDcDate(boxCabinetUnloadDO.getUlWarehouseTime());
                    }
                }

                List<BoxApprovalDO> itemApprovalList =
                        shipmentApprovalMap.get(shipmentId);
                if (CollectionUtils.isNotEmpty(itemApprovalList)) {
                    BoxApprovalDO boxApprovalDO = itemApprovalList.get(0);
                    //查询反审信息
                    Integer backApprovalType = boxApprovalDO.getApprovalType();
                    boxBackVO.setBackApprovalType(backApprovalType);
                }
            }
        }
        return result;
    }

    @Override
    public PageResult<BoxBackVO> getBoxUnloadPage(MyBoxUnloadQueryVO query) {
        Set<Long> warehouseIdSet = getDepartWarehouseId();
        Integer status = query.getStatus();
        List<Integer> ulStatusList = null;
        if (status != null) {
            ulStatusList = new ArrayList<>();
            if (status == 1) {
                ulStatusList.add(ULStatusEnum.NO_CABINET_UNLOAD.getUlStatus());
            } else if (status == 3) {
                ulStatusList.add(ULStatusEnum.UNLOADING_CABINET.getUlStatus());
                ulStatusList.add(ULStatusEnum.UNLOADING_EXAMINE_FAIL.getUlStatus());
            } else if (status == 5) {
                ulStatusList.add(ULStatusEnum.UNLOADING_EXAMINE_ING.getUlStatus());
            } else if (status == 7) {
                ulStatusList.add(ULStatusEnum.UNLOADING_EXAMINE_SUCCESS.getUlStatus());
                ulStatusList.add(ULStatusEnum.UNLOADING_SEALED.getUlStatus());
            }
        }
        PageResult<BoxDO> pageResult = selectPage(query, new LambdaQuery<BoxDO>()
                .likeIfPresent(BoxDO::getSelfNo, query.getSelfNo())
                .eq(BoxDO::getClStatus, ClStatueEnum.HAS_CLEARANCE.getClStatus())
                .in(ulStatusList != null, BoxDO::getUlStatus, ulStatusList)
                .and(
                        i ->
                                i.in(BoxDO::getStartWarehouseId, warehouseIdSet)
                                        .or()
                                        .in(BoxDO::getDestWarehouseId, warehouseIdSet)
                )
                .ne(BoxDO::getTransportType, TransportTypeEnum.AIR.getType())
                .orderByDesc(BoxDO::getId));

        return boxInfoQuery(pageResult, true);
    }

    @Override
    public PageResult<BoxBackVO> getBoxExitPage(MyBoxExitQueryVO query) {
        Set<Long> warehouseIdSet = getDepartWarehouseId();
        PageResult<BoxDO> pageResult = selectPage(query, new LambdaQuery<BoxDO>()
                .likeIfPresent(BoxDO::getSelfNo, query.getSelfNo())
                .eq(BoxDO::getLdStatus, LdStatusEnum.CABINET_SEALED.getLdStatus())
                .eq(BoxDO::getDcCustomsStatus, 3)
                .in(BoxDO::getDcCheckStatus, Arrays.asList(1, 2))
                .eq(BoxDO::getCheckExamineStatus, BpmProcessInstanceResultEnum.APPROVE.getResult())
                .and(
                        i ->
                                i.in(BoxDO::getStartWarehouseId, warehouseIdSet)
                                        .or()
                                        .in(BoxDO::getDestWarehouseId, warehouseIdSet)
                )
                .orderByDesc(BoxDO::getId));

        PageResult<BoxBackVO> result = boxInfoQuery(pageResult);

        List<BoxBackVO> dataList = result.getList();
        if (CollectionUtil.isNotEmpty(dataList)) {
            for (BoxBackVO boxBackVO : dataList) {
                Long shipmentId = boxBackVO.getId();
//                Set<Long> orderIdList = getShipOrderIdList(shipmentId);
//                boxBackVO.setOrderNum(orderIdList.size());

                long orderNum = boxPreloadGoodsService.count(new QueryWrapper<BoxPreloadGoodsDO>()
                        .select("distinct order_id")
                        .eq("shipment_id", shipmentId)
                        .eq("is_remove", 0)
                );
                boxBackVO.setOrderNum(orderNum);

                long orderExitNum = boxOrderExitService.count(new LambdaQueryWrapper<BoxOrderExitDO>()
                        .eq(BoxOrderExitDO::getShipmentId, shipmentId)
                );
                boxBackVO.setOrderExitNum(orderExitNum);
            }
        }
        return result;
    }

    @Override
    public PageResult<BoxBackVO> getBoxExitPageAir(MyBoxExitQueryVO query) {
        Set<Long> warehouseIdSet = getDepartWarehouseId();
        PageResult<BoxDO> pageResult = selectPage(query, new LambdaQuery<BoxDO>()
                .likeIfPresent(BoxDO::getSelfNo,
                        query.getSelfNo())
                //已出仓 222
                .eq(BoxDO::getCheckoutStatus,
                        AirCheckoutStatusEnum.CHECKOUT.getStatus())
                .and(
                        i -> i.and(t ->
                                t.eq(BoxDO::getDcCustomsStatus, 3)
                                        .in(BoxDO::getDcCheckStatus, Arrays.asList(1, 2))
                                        .eq(BoxDO::getCheckExamineStatus, BpmProcessInstanceResultEnum.APPROVE.getResult())
                        ).or(t ->
                                t.eq(BoxDO::getOverMachineStatus, 2)
                                        .eq(BoxDO::getOverMachineAbnormalStatus, 1)
                                        .eq(BoxDO::getDeleteType, 2)
                                        .eq(BoxDO::getOverMachineExamineStatus, BpmProcessInstanceResultEnum.APPROVE.getResult())
                        )
                )
                .and(
                        i ->
                                i.in(BoxDO::getStartWarehouseId, warehouseIdSet)
                                        .or()
                                        .in(BoxDO::getDestWarehouseId, warehouseIdSet)
                )
                .orderByDesc(BoxDO::getId));

        PageResult<BoxBackVO> result = boxInfoQuery(pageResult);

        List<BoxBackVO> dataList = result.getList();
        if (CollectionUtil.isNotEmpty(dataList)) {
            for (BoxBackVO boxBackVO : dataList) {
                Long shipmentId = boxBackVO.getId();
//                Set<Long> orderIdList = getShipOrderIdList(shipmentId);
//                boxBackVO.setOrderNum(orderIdList.size());

                long orderNum = boxPreloadGoodsService.count(new QueryWrapper<BoxPreloadGoodsDO>()
                        .select("distinct order_id")
                        .eq("shipment_id", shipmentId)
                        .eq("is_remove", 0)
                );
                boxBackVO.setOrderNum(orderNum);

                long orderExitNum = boxOrderExitService.count(
                        new LambdaQueryWrapper<BoxOrderExitDO>()
                                .eq(BoxOrderExitDO::getShipmentId, shipmentId)
                );
                boxBackVO.setOrderExitNum(orderExitNum);
            }
        }
        return result;
    }

    @Override
    public BoxCabinetLoadVO getBoxCabinetDetail(Long shipmentId) {
        List<BoxLoadSectionBackVO> boxLoadDetailBackVO = boxPreloadGoodsService.loadSecGoodsList(shipmentId);

        BoxCabinetLoadVO boxCabinetLoadVO = new BoxCabinetLoadVO();
        boxCabinetLoadVO.setLoadDetail(boxLoadDetailBackVO);

        BoxBaseBackVO boxBaseBackVO = getBaseBoxInfo(shipmentId);
        boxCabinetLoadVO.setBoxInfo(boxBaseBackVO);

        BoxCabinetDO boxCabinetDO = getBoxCabinetDO(shipmentId);

        if (boxCabinetDO != null) {
            BoxCabinetBackVO boxCabinetBackVO = BoxCabinetConvert.INSTANCE.convert(boxCabinetDO);
            boxCabinetBackVO.setOperator(getUserName(boxCabinetDO.getCreator()));
            boxCabinetLoadVO.setCabinetInfo(boxCabinetBackVO);
        }

        BoxApprovalDO cabinetSplitApproval = boxApprovalService.getOne(new LambdaQueryWrapperX<BoxApprovalDO>()
                .eq(BoxApprovalDO::getShipmentId, shipmentId)
                .eq(BoxApprovalDO::getApprovalType, BoxApprovalTypeEnum.SPLIT_ORDER.getType())
                .orderByDesc(BoxApprovalDO::getId)
                .last("limit 1")
        );
        if (cabinetSplitApproval != null) {
            boxCabinetLoadVO.setCabinetSplitInfo(BoxApprovalConvert.INSTANCE.convert(cabinetSplitApproval));
        }

        if (TransportTypeEnum.AIR.getType().equals(boxBaseBackVO.getTransportType())) {
            for (BoxLoadSectionBackVO backVO : boxLoadDetailBackVO) {
                List<BoxLoadOrderVO> loadOrderList = backVO.getSectionOrderList();
                if (CollectionUtil.isNotEmpty(loadOrderList)) {
                    loadOrderList.sort(Comparator.comparing(BoxLoadOrderVO::getPkgNum, Comparator.nullsLast(String::compareTo)));
                }
            }
        }
        return boxCabinetLoadVO;
    }

    @Override
    public BoxCabinetLoadVO getBoxCabinetUnloadDetail(Long shipmentId) {
        List<BoxLoadSectionBackVO> boxLoadDetailBackVO = boxPreloadGoodsService.boxGoodsDetail(shipmentId);
        BoxCabinetLoadVO boxCabinetLoadVO = new BoxCabinetLoadVO();

        BoxCustomsDO boxCustomsDO = boxCustomsService.selectOne(new LambdaQueryWrapperX<BoxCustomsDO>()
                .eq(BoxCustomsDO::getShipmentId, shipmentId)
                .orderByDesc(BaseDO::getCreateTime)
                .last(" limit 1"));

        if (boxCustomsDO != null) {
            boxCabinetLoadVO.setCustomsInfo(BoxCustomsConvert.INSTANCE.convert(boxCustomsDO));
        }

        boxCabinetLoadVO.setBoxInfo(getBaseBoxInfo(shipmentId));

        boxCabinetLoadVO.setLoadDetail(boxLoadDetailBackVO);
        BoxCabinetUnloadDO boxCabinetUnloadDO = boxCabinetUnloadService.getOne(new LambdaQueryWrapperX<BoxCabinetUnloadDO>()
                .eq(BoxCabinetUnloadDO::getShipmentId, shipmentId)
                .last("limit 1")
        );
        if (boxCabinetUnloadDO != null) {
            boxCabinetLoadVO.setCabinetUnloadInfo(BoxCabinetUnloadConvert.INSTANCE.convert(boxCabinetUnloadDO));
        }
        return boxCabinetLoadVO;
    }

    @Override
    public BoxCabinetLoadVO getBoxCabinetExitDetail(Long shipmentId) {
        List<BoxLoadSectionBackVO> boxLoadDetailBackVO = boxPreloadGoodsService.loadSecGoodsList(shipmentId);

        BoxCabinetLoadVO boxCabinetLoadVO = new BoxCabinetLoadVO();
        boxCabinetLoadVO.setBoxInfo(getBaseBoxInfo(shipmentId));
        boxCabinetLoadVO.setLoadDetail(boxLoadDetailBackVO);

        BoxCustomsDO boxCustomsDO = boxCustomsService.getOne(new LambdaQueryWrapper<BoxCustomsDO>()
                .eq(BoxCustomsDO::getShipmentId, shipmentId)
                .last("limit 1")
        );
        if (boxCustomsDO != null) {
            boxCabinetLoadVO.setCustomsInfo(BoxCustomsConvert.INSTANCE.convert(boxCustomsDO));
        }
        return boxCabinetLoadVO;
    }

    @Override
    public List<BoxLoadOrderVO> getBoxCabinetExitList(Long shipmentId) {
        BoxLoadDetailBackVO boxLoadDetailBackVO = boxGoodsList(shipmentId, null, null, 0, 1);
        List<BoxLoadOrderVO> orderList = boxLoadDetailBackVO.getSectionOrderList();
        Map<Long, BoxLoadOrderVO> orderVOMap = orderList.stream()
                .collect(Collectors.toMap(BoxLoadOrderVO::getOrderId, v -> v, (v1, v2) -> v2));


        //找出退场的订单
        List<BoxOrderExitDO> exitOrderList = boxOrderExitService.list(new LambdaQueryWrapper<BoxOrderExitDO>()
                .eq(BoxOrderExitDO::getShipmentId, shipmentId)
        );
        List<BoxLoadOrderVO> dataList = new ArrayList<>();

        if (CollectionUtil.isNotEmpty(exitOrderList)) {
            for (BoxOrderExitDO exitDO : exitOrderList) {
                Long orderId = exitDO.getOrderId();
                if (orderVOMap.containsKey(orderId)) {
                    BoxLoadOrderVO boxLoadOrderVO = orderVOMap.get(orderId);
                    if (Objects.nonNull(boxLoadOrderVO)) {
                        boxLoadOrderVO.setRefundNum(exitDO.getRefundNum());
                        boxLoadOrderVO.setSplitStatus(exitDO.getSplitStatus());
                        boxLoadOrderVO.setSplit(exitDO.getSplit());
                        boxLoadOrderVO.setExitWarehouseIn(exitDO.getExitWarehouseIn());
                        boxLoadOrderVO.setOrderExitId(exitDO.getId());
                        boxLoadOrderVO.setLocationJson(exitDO.getLocationJson());
                    }
                    dataList.add(boxLoadOrderVO);
                }
            }
        }
        return dataList;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void confirmArrival(BoxCustomsApplyReq applyReq) {
        BoxCustomsDO boxCustomsDO = BoxCustomsConvert.INSTANCE.convert(applyReq);
        boxCustomsService.saveOrUpdate(boxCustomsDO);

        Long shipmentId = applyReq.getShipmentId();

        //出货单中删除已退场的订单
        List<BoxOrderExitDO> exitOrderList = boxOrderExitService.list(new LambdaQueryWrapper<BoxOrderExitDO>()
                .eq(BoxOrderExitDO::getShipmentId, shipmentId)
        );

        List<Long> orderIdList = exitOrderList.stream()
                .map(BoxOrderExitDO::getOrderId)
                .collect(Collectors.toList());
        if (CollectionUtil.isEmpty(exitOrderList)) {
            throw exception(SHIPMENT_ORDER_IS_NOT_EXITS);
        }
        //删除预装的商品
        boxPreloadGoodsService.remove(shipmentId, orderIdList, 1, true);

        addOrderLog(orderIdList, OrderShipmentLog.EXIT_INWAREHOUSE, "");

        //修改订单的储位
        for (BoxOrderExitDO orderExitDO : exitOrderList) {
            String locationJson = orderExitDO.getLocationJson();
            if (StringUtils.isNotEmpty(locationJson)) {
                List<OrderLocationCreateReqVO> orderLocationCreateReqVOList = JSONArray.parseArray(locationJson, OrderLocationCreateReqVO.class);
                orderLocationService.tallyUpdate(orderExitDO.getOrderId(), orderLocationCreateReqVOList);
            }
            // 改变退场订单入仓状态为已完成
            orderExitDO.setExitWarehouseIn(Boolean.TRUE);
        }

        //修改出货单为已处理
        BoxDO boxDO = getBox(shipmentId);
        boxDO.setCheckDealStatus(1);
        updateById(boxDO);
        // 更新退场订单状态为已完成入仓
        boxOrderExitService.updateBatchById(exitOrderList);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void changeContainer(BoxChangeReqVO req) {
        Long shipmentId = req.getShipmentId();
        String cubNo = req.getCubNo();
        String sono = req.getSono();
        BoxDO boxDO = getBox(shipmentId);
        boxDO.setCubNo(cubNo);
        //修改为已经处理
        boxDO.setCheckDealStatus(1);
        //状态回到封柜成功待出仓
        boxDO.setDcStatus(DcStatueEnum.UNCUSTOMED.getDcStatus());
        updateById(boxDO);

        //删除报关数据
        boxCustomsService.remove(new LambdaQueryWrapper<BoxCustomsDO>()
                .eq(BoxCustomsDO::getShipmentId, shipmentId)
        );

        BoxTrailerDO trailerDO = boxTrailerService.getOne(new LambdaQueryWrapper<BoxTrailerDO>()
                .eq(BoxTrailerDO::getShipmentId, shipmentId)
                .last("limit 1")
        );
        //修改拖车的货柜号
        trailerDO.setTlContainerNo(cubNo);
        boxTrailerService.updateById(trailerDO);

        if (StringUtils.isNotEmpty(sono)) {
            //修改sono
            BoxBookSeaDO boxBookSeaDO = boxBookSeaService.getOne(new LambdaQueryWrapperX<BoxBookSeaDO>()
                    .eq(BoxBookSeaDO::getShipmentId, shipmentId)
            );
            boxBookSeaDO.setSono(sono);
            boxBookSeaService.updateById(boxBookSeaDO);
        }

    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void closureApply(BoxCabinetApplyReq applyReq) {
        BoxCabinetDO boxCabinet = BoxCabinetConvert.INSTANCE.convert(applyReq);
        BoxCabinetDO dbCabinet = getBoxCabinetDO(applyReq.getShipmentId());
        if (dbCabinet != null) {
            boxCabinet.setId(dbCabinet.getId());
        }
        boxCabinetService.saveOrUpdate(boxCabinet);

        //提交审核
        createApproval(applyReq.getShipmentId(), BoxApprovalTypeEnum.SEALING_CABINET.getType(), "封柜申请");
    }


    @Override
    @Transactional(rollbackFor = Exception.class)
    public void unloadApply(BoxUnloadApplyReq applyReq) {
        BoxCabinetUnloadDO boxCabinetUnloadDO = BoxCabinetUnloadConvert.INSTANCE.convert(applyReq);
        Long shipmentId = applyReq.getShipmentId();

        //兼容前端不传ID
        BoxCabinetUnloadDO dbDO = boxCabinetUnloadService.getOne(new LambdaQueryWrapperX<BoxCabinetUnloadDO>()
                .eq(BoxCabinetUnloadDO::getShipmentId, shipmentId)
                .last("limit 1")
        );
        if (dbDO != null) {
            boxCabinetUnloadDO.setId(dbDO.getId());
        }

        boxCabinetUnloadService.saveOrUpdate(boxCabinetUnloadDO);

        //提交审核
        BoxDO boxDO = getBox(shipmentId);
        if (boxDO.getTransportType().equals(TransportTypeEnum.AIR.getType())) {
            createApproval(applyReq.getShipmentId(), BoxApprovalTypeEnum.AIR_TO_WAREHOUSE.getType(), "到仓申请");
        } else {
            createApproval(applyReq.getShipmentId(), BoxApprovalTypeEnum.UNLOAD_CABINET.getType(), "卸柜申请");
        }
    }

    private void createApproval(Long shipmentId, Integer type, String reason) {
        BoxApprovalCreateReqVO approvalCreateReqVO = new BoxApprovalCreateReqVO();
        approvalCreateReqVO.setShipmentId(shipmentId);
        approvalCreateReqVO.setApplyReason(reason);
        approvalCreateReqVO.setApprovalStatus(BpmProcessInstanceResultEnum.PROCESS.getResult());
        approvalCreateReqVO.setApprovalType(type);
        boxApprovalService.createBoxApproval(approvalCreateReqVO);
    }

    @Override
    public void checkPwd(String inputPwd) {
        BusiPwdDO pwdDO = busiPwdService.getOne(new LambdaQueryWrapperX<BusiPwdDO>()
                .eq(BusiPwdDO::getBusiType, "1")
                .last("limit 1")
        );
        if (pwdDO == null) {
            throw new ServiceException(500, "业务密码未设置");
        }
        String pwd = DigestUtils.md5DigestAsHex(inputPwd.getBytes());
        if (!pwd.equals(pwdDO.getPwd())) {
            throw new ServiceException(500, "密码错误");
        }
    }

    @Override
    public void boxLoadBatchCreate(BoxLoadInfoBatchAddReqVO createReqVO) {
        //首先校验密码
        checkPwd(createReqVO.getPwd());

        //完成批量装柜
        BoxLoadInfoCreateReqVO req = new BoxLoadInfoCreateReqVO();
        req.setShipmentId(createReqVO.getShipmentId());
        req.setOrderNo(createReqVO.getOrderNo());
        boxLoadInfoService.batchCreate(req);
    }

    @Override
    public void batchRemove(BoxLoadBatchRemoveReqVO createReqVO) {
        //
        Integer startNo = createReqVO.getStartNo();
        Integer endNo = createReqVO.getEndNo();
        if (endNo - startNo < 0) {
            throw new ServiceException(500, "结束编号要大于等于起始编号");
        }
        String orderNo = createReqVO.getOrderNo();
        List<String> orderNumCodeList = new ArrayList<>();

        if (startNo.equals(endNo)) {
            orderNumCodeList.add(CodeUtils.createOrderTagNumber(orderNo, startNo));
        } else {
            for (int i = startNo; i <= endNo; i++) {
                orderNumCodeList.add(CodeUtils.createOrderTagNumber(orderNo, i));
            }
        }
        OrderDO orderDO = orderService.getOne(new LambdaQueryWrapperX<OrderDO>()
                .eq(OrderDO::getOrderNo, orderNo)
                .last("limit 1")
        );
        if (orderDO == null) {
            BoxMergePkgDO boxMergePkgDO = boxMergePkgService.selectOne(BoxMergePkgDO::getPkgNum, orderNo);
            if (boxMergePkgDO != null) {
                List<BoxPkgOrderDO> boxPkgOrderDOS = boxPkgOrderService.selectList(BoxPkgOrderDO::getPkgId, boxMergePkgDO.getId());
                if (CollectionUtil.isNotEmpty(boxPkgOrderDOS)) {
                    List<Long> orderIds = boxPkgOrderDOS.stream().map(BoxPkgOrderDO::getOrderId).collect(Collectors.toList());
                    boxLoadInfoService.deleteLoadInfo(createReqVO.getShipmentId(), orderIds);
                    return;
                }
            }
        }
        boxLoadInfoService.batchDelete(orderNumCodeList, createReqVO.getShipmentId());
        addOrderLog(Collections.singletonList(orderDO.getOrderId()), OrderShipmentLog.CABINET_INFO_REMOVE_SINGLE, Joiner.on(",").join(orderNumCodeList));
    }

    @Override
    public void exitOrder(BoxOrderExitCreateReqVO createReqVO) {
        Long shipmentId = createReqVO.getShipmentId();
        String orderNo = createReqVO.getOrderNo();

        BoxLoadDetailBackVO boxLoadDetailBackVO = boxGoodsList(shipmentId, null, null, 0);

        List<BoxLoadOrderVO> orderList = boxLoadDetailBackVO.getSectionOrderList();
        if (CollectionUtil.isEmpty(orderList) && (Objects.isNull(createReqVO.getSplit()) || !createReqVO.getSplit())) {
            throw exception(SHIPMENT_ORDER_IS_NOT_EXITS);
        }

        Long orderId = null;
        Integer installNum = 0; // 实装数量
        for (BoxLoadOrderVO boxLoadOrderVO : orderList) {
            if (boxLoadOrderVO.getOrderNo().equals(orderNo)) {
                orderId = boxLoadOrderVO.getOrderId();
                installNum = Math.toIntExact(boxLoadOrderVO.getInstallNum());
            }
        }
        if (Objects.nonNull(createReqVO.getSplit()) && createReqVO.getSplit()) {
            orderId = createReqVO.getOrderId();
            installNum = createReqVO.getNum();
        }

        if (orderId == null) {
            throw exception(SHIPMENT_ORDER_IS_NOT_EXITS);
        }

        //判断订单是否以退场
        long exitCount = boxOrderExitService.count(new LambdaQueryWrapper<BoxOrderExitDO>()
                .eq(BoxOrderExitDO::getShipmentId, shipmentId)
                .eq(BoxOrderExitDO::getOrderId, orderId)
        );
        if (exitCount > 0) {
            throw exception(EXIT_ORDER_IS_EXITS);
        }

        createReqVO.setOrderId(orderId);
        BoxOrderExitDO exitDO = BoxOrderExitConvert.INSTANCE.convert(createReqVO);
        if (Objects.isNull(exitDO.getNum()) || exitDO.getNum() == 0) {
            exitDO.setNum(installNum);
        }
        if (Objects.isNull(exitDO.getRefundNum()) || exitDO.getRefundNum() == 0) {
            exitDO.setNum(installNum);
        }
        if (Objects.nonNull(exitDO.getNum()) && Objects.nonNull(exitDO.getRefundNum())) {
            if (exitDO.getNum() < exitDO.getRefundNum()) {
                throw exception(REFUND_NUM_NOT_BE_GT_NUM);
            }
            if (exitDO.getNum() > exitDO.getRefundNum()) {
                // 该订单不是整体退场，需要进行拆单后再操作退场
                exitDO.setSplitStatus(1);
            }
        }
        List<OrderLocationCreateReqVO> locationList = createReqVO.getOrderLocationCreateReqVOList();
        if (CollectionUtil.isNotEmpty(locationList)) {
            String locationJson = JSON.toJSONString(locationList);
            exitDO.setLocationJson(locationJson);
        }
        // 创建退场订单时标识当前订单未完成退场入仓
        exitDO.setExitWarehouseIn(Boolean.FALSE);
        boxOrderExitService.save(exitDO);
    }

    /**
     * 订单项匹配出货位置
     *
     * @param areaList
     * @param positionList
     * @param orderLocationList
     * @param itemVO
     */
    private void matchItemLocation(List<WarehouseAreaDO> areaList, List<WarehouseAreaPositionDO> positionList, List<OrderLocationDO> orderLocationList, BoxPreloadGoodsBackVO itemVO) {
        Long orderItemId = itemVO.getOrderItemId();
        List<OrderLocationDO> orderItemLocationList = orderLocationList.stream()
                .filter(t -> t.getOrderItemId() != null && t.getOrderItemId().equals(orderItemId))
                .collect(Collectors.toList());
        itemVO.setPositionNo(matchLocation(areaList, positionList, orderItemLocationList));
        itemVO.setOrderItemLocationList(OrderLocationConvert.INSTANCE.convertList(orderItemLocationList));
    }

    private String matchLocation(List<WarehouseAreaDO> areaList,
                                 List<WarehouseAreaPositionDO> positionList,
                                 List<OrderLocationDO> orderLocationList) {
        if (CollectionUtil.isEmpty(orderLocationList)) return null;

        Map<Long, WarehouseAreaDO> wareMap = areaList.stream()
                .collect(Collectors.toMap(WarehouseAreaDO::getId, v -> v));

        Map<Long, WarehouseAreaPositionDO> positionMap = positionList.stream()
                .collect(Collectors.toMap(WarehouseAreaPositionDO::getId, v -> v));

        List<String> locationList = new ArrayList<>();
        for (OrderLocationDO orderLocationDO : orderLocationList) {
            StringBuilder sb = new StringBuilder();

            Long wareId = orderLocationDO.getWareId();
            WarehouseAreaDO wareDO = wareMap.get(wareId);
            if (wareDO == null) continue;
            String wareName = wareDO.getName();
//            sb.append(wareName);

            Long areaId = orderLocationDO.getAreaId();
            WarehouseAreaDO areaDO = wareMap.get(areaId);
            if (areaDO != null) {
                String areaName = areaDO.getName();
                sb.append(areaName);
            }

            Long locationId = orderLocationDO.getLocationId();
            WarehouseAreaPositionDO positionDO = positionMap.get(locationId);
            if (positionDO != null) {
                sb.append(positionDO.getCode());

                //看有没有上级
//                if(positionDO.getPid() != 0L) {
//                    Long parentLocationId = positionDO.getPid();
//                    WarehouseAreaPositionDO parentPositionDO = positionMap.get(parentLocationId);
//                    String parentPositionName = parentPositionDO.getCode();
//                    sb.append("-").append(parentPositionName);
//                    sb.append(positionDO.getCode());
//                } else {
//                    sb.append("-").append(positionDO.getCode());
//                }
            }
            locationList.add(sb.toString());
        }
        return Joiner.on(",").join(locationList);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void batchOrderLocationUpdate(BoxOrderLocationUpdateReq req) {
        List<OrderLocationCreateReqVO> orderLocationList = req.getOrderLocationList();
        Long shipmentId = req.getShipmentId();


        //修改理货状态、理货时间
        Collection<Long> orderIdList = orderLocationList.stream()
                .map(OrderLocationBaseVO::getOrderId)
                .collect(Collectors.toSet());

        List<BoxTallyDO> boxTallyList = boxTallyService.list(new LambdaQueryWrapperX<BoxTallyDO>()
                .in(BoxTallyDO::getOrderId, orderIdList)
                .eq(BoxTallyDO::getShipmentId, shipmentId)
        );

        Map<Long, BoxTallyDO> boxTallyMap = boxTallyList.stream()
                .collect(Collectors.toMap(BoxTallyDO::getOrderId, v -> v, (v1, v2) -> v2));

        List<BoxTallyDO> tallyList = new ArrayList<>();

        for (Long orderId : orderIdList) {
            BoxTallyDO boxTallyDO = boxTallyMap.get(orderId);
            if (boxTallyDO == null) {
                boxTallyDO = new BoxTallyDO();
                boxTallyDO.setShipmentId(shipmentId);
                boxTallyDO.setOrderId(orderId);
            }
            boxTallyDO.setTallyStatus(1);
            boxTallyDO.setTallyTime(new Date());
            tallyList.add(boxTallyDO);

            List<OrderLocationCreateReqVO> locationList = orderLocationList.stream()
                    .filter(t -> t.getOrderId().equals(orderId))
                    .collect(Collectors.toList());

            //批量修改储位
            orderLocationService.tallyUpdate(orderId, locationList);
        }
        boxTallyService.saveOrUpdateBatch(tallyList);
        //订单理货箱数更新
        boxOrderCheckInfoService.orderTally(orderIdList, shipmentId);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void tallyCommit(Long shipmentId) {
        //订单有异常就不能提交
        BoxDO boxDO = getBox(shipmentId);
        checkOrderAbnormal(shipmentId, boxDO.getSelfNo());

        if (boxDO.getTyStatus() != TyStatueEnum.HAS_TALLY.getTyStatus()) {
            //已经完成理货则不再进行业务处理
            boxDO.setTyStatus(TyStatueEnum.HAS_TALLY.getTyStatus());
            if (boxDO.getTransportType().equals(TransportTypeEnum.AIR.getType())) {
                checkOrderTagNum(shipmentId, 0);
                //空运，修改订单状态
                updateOrderStatusByShipmentIdAndTransportType(shipmentId, OrderStatusEnum.SHIPMENT.getValue(), null,
                        BoxAirStatusEnum.TALLY_COMPLETE.getStatus(), null, null, Integer.parseInt(boxDO.getTransportType()));
            }
        }

        boxDO.setTyTime(new Date());
        Long userId = SecurityFrameworkUtils.getLoginUserId();
        boxDO.setTyOperator(getUserName(userId.toString()));
        updateById(boxDO);

        //理货提交把所有订单也修改为已理货状态
        Set<Long> orderIdSet = boxPreloadGoodsService.getShipOrderIdList(shipmentId);

        List<BoxTallyDO> boxTallyList = boxTallyService.list(new LambdaQueryWrapperX<BoxTallyDO>()
                .in(BoxTallyDO::getOrderId, orderIdSet)
                .eq(BoxTallyDO::getShipmentId, shipmentId)
        );

        Map<Long, BoxTallyDO> boxTallyMap = boxTallyList.stream()
                .collect(Collectors.toMap(BoxTallyDO::getOrderId, v -> v, (v1, v2) -> v2));

        List<BoxTallyDO> tallyList = new ArrayList<>();

        for (Long orderId : orderIdSet) {
            BoxTallyDO boxTallyDO = boxTallyMap.get(orderId);
            if (boxTallyDO == null) {
                boxTallyDO = new BoxTallyDO();
                boxTallyDO.setShipmentId(shipmentId);
                boxTallyDO.setOrderId(orderId);
            }
            boxTallyDO.setTallyStatus(1);
            boxTallyDO.setTallyTime(new Date());
            tallyList.add(boxTallyDO);
        }
        boxTallyService.saveOrUpdateBatch(tallyList);

        addOrderLog(new ArrayList<>(orderIdSet), OrderShipmentLog.TALLY, "");
    }

    private void checkOrderAbnormal(Long shipmentId, String selfNo) {
        Set<Long> orderIds = boxPreloadGoodsService.getShipOrderIdList(shipmentId);
        if (CollectionUtil.isEmpty(orderIds)) {
            throw new ServiceException(500, "出货无订单");
        }
        List<OrderDO> orderList = orderQueryService.getOrderList(orderIds);
        List<OrderDO> abnormalOrderList = orderList.stream()
                .filter(t -> t.getAbnormalState() > 0)
                .collect(Collectors.toList());
        if (CollectionUtils.isNotEmpty(abnormalOrderList)) {
            List<String> orderNoList = abnormalOrderList.stream()
                    .map(OrderDO::getOrderNo)
                    .collect(Collectors.toList());
            String message = "自编号" + selfNo + "下有订单存在异常,订单号:" + Joiner.on(",").join(orderNoList);
            throw new ServiceException(500, message);
        }
    }

    @Override
    public List<OrderSplitBackVO> listByOrderId(Long orderId) {
        return orderSplitService.listByOrderId(orderId, 0);
    }

    @Override
    public List<OrderSplitItemDO> splitItemListByOrderId(Long orderItemId) {
        return orderSplitItemMapper.selectList(new LambdaQueryWrapperX<OrderSplitItemDO>()
                .eq(OrderSplitItemDO::getUsed, false)
                .eq(OrderSplitItemDO::getOrderItemId, orderItemId));
    }

    @Override
    public List<OrderItemDO> getOrderItemsByOrderId(Long orderId) {
        return orderItemService.list(new LambdaQueryWrapper<OrderItemDO>()
                .eq(OrderItemDO::getOrderId, orderId)
                .orderByDesc(OrderItemDO::getOrderItemId));
    }

    @Override
    public void updateStatus(Long orderId, String orderNo, Integer status, Integer abnormalState, Integer inWarehouseState, Integer shipmentState, Integer auditType, String auditResult) {
        orderService.updateStatus(orderId, orderNo, status, abnormalState, inWarehouseState, shipmentState, auditType, auditResult, null, "出货操作", null);
    }

    @Override
    public void splitCancelByOrderId(Long orderId) {
        orderSplitService.splitCancelByOrderId(orderId);
    }

    @Override
    public void splitSuccess(OrderSplitApplyDetailDto orderSplitApplyDetailDto, String auditResult) {
        orderSplitService.splitSuccess(orderSplitApplyDetailDto, auditResult);
    }

    @Override
    public OrderDO getSplitBoxOrder(String orderNo) {
        return orderService.getOne(new LambdaQueryWrapper<OrderDO>()
                .eq(OrderDO::getOrderNo, orderNo)
        );
    }

    @Override
    public OrderDO getOrder(Long orderId) {
        return orderService.getById(orderId);
    }

    @Override
    public OrderConsigneeDO getOrderConsignee(OrderDO orderDO) {
        OrderConsigneeDO orderConsigneeDO = orderConsigneeService.getOne(new LambdaQueryWrapper<OrderConsigneeDO>().eq(OrderConsigneeDO::getOrderId, orderDO.getOrderId()).orderByDesc(OrderConsigneeDO::getId).last("limit 1"));
        return orderConsigneeDO;
    }

    @Override
    public void updateSplitOrderId(Long shipmentId, OrderDO oldOrder, Long newOrderId, String newOrderNo) {
        Long orderId = oldOrder.getOrderId();
        //找出所有的已装信息
        List<BoxPreloadGoodsDO> preloadGoodsDOList = boxPreloadGoodsService.list(new LambdaQueryWrapperX<BoxPreloadGoodsDO>()
                .eq(BoxPreloadGoodsDO::getOrderId, orderId)
                .eq(BoxPreloadGoodsDO::getShipmentId, shipmentId)
                .eq(BoxPreloadGoodsDO::getIsRemove, 0)
        );

        //新的订单项列表
        List<OrderItemDO> itemList = orderItemService.list(new LambdaQueryWrapper<OrderItemDO>()
                .eq(OrderItemDO::getOrderId, newOrderId)
                .orderByDesc(OrderItemDO::getOrderItemId)
        );
        //原订单项id->订单项id
        Map<Long, Long> orgItemIdMap = itemList.stream()
                .collect(Collectors.toMap(OrderItemDO::getOrgItemId, OrderItemDO::getOrderItemId, (v1, v2) -> v2));
        Map<Long, Long> orderItemIdMap = new HashMap<>();
        // 拆单后需要移除的货物信息id列表
        List<Long> delPreloadGoodsIdList = new ArrayList<>();
        for (BoxPreloadGoodsDO boxPreloadGoodsDO : preloadGoodsDOList) {
            //订单号修改为新的拆单订单号
            boxPreloadGoodsDO.setOrderId(newOrderId);
            //旧的订单项ID
            Long orderItemId = boxPreloadGoodsDO.getOrderItemId();
            Long newOrderItemId = null;
            if (orderItemIdMap.containsKey(orderItemId)) {
                newOrderItemId = orderItemIdMap.get(orderItemId);
            } else {
                //旧的订单Id
                newOrderItemId = orgItemIdMap.get(orderItemId);
                // TODO 此处有个问题，拆单后将某个货物全部拆出了,此时该货物映射的orderItemId是不存在的
                if (Objects.nonNull(newOrderItemId)) {
                    orderItemIdMap.put(orderItemId, newOrderItemId);
                }
            }
            if (Objects.nonNull(newOrderItemId)) {
                boxPreloadGoodsDO.setOrderItemId(newOrderItemId);
            } else {
                // 不存在newOrderItemId,则表示该货物拆单被拆出了，需要移除预装货物列表
                delPreloadGoodsIdList.add(boxPreloadGoodsDO.getId());
            }
        }
        boxPreloadGoodsService.updateBatch(preloadGoodsDOList);
        // 移除已被拆出的货物
        if (CollectionUtil.isNotEmpty(delPreloadGoodsIdList)) {
            boxPreloadGoodsService.removeByIds(delPreloadGoodsIdList);
        }


        orderService.updateStatus(newOrderId, null, oldOrder.getStatus(), oldOrder.getAbnormalState(),
                oldOrder.getInWarehouseState(), oldOrder.getShipmentState(), null, null, null, "出货操作", null);

        List<BoxLoadInfoDO> existList = boxLoadInfoService.list(new LambdaQueryWrapper<BoxLoadInfoDO>()
                .eq(BoxLoadInfoDO::getOrderId, orderId)
                .eq(BoxLoadInfoDO::getShipmentId, shipmentId)
        );
        if (CollectionUtil.isNotEmpty(existList)) {
            //修改为新的标签号
            for (BoxLoadInfoDO boxLoadInfoDO : existList) {
                String orderNumCode = boxLoadInfoDO.getOrderNumCode();
                int position = orderNumCode.lastIndexOf("-");
                if (position >= 0) {
                    String boxNumber = orderNumCode.substring(position + 1);
                    orderNumCode = newOrderNo + "-" + boxNumber;
                    boxLoadInfoDO.setOrderNumCode(orderNumCode);
                }
            }
            boxLoadInfoService.updateBatch(existList);
        }

        //修改新的标签号
        BoxLoadInfoDO boxLoadInfoDO = new BoxLoadInfoDO();
        boxLoadInfoDO.setOrderId(newOrderId);
        boxLoadInfoService.update(boxLoadInfoDO, new LambdaQueryWrapperX<BoxLoadInfoDO>()
                .eq(BoxLoadInfoDO::getOrderId, orderId)
                .eq(BoxLoadInfoDO::getShipmentId, shipmentId)
        );


//        BoxPreloadGoodsDO goodsDO = new BoxPreloadGoodsDO();
//        goodsDO.setOrderId(newOrderId);

//        //修改为新的订单号，订单项是否修改?
//        boxPreloadGoodsService.update(goodsDO, new LambdaQueryWrapper<BoxPreloadGoodsDO>()
//            .eq(BoxPreloadGoodsDO::getShipmentId, shipmentId)
//                .eq(BoxPreloadGoodsDO::getOrderId, orderId)
//        );
    }


    @Override
    public void updateExitSplitOrderId(Long shipmentId, OrderDO oldOrder, List<OrderDO> exitSplitOrder) {
        Long orderId = oldOrder.getOrderId();
        //找出所有的已装信息
        List<BoxPreloadGoodsDO> preloadGoodsDOList = boxPreloadGoodsService.list(new LambdaQueryWrapperX<BoxPreloadGoodsDO>()
                .eq(BoxPreloadGoodsDO::getOrderId, orderId)
                .eq(BoxPreloadGoodsDO::getShipmentId, shipmentId)
                .eq(BoxPreloadGoodsDO::getIsRemove, 0)
        );
        List<BoxLoadInfoDO> existList = boxLoadInfoService.list(new LambdaQueryWrapper<BoxLoadInfoDO>()
                .eq(BoxLoadInfoDO::getOrderId, orderId)
                .eq(BoxLoadInfoDO::getShipmentId, shipmentId)
        );
        for (OrderDO newOrder : exitSplitOrder) {
            // 拆单后需要移除的货物信息id列表
            List<BoxPreloadGoodsDO> newPreloadGoodsDOList = new ArrayList<>();
            //新的订单项列表
            List<OrderItemDO> itemList = orderItemService.list(new LambdaQueryWrapper<OrderItemDO>()
                    .eq(OrderItemDO::getOrderId, newOrder.getOrderId())
                    .orderByDesc(OrderItemDO::getOrderItemId)
            );
            for (OrderItemDO orderItemDO : itemList) {
                for (BoxPreloadGoodsDO boxPreloadGoodsDO : preloadGoodsDOList) {
                    if (Objects.equals(boxPreloadGoodsDO.getOrderItemId(), orderItemDO.getOrgItemId())) {
                        BoxPreloadGoodsDO newPreloadGoodsDO = new BoxPreloadGoodsDO();
                        BeanUtils.copyProperties(boxPreloadGoodsDO, newPreloadGoodsDO);
                        newPreloadGoodsDO.setId(null);
                        //订单号修改为新的拆单订单号
                        newPreloadGoodsDO.setOrderId(newOrder.getOrderId());
                        newPreloadGoodsDO.setOrderItemId(orderItemDO.getOrderItemId());
                        if (!newOrder.getIsMaster()) {
                            newPreloadGoodsDO.setCreateTime(new Date());
                            newPreloadGoodsDO.setCreator(String.valueOf(SecurityFrameworkUtils.getLoginUserId()));
                        }
                        newPreloadGoodsDO.setUpdateTime(new Date());
                        newPreloadGoodsDO.setUpdater(String.valueOf(SecurityFrameworkUtils.getLoginUserId()));
                        newPreloadGoodsDOList.add(newPreloadGoodsDO);
                    }
                }
            }
            boxPreloadGoodsService.insertBatch(newPreloadGoodsDOList);
            List<BoxLoadInfoDO> newExistList = new ArrayList<>();
            List<BoxLoadInfoDO> updateBoxExistList = new ArrayList<>();
            int num = newOrder.getSumNum();
            if (CollectionUtil.isNotEmpty(existList)) {
                //修改为新的标签号
                for (BoxLoadInfoDO boxLoadInfoDO : existList) {
                    if (num > 0) {
                        BoxLoadInfoDO newBoxLoadInfo = new BoxLoadInfoDO();
                        BeanUtils.copyProperties(boxLoadInfoDO, newBoxLoadInfo);
                        String orderNumCode = newBoxLoadInfo.getOrderNumCode();
                        int position = orderNumCode.lastIndexOf("-");
                        if (position >= 0) {
                            String boxNumber = orderNumCode.substring(position + 1);
                            orderNumCode = newOrder.getOrderNo() + "-" + boxNumber;
                            newBoxLoadInfo.setOrderNumCode(orderNumCode);
                        }
                        newBoxLoadInfo.setOrderId(newOrder.getOrderId());
                        newExistList.add(newBoxLoadInfo);
                        updateBoxExistList.add(boxLoadInfoDO);
                        num--;
                    }
                }
                boxLoadInfoService.updateBatch(newExistList);
                existList.removeAll(updateBoxExistList);
            }
            if (!newOrder.getIsMaster()) {
                // 拆出需要退场的订单做新增处理
//                newPreloadGoodsDOList = newPreloadGoodsDOList.stream().peek(p -> p.setId(null)).collect(Collectors.toList());
//                boxPreloadGoodsService.saveBatch(newPreloadGoodsDOList);
                // 需要修改退场订单为当前订单拆出来的需要退场的子订单, 需要将此业务加入到货柜中去
                BoxOrderExitCreateReqVO orderExitCreateReqVO = new BoxOrderExitCreateReqVO();
                orderExitCreateReqVO.setOrderNo(newOrder.getOrderNo());
                orderExitCreateReqVO.setOrderId(newOrder.getOrderId());
                orderExitCreateReqVO.setShipmentId(shipmentId);
                orderExitCreateReqVO.setNum(newOrder.getSumNum());
                orderExitCreateReqVO.setRefundNum(newOrder.getSumNum());
                orderExitCreateReqVO.setSplitStatus(0);
                orderExitCreateReqVO.setSplit(true);
                this.exitOrder(orderExitCreateReqVO);
            }
            orderService.updateStatus(newOrder.getOrderId(), null, oldOrder.getStatus(), oldOrder.getAbnormalState(),
                    oldOrder.getInWarehouseState(), oldOrder.getShipmentState(), null, null, null, false);
        }
        // 移除已被拆出的货物
        if (CollectionUtil.isNotEmpty(preloadGoodsDOList)) {
            boxPreloadGoodsService.removeByIds(new ArrayList<>(preloadGoodsDOList.stream().map(BoxPreloadGoodsDO::getId).collect(Collectors.toList())));
        }
    }

    @Override
    public List<BoxNoticeVO> noticeList(BoxQueryVO boxQueryVO) {
        List<BoxNoticeVO> noticeList = new ArrayList<>();

        Long loginUserId = SecurityFrameworkUtils.getLoginUserId();

        List<String> transportTypeList = boxQueryVO.getTransportTypeList();

        //首先找到所有没有起运的出货列表
        List<BoxBookSeaDO> boxBookList = boxBookSeaService.getNoticeBookList();

        //1.出货时间相关提醒
        if (CollectionUtil.isNotEmpty(boxBookList)) {
            List<Long> shipmentIdList = boxBookList.stream()
                    .map(BoxBookSeaDO::getShipmentId)
                    .collect(Collectors.toList());
            List<BoxDO> boxList = getBoxList(shipmentIdList);
            Map<Long, BoxDO> boxMap = boxList.stream()
                    .collect(Collectors.toMap(BoxDO::getId, v -> v));

            Date now = new Date();

            for (BoxBookSeaDO boxBookSeaDO : boxBookList) {
                Long shipmentId = boxBookSeaDO.getShipmentId();
                Long createUserId = Long.valueOf(boxBookSeaDO.getCreator());
                BoxDO boxDO = boxMap.get(shipmentId);

                String transportType = boxDO.getTransportType();
                if (CollectionUtil.isNotEmpty(transportTypeList)) {
                    if (!transportTypeList.contains(transportType)) continue;
                }

                //预计报关时间和通知人
                Date customsDate = boxBookSeaDO.getCustomsTime();
                if (customsDate != null) {
                    //流程需要进行到报关状态
                    Integer ldStatus = boxDO.getLdStatus();
                    //没有封柜完成不提醒
                    if (ldStatus != LdStatusEnum.CABINET_SEALED.getLdStatus()) continue;

                    //判断当前出货有没有报关
                    Integer dcStatus = boxDO.getDcStatus();
                    if (dcStatus != DcStatueEnum.DECLARED.getDcStatus() && now.compareTo(customsDate) > 0) {
                        //不等于已报关，则通知
                        Long customsNotifyUser = boxBookSeaDO.getCustomsNotifyUser();
                        checkAddNotice(customsNotifyUser, loginUserId, createUserId, boxDO, NoticeTypeEnum.CUSTOMS, noticeList, customsDate);
                    }
                }

                //预计提单补料
                Date ladingBillTime = boxBookSeaDO.getLadingBillTime();
                if (ladingBillTime != null) {
                    Integer saStatus = boxDO.getSaStatus();
                    if (saStatus != SaStatueEnum.HAS_SHIP.getSaStatus()) continue;

                    Integer blStatus = boxDO.getBlStatus();
                    if (blStatus != BlStatueEnum.HAS_LADING_BILL.getBlStatus() && now.compareTo(ladingBillTime) > 0) {
                        Long ladingBillNotifyUser = boxBookSeaDO.getLadingBillNotifyUser();
                        checkAddNotice(ladingBillNotifyUser, loginUserId, createUserId, boxDO, NoticeTypeEnum.LADINGBILL, noticeList, ladingBillTime);
                    }
                }

                //预计开船时间
                Date sailTime = boxBookSeaDO.getSailTime();
                if (sailTime != null) {
                    Integer bgStatus = boxDO.getBgStatus();
                    if (bgStatus != BgStatueEnum.HAS_BARGE.getBgStatus()) continue;

                    Integer dtStatus = boxDO.getDtStatus();
                    if (dtStatus != DtStatueEnum.HAS_SHIPPING.getDtStatus() && now.compareTo(sailTime) > 0) {
                        Long sailNotifyUser = boxBookSeaDO.getSailNotifyUser();
                        checkAddNotice(sailNotifyUser, loginUserId, createUserId, boxDO, NoticeTypeEnum.SHIP, noticeList, sailTime);
                    }
                }

                //预计截关时间
                Date cutOffTime = boxBookSeaDO.getCutOffTime();
                if (cutOffTime != null) {
                    //流程需要进行到报关状态
                    Integer ldStatus = boxDO.getLdStatus();
                    //没有封柜完成不提醒
                    if (ldStatus != LdStatusEnum.CABINET_SEALED.getLdStatus()) continue;

                    Integer dcCustomsStatus = boxDO.getDcCustomsStatus();
                    Integer dcCheckStatus = boxDO.getDcCheckStatus();
                    Integer checkDealStatus = boxDO.getCheckDealStatus();
                    //查验退场未处理
                    if (dcCustomsStatus == 3 && dcCheckStatus != 3 && checkDealStatus == 0 && now.compareTo(cutOffTime) > 0) {
                        Long cutOffNotifyUser = boxBookSeaDO.getCutOffNotifyUser();
                        checkAddNotice(cutOffNotifyUser, loginUserId, createUserId, boxDO, NoticeTypeEnum.CUTOFF, noticeList, cutOffTime);
                    }
                }
            }
        }

        //2.订单异常相关提醒
        List<BoxAbnormalDO> abnormalList = getAbnormalList(false);

        if (CollectionUtil.isNotEmpty(abnormalList)) {
            List<Long> shipmentIdList = abnormalList.stream()
                    .map(BoxAbnormalDO::getShipmentId)
                    .collect(Collectors.toList());
            List<BoxDO> boxList = getBoxList(shipmentIdList);
            if (CollectionUtil.isNotEmpty(boxList)) {

                Map<Long, BoxDO> boxMap = boxList.stream()
                        .collect(Collectors.toMap(BoxDO::getId, v -> v));

                for (BoxAbnormalDO abnormalDO : abnormalList) {
                    String notifyUsers = abnormalDO.getNotifyUsers();
                    if (notifyUsers == null) continue;
                    Long shipmentId = abnormalDO.getShipmentId();
                    Integer opStep = abnormalDO.getOpStep();
                    BoxDO boxDO = boxMap.get(shipmentId);
                    String transportType = boxDO.getTransportType();
                    if (CollectionUtil.isNotEmpty(transportTypeList)) {
                        if (!transportTypeList.contains(transportType)) continue;
                    }

                    String[] userArray = notifyUsers.split(",");
                    NoticeTypeEnum typeEnum = null;
                    if (opStep.equals(AbnormalStepEnum.CUSTOMS.getStep())) {
                        typeEnum = NoticeTypeEnum.ABNORMAL_CUSTOMS;
                    } else if (opStep.equals(AbnormalStepEnum.SHIPPING.getStep())) {
                        typeEnum = NoticeTypeEnum.ABNORMAL_SHIPPING;
                    } else if (opStep.equals(AbnormalStepEnum.ARRIVAL.getStep())) {
                        typeEnum = NoticeTypeEnum.ABNORMAL_ARRIVAL;
                    }
                    Date noticeTime = abnormalDO.getAbnEndTime();
                    for (String userId : userArray) {
                        if (!userId.equals(loginUserId.toString())) continue;
                        noticeList.add(addNotice(typeEnum, boxDO, noticeTime));
                    }
                }
            }
        }

        //3.agent提醒
        //查找已预装未设置agent的出货
        List<BoxDO> boxList = boxMapper.agentNoticeList();
        if (CollectionUtil.isNotEmpty(boxList)) {
            List<Long> shipmentIdList = boxList.stream()
                    .map(BoxDO::getId)
                    .collect(Collectors.toList());
            List<BoxApprovalDO> boxApprovalList = boxApprovalService.list(new LambdaQueryWrapperX<BoxApprovalDO>()
                    .in(BoxApprovalDO::getShipmentId, shipmentIdList)
                    .eq(BoxApprovalDO::getApprovalStatus, ApprovalResultStatusEnum.pass.getValue())
                    .eq(BoxApprovalDO::getApprovalType, BoxApprovalTypeEnum.PRELOAD.getType())
            );
            Map<Long, Long> boxNoticeIdMap = boxApprovalList.stream()
                    .collect(Collectors.toMap(BoxApprovalDO::getShipmentId, BoxApprovalDO::getNoticeUser, (v1, v2) -> v2));
            for (BoxDO boxDO : boxList) {
                String transportType = boxDO.getTransportType();
                if (CollectionUtil.isNotEmpty(transportTypeList)) {
                    if (!transportTypeList.contains(transportType)) continue;
                }

                Long noticeUserId = boxNoticeIdMap.get(boxDO.getId());
                if (!loginUserId.equals(noticeUserId)) continue;

                noticeList.add(addNotice(NoticeTypeEnum.AGENT, boxDO, null));
            }
        }

        //4.报关退场提醒
        List<BoxCustomsSplitDO> boxCustomsSplitList = boxCustomsSplitService.list(new LambdaQueryWrapper<BoxCustomsSplitDO>()
                .eq(BoxCustomsSplitDO::getDealStatus, 0)
        );
        if (CollectionUtil.isNotEmpty(boxCustomsSplitList)) {
            List<Long> shipmentIdList = boxCustomsSplitList.stream()
                    .map(BoxCustomsSplitDO::getShipmentId)
                    .collect(Collectors.toList());
            List<BoxDO> customsSplitBoxList = getBoxList(shipmentIdList);
            Map<Long, BoxDO> boxMap = customsSplitBoxList.stream()
                    .collect(Collectors.toMap(BoxDO::getId, v -> v));

            for (BoxCustomsSplitDO boxCustomsSplitDO : boxCustomsSplitList) {
                BoxDO boxDO = boxMap.get(boxCustomsSplitDO.getShipmentId());
                noticeList.add(addNotice(NoticeTypeEnum.CUSTOMS_SPLIT, boxDO, null, boxCustomsSplitDO.getId()));
            }
        }

        return noticeList;
    }

    private void checkAddNotice(Long notifyUserId, Long loginUserId, Long createUserId, BoxDO boxDO, NoticeTypeEnum typeEnum, List<BoxNoticeVO> noticeList, Date noticeTime) {
        if (notifyUserId > 0) {
            if (notifyUserId.equals(loginUserId)) {
                noticeList.add(addNotice(typeEnum, boxDO, noticeTime));
            }
        } else {
            if (createUserId.equals(loginUserId)) {
                noticeList.add(addNotice(typeEnum, boxDO, noticeTime));
            }
        }
    }

    private BoxNoticeVO addNotice(NoticeTypeEnum typeEnum, BoxDO boxDO, Date noticeTime) {
        return addNotice(typeEnum, boxDO, noticeTime, null);
    }

    private BoxNoticeVO addNotice(NoticeTypeEnum typeEnum, BoxDO boxDO, Date noticeTime, Long notifyId) {
        BoxNoticeVO boxNoticeVO = new BoxNoticeVO();
        BeanUtils.copyProperties(boxDO, boxNoticeVO);
        boxNoticeVO.setNotifyId(notifyId);
        boxNoticeVO.setNoticeType(typeEnum.getType());
        boxNoticeVO.setNoticeText(typeEnum.getText());
        boxNoticeVO.setCreateTime(noticeTime);
        return boxNoticeVO;
    }

    @Override
    public void generateBillLadingNo(Long shipmentId, boolean updateOrder, boolean tempSort) {
        boxPreloadGoodsService.generateBillLadingNo(shipmentId, updateOrder, tempSort);
    }

    @Override
    public BoxLoadOrderVO searchLoadOrderByBoxNo(BoxOrderSearchVO boxOrderSearchVO) {
        //根据shipment和secId，找到这个出货单部分下的所有订单商品
        Long shipmentId = boxOrderSearchVO.getShipmentId();
        String orderNumCode = boxOrderSearchVO.getOrderNumCode();

        Long orderId = boxLoadInfoService.getOrderIdByOrderNumCode(shipmentId, orderNumCode);
        if (orderId == null) {
            orderId = getOrderIdByOrderNo(orderNumCode);
        }
        if (orderId == null) {
            throw new ServiceException(500, "订单不在此出货单中");
        }
        return matchOrderInfo(shipmentId, orderId);
    }

    private Long getOrderIdByOrderNo(String orderNo) {
        //箱号没查到，查订单号
        OrderDO orderDO = orderService.getOne(new LambdaQueryWrapperX<OrderDO>()
                .eq(OrderDO::getOrderNo, orderNo)
                .last("limit 1")
        );
        if (orderDO != null) {
            return orderDO.getOrderId();
        }
        return null;
    }

    @Override
    public BoxLoadOrderVO searchOrderByBoxNo(BoxOrderSearchVO boxOrderSearchVO) {
        Long shipmentId = boxOrderSearchVO.getShipmentId();
        String orderNumCode = boxOrderSearchVO.getOrderNumCode();
        BoxLoadInfoQueryVO boxLoadInfoQueryVO = new BoxLoadInfoQueryVO();
        boxLoadInfoQueryVO.setShipmentId(shipmentId);
        List<BoxLoadInfoDO> loadInfoList = boxLoadInfoService.getBoxLoadInfoList(boxLoadInfoQueryVO);

        loadInfoList = loadInfoList.stream()
                .filter(t -> t.getOrderNumCode().equals(orderNumCode))
                .collect(Collectors.toList());

        Long orderId;
        if (CollectionUtil.isEmpty(loadInfoList)) {
            //箱号没查到，查订单号
            orderId = getOrderIdByOrderNo(orderNumCode);
        } else {
            orderId = loadInfoList.get(0).getOrderId();
        }

        if (orderId == null) {
            throw new ServiceException(500, "订单不在此出货单中");
        }

        return matchOrderInfo(shipmentId, orderId);
    }

    private BoxLoadOrderVO matchOrderInfo(Long shipmentId, Long orderId) {
        BoxLoadDetailBackVO boxLoadDetailBackVO = boxGoodsList(shipmentId, null, null, 0);
        List<BoxLoadOrderVO> sectionOrderList = boxLoadDetailBackVO.getSectionOrderList();
        BoxLoadOrderVO boxLoadOrderVO = null;
        if (CollectionUtil.isNotEmpty(sectionOrderList)) {
            Map<Long, BoxLoadOrderVO> orderMap = sectionOrderList.stream()
                    .collect(Collectors.toMap(BoxLoadOrderVO::getOrderId, (v -> v)));
            boxLoadOrderVO = orderMap.get(orderId);
        }

        if (boxLoadOrderVO == null) {
            throw new ServiceException(500, "箱号不在此出货单中");
        }
        return boxLoadOrderVO;
    }

    @Override
    public List<BoxExportVO> getExportBoxList(BoxQueryVO query) {
        PageVO page = new PageVO();
        page.setPage(1);
        page.setRows(Integer.MAX_VALUE);
        PageResult<BoxDO> pageResult = boxMapper.selectPage(page, query);
        List<BoxDO> list = pageResult.getList();

        DictDataPageReqVO pageReqVO = new DictDataPageReqVO();
        pageReqVO.setDictType("transport_type");
        pageReqVO.setPageNo(1);
        pageReqVO.setPageSize(100);
        PageResult<DictDataDO> dictPageResult = dictDataService.getDictDataPage(pageReqVO);
        List<DictDataDO> dictList = dictPageResult.getList();
        Map<String, String> dictMap = dictList.stream()
                .collect(Collectors.toMap(DictDataDO::getValue, DictDataDO::getLabel));

        List<BoxExportVO> exportList = new ArrayList<>();

        if (CollectionUtil.isNotEmpty(list)) {
            List<BoxBackVO> boxBackVOList = BoxConvert.INSTANCE.convertList(list);

            List<Long> shipmentIdList = boxBackVOList.stream()
                    .map(BoxBaseBackVO::getId)
                    .collect(Collectors.toList());

            Map<Long, BoxGoodsStatistics> allBoxStatistics = boxPreloadGoodsService.boxStatistics(shipmentIdList);

            List<CabinetDO> cabinetList = cabinetService.getCabinetList(new CabinetExportReqVO());

            Map<Long, CabinetDO> cabinetMap = cabinetList.stream()
                    .collect(Collectors.toMap(CabinetDO::getId, v -> v, (v1, v2) -> v2));

            for (BoxBackVO boxBackVO : boxBackVOList) {
                //设置柜型详情
                CabinetDO cabinetDO = cabinetMap.get(boxBackVO.getCabinetId());

                //统计信息
                BoxGoodsStatistics boxStatistics = allBoxStatistics.get(boxBackVO.getId());

                BoxExportVO exportVO = new BoxExportVO();
                exportVO.setSelfNo(boxBackVO.getSelfNo());
                exportVO.setCubNo(boxBackVO.getCubNo());
                if (cabinetDO != null) {
                    exportVO.setCabinet(cabinetDO.getName());
                }
                String volume = String.valueOf(boxStatistics.getVolume().floatValue());
                String loadVolume = String.valueOf(boxStatistics.getLoadVolume().floatValue());
                exportVO.setSquare(volume + "/" + loadVolume);

                String weight = String.valueOf(boxStatistics.getWeight().floatValue());
                String loadWeight = String.valueOf(boxStatistics.getLoadWeight().floatValue());
                exportVO.setWeight(weight + "/" + loadWeight);

                exportVO.setStatusName(boxBackVO.getShipmentStatusText());

                String date = DateUtil.format(boxBackVO.getCreateTime(), "yyyy-MM-dd HH:mm:ss");
                exportVO.setDate(date);

                String transportTypeName = dictMap.get(boxBackVO.getTransportType());
                exportVO.setTransportTypeName(transportTypeName);

                exportList.add(exportVO);
            }
        }
        return exportList;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void createPickUpException(Long shipmentId) {
        Set<Long> orderIdList = boxPreloadGoodsService.getShipOrderIdList(shipmentId);

        //订单不存在
        if (CollectionUtil.isEmpty(orderIdList)) return;

        for (Long orderId : orderIdList) {
            OrderBackVO backVO = orderQueryService.getOrder(orderId);
            Long lineId = backVO.getLineId();
            WarehouseLineDO lineDO = warehouseLineMapper.selectOne(new LambdaQueryWrapper<WarehouseLineDO>()
                    .eq(WarehouseLineDO::getId, lineId)
            );
            String services = lineDO.getOtherService();
            if (StringUtils.isEmpty(services)) continue;
            //5是提货异常服务
            if (!services.contains("5")) continue;
            //看看收货人是否是送货上门
            OrderConsigneeBackVO orderConsigneeDO = backVO.getConsigneeVO();
            //送货方式,2-送货上门
            Integer harvestMethod = Objects.nonNull(orderConsigneeDO) && Objects.nonNull(orderConsigneeDO.getHarvestMethod()) ? orderConsigneeDO.getHarvestMethod() : backVO.getHarvestMethod();
            if (harvestMethod == null || harvestMethod != 2) continue;

            //创建订单异常
            OrderExceptionCreateReqVO orderExceptionCreateReqVO = new OrderExceptionCreateReqVO();
            orderExceptionCreateReqVO.setOrderId(orderId);
//            orderExceptionCreateReqVO.setOrderItemId(createReqVO.getProductId());
            orderExceptionCreateReqVO.setOrderNumber(backVO.getOrderNo());

            orderExceptionCreateReqVO.setOrderExceptionType(OrderExceptionEnum.ORDER_PICK_UP_EXCEPTION.getKey());

            orderExceptionCreateReqVO.setOrderExceptionRemark("送货异常");
            OrderExceptionDescVO exceptionDescVO = new OrderExceptionDescVO();
            exceptionDescVO.setDescZh(orderExceptionCreateReqVO.getOrderExceptionRemark());
            exceptionDescVO.setDescEn(orderExceptionCreateReqVO.getOrderExceptionType());
            orderExceptionCreateReqVO.setOrderExceptionDescVO(exceptionDescVO);
            orderExceptionService.createOrderException(orderExceptionCreateReqVO);
        }

    }

    @Override
    public void checkApproval(Long shipmentId, Integer approvalType) {
        boxApprovalService.checkApproval(shipmentId, approvalType);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public List<OrderSplitBackVO> splitList(Long shipmentId, Long orderId) {
        //首先判断这个订单是否在拆单中
        checkApproval(shipmentId, null);

        //首先删除已经生成的拆单
        orderSplitService.removeByOrderId(orderId);

        OrderDO orderDO = orderService.getById(orderId);
        Long lineId = orderDO.getLineId();
        WarehouseLineDO warehouseLineDO = warehouseLineMapper.selectById(lineId);

        //然后插入拆单项
        OrderSplitCreateReqVO createReqVO = new OrderSplitCreateReqVO();
        createReqVO.setDstWarehouseId(warehouseLineDO.getDestWarehouseId());
        createReqVO.setParentOrderId(orderId);
        createReqVO.setParentOrderNo(orderDO.getOrderNo());
        createReqVO.setTransportId(orderDO.getTransportId());
        createReqVO.setChannelId(orderDO.getChannelId());
        createReqVO.setCheckOrderScheduling(false);
        orderSplitService.createSplit(createReqVO);

        //返回数据
        return orderSplitService.listByOrderId(orderId, 0);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void updateOrderSelfNoByShipmentId(Long shipmentId) {
        Set<Long> orderIdList = boxPreloadGoodsService.getShipOrderIdList(shipmentId);
        //订单不存在
        if (CollectionUtil.isEmpty(orderIdList)) return;
        BoxDO boxDO = boxMapper.selectById(shipmentId);

        for (Long orderId : orderIdList) {
            updateOrderSelfNo(orderId, boxDO.getSelfNo());
        }
    }

    @Override
    public void updateOrderSelfNo(Long orderId, String selfNo) {
        LambdaUpdateWrapper<OrderDO> updateWrapper = new LambdaUpdateWrapper<>();
        updateWrapper.eq(OrderDO::getOrderId, orderId);
        updateWrapper.set(OrderDO::getContainerNumber, selfNo);
        orderService.update(null, updateWrapper);
    }

    @Override
    public void checkPreInstallNum(Long shipmentId) {
        Set<Long> orderIdList = boxPreloadGoodsService.getShipOrderIdList(shipmentId);
        if (CollectionUtil.isEmpty(orderIdList)) {
            throw new ServiceException(500, "请先预装订单");
        }
    }

    @Override
    public void createPaymentException(Long shipmentId) {
        Set<Long> orderIdList = boxPreloadGoodsService.getShipOrderIdList(shipmentId);

        //订单不存在
        if (CollectionUtil.isEmpty(orderIdList)) return;

        for (Long orderId : orderIdList) {
            OrderDO orderDO = orderService.getById(orderId);
            Boolean isCargoControl = orderDO.getIsCargoControl();
            if (isCargoControl) continue;
            //非控货订单，检查线路是否开通代收货款

            Long lineId = orderDO.getLineId();
            WarehouseLineDO lineDO = warehouseLineMapper.selectOne(new LambdaQueryWrapper<WarehouseLineDO>()
                    .eq(WarehouseLineDO::getId, lineId)
            );
            String services = lineDO.getOtherService();
            if (StringUtils.isEmpty(services)) continue;
            // 3是非控货订单代收货款服务
            if (!services.contains("3")) continue;
            //订单未设置代收货款则跳过
            if (!orderDO.getIsCollection()) continue;

            //创建订单异常
            OrderExceptionCreateReqVO orderExceptionCreateReqVO = new OrderExceptionCreateReqVO();
            orderExceptionCreateReqVO.setOrderId(orderId);
//            orderExceptionCreateReqVO.setOrderItemId(createReqVO.getProductId());
            orderExceptionCreateReqVO.setOrderNumber(orderDO.getOrderNo());

            orderExceptionCreateReqVO.setOrderExceptionType(OrderExceptionEnum.ORDER_COD_EXCEPTION.getKey());
            orderExceptionCreateReqVO.setOrderExceptionAmount(orderDO.getCollectionProxy());
            if (orderDO.getCollectionProxyCurrency() != null) {
                orderExceptionCreateReqVO.setOrderExceptionAmountCurrencyId(orderDO.getCollectionProxyCurrency().longValue());
            }

            orderExceptionCreateReqVO.setOrderExceptionRemark("订单需要代收货款");
            OrderExceptionDescVO exceptionDescVO = new OrderExceptionDescVO();
            exceptionDescVO.setDescZh(orderExceptionCreateReqVO.getOrderExceptionRemark());
            exceptionDescVO.setDescEn(orderExceptionCreateReqVO.getOrderExceptionType());
            orderExceptionCreateReqVO.setOrderExceptionDescVO(exceptionDescVO);
            orderExceptionService.createOrderException(orderExceptionCreateReqVO);
        }
    }

    @Override
    public List<OrderItemDO> getOrderItemListByOrderIdList(List<Long> orderIdList) {
        return orderItemService.getOrderItemListByOrderIdList(orderIdList);
    }

    @Override
    public ProductPriceDO getProductPrice(Long proId, Long lineId, Long channelId) {
        return productPriceService.getProductPriceById(proId, lineId, channelId);
    }

    @Override
    public List<OrderApprovalDO> getOrderApprovalIng(Set<Long> oIdList) {
        return orderApprovalService.list(new LambdaQueryWrapperX<OrderApprovalDO>()
                .in(OrderApprovalDO::getOrderId, oIdList)
                .eq(OrderApprovalDO::getStatus, ApprovalResultStatusEnum.processing.getValue())
        );
    }

    /**
     * 根据订单项返回订单是否是多规格
     *
     * @param goodsList 商品订单项
     * @return
     */
    @Override
    public Boolean getMultiSpecification(List<BoxPreloadGoodsBackVO> goodsList) {
        for (BoxPreloadGoodsBackVO item : goodsList) {
            if (item.getMultiSpecification() != null && item.getMultiSpecification()) {
                return Boolean.TRUE;
            }
        }
        return Boolean.FALSE;
    }

    @Override
    public List<BoxLoadSectionBackVO> pdaTallyList(Long shipmentId) {
        List<BoxLoadSectionBackVO> secList = boxPreloadGoodsService.loadSecGoodsList(shipmentId);
        BoxDO box = this.getBox(shipmentId);
        //空运理货已理数据在另外一个表中  所以覆盖原来的已理数据
        if (TransportTypeEnum.AIR.getType().equals(box.getTransportType())) {
            List<BoxLoadOrderVO> boxLoadOrderVOS = secList.stream().flatMap(item -> item.getSectionOrderList().stream()).collect(Collectors.toList());
            boxLoadOrderVOS.stream().forEach(item -> {
                Long installNum = boxOrderCheckInfoService.selectCount(new LambdaQueryWrapperX<BoxOrderCheckInfoDO>()
                        .eq(BoxOrderCheckInfoDO::getShipmentId, shipmentId)
                        .eq(BoxOrderCheckInfoDO::getOrderId, item.getOrderId())
                        .eq(BoxOrderCheckInfoDO::getType, 0)
                );
                item.setInstallNum(installNum == null ? 0L : installNum);
                OrderDO orderDO = orderService.selectOne(OrderDO::getOrderId, item.getOrderId());
                item.setNum(orderDO.getSumNum());
            });
        }
        //查询所有库区库域信息
        List<WarehouseAreaDO> areaList = warehouseAreaService.list(new LambdaQueryWrapper<>());
        List<WarehouseAreaPositionDO> positionList = warehouseAreaPositionService.list(new LambdaQueryWrapper<>());
        for (BoxLoadSectionBackVO sectionBackVO : secList) {
            List<BoxLoadOrderVO> orderList = sectionBackVO.getSectionOrderList();
            if (CollectionUtil.isEmpty(orderList)) continue;
            for (BoxLoadOrderVO orderVO : orderList) {
                Long orderId = orderVO.getOrderId();
                List<OrderLocationDO> orderLocationLists = orderLocationService.getOrderLocationListByOrderId(orderId);

                //按照订单纬度返回信息，分组
                Map<String, List<OrderLocationDO>> positionMap = orderLocationLists.stream()
                        .collect(Collectors.groupingBy(
                                t -> t.getOrderId() + "_" +
//                                        t.getOrderItemId() + "_" +
                                        t.getWareId() + "_" + t.getAreaId() + "_" + t.getLocationId()));
                List<OrderLocationDO> locationList = new ArrayList<>();
                for (Map.Entry<String, List<OrderLocationDO>> entry : positionMap.entrySet()) {
                    List<OrderLocationDO> orderLocationDOList = entry.getValue();
                    locationList.add(orderLocationDOList.get(0));
                }

                String positionNo = matchLocation(areaList, positionList, locationList);
                orderVO.setPositionNo(positionNo);
                orderVO.setOrderLocationList(OrderLocationConvert.INSTANCE.convertList(locationList));


                List<BoxPreloadGoodsBackVO> orderGoodsItemList = orderVO.getGoodsList();
                for (BoxPreloadGoodsBackVO itemVO : orderGoodsItemList) {
                    matchItemLocation(areaList, positionList, locationList, itemVO);
                }
            }
        }
        return secList;
    }

    @Override
    public List<BoxAbnormalDO> getAbnormalList(Long shipmentId) {
        BoxDO boxDO = getBox(shipmentId);
        boolean airShipment = boxDO.getTransportType().equals(TransportTypeEnum.AIR.getType());
        List<Integer> opStepList = AbnormalStepEnum.getStepList();
        if (airShipment) {
            opStepList = AbnormalStepAirEnum.getStepList();
        }
        return boxAbnormalService.list(new LambdaQueryWrapper<BoxAbnormalDO>()
                .in(BoxAbnormalDO::getOpStep, opStepList)
                .eq(shipmentId != null, BoxAbnormalDO::getShipmentId, shipmentId)
                .eq(BoxAbnormalDO::getDealStatus, 0)
        );
    }

    @Override
    public List<BoxAbnormalDO> getAbnormalList(boolean airShipment) {
        List<Integer> opStepList = AbnormalStepEnum.getStepList();
        if (airShipment) {
            opStepList = AbnormalStepAirEnum.getStepList();
        }
        return boxAbnormalService.list(new LambdaQueryWrapper<BoxAbnormalDO>()
                .in(BoxAbnormalDO::getOpStep, opStepList)
                .eq(BoxAbnormalDO::getDealStatus, 0)
        );
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void updateAbnormalOrder(OrderDealReqVO dealReqVO) {
        Long shipmentId = dealReqVO.getShipmentId();
        BoxDO boxDO = getBox(shipmentId);
        if (boxDO.getTransportType().equals(TransportTypeEnum.AIR.getType())) {
            updateAbnormalOrderAir(dealReqVO);
            return;
        }

        List<BoxAbnormalDO> abnormalList = getAbnormalList(shipmentId);
        if (CollectionUtil.isEmpty(abnormalList)) {
            throw new ServiceException(500, "出货单无异常");
        }
        List<Long> orderIdList = dealReqVO.getOrderIdList();
        String text = dealReqVO.getText();
        Integer type = dealReqVO.getType();

        Set<Long> orderIdSet = boxPreloadGoodsService.getShipOrderIdList(shipmentId);
        BoxAbnormalDO boxAbnormalDO = abnormalList.get(0);


        String typeName = "";
        if (boxAbnormalDO.getOpStep().equals(AbnormalStepEnum.CUSTOMS.getStep())) {
            typeName = "报关异常：";
        } else if (boxAbnormalDO.getOpStep().equals(AbnormalStepEnum.SHIPPING.getStep())) {
            typeName = "起运异常：";
        } else if (boxAbnormalDO.getOpStep().equals(AbnormalStepEnum.ARRIVAL.getStep())) {
            typeName = "到港异常：";
        }
        String statusText = typeName + text;// + "," + boxAbnormalDO.getDelayDays() + "天";

        String dealIdStr = boxAbnormalDO.getDealOrderIds();
        Set<Long> dealIdSet = new HashSet<>();
        if (StringUtils.isNotEmpty(dealIdStr)) {
            String[] dealIdArray = dealIdStr.split(",");
            for (String dealId : dealIdArray) {
                dealIdSet.add(Long.valueOf(dealId));
            }
        }

        dealIdSet.addAll(orderIdList);
        dealIdStr = Joiner.on(",").join(dealIdSet);
        boxAbnormalDO.setDealOrderIds(dealIdStr);
        if (orderIdSet.size() == dealIdSet.size()) {
            //修改为已处理
            boxAbnormalDO.setDealStatus(1);
        }
        boxAbnormalService.updateById(boxAbnormalDO);

        //需要更新订单
        if (type == 1) {
            for (Long orderId : orderIdList) {
                OrderRemindExceptionDto orderRemindExceptionDto = new OrderRemindExceptionDto();
                orderRemindExceptionDto.setType(OrderRemindExceptionEnum.CUSTOMS.getType());
                orderRemindExceptionDto.setReason(statusText);
                orderBusinessService.handleOrderRemindException(orderId, Collections.singletonList(orderRemindExceptionDto));
            }
        }
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void updateAbnormalOrderAir(OrderDealReqVO dealReqVO) {
        Long shipmentId = dealReqVO.getShipmentId();
        List<BoxAbnormalDO> abnormalList = getAbnormalList(shipmentId);
        if (CollectionUtil.isEmpty(abnormalList)) {
            throw new ServiceException(500, "出货单无异常");
        }
        List<Long> orderIdList = dealReqVO.getOrderIdList();
        String text = dealReqVO.getText();
        Integer type = dealReqVO.getType();

        Set<Long> orderIdSet = boxPreloadGoodsService.getShipOrderIdList(shipmentId);
        BoxAbnormalDO boxAbnormalDO = abnormalList.get(0);


        String typeName = "";
        if (boxAbnormalDO.getOpStep().equals(AbnormalStepAirEnum.CUSTOMS.getStep())) {
            typeName = "报关异常：";
        } else if (boxAbnormalDO.getOpStep().equals(AbnormalStepAirEnum.FLYING.getStep())) {
            typeName = "起飞异常：";
        } else if (boxAbnormalDO.getOpStep().equals(AbnormalStepAirEnum.ARRIVAL.getStep())) {
            typeName = "到港异常：";
        }
        String statusText = typeName + text;// + "," + boxAbnormalDO.getDelayDays() + "天";

        String dealIdStr = boxAbnormalDO.getDealOrderIds();
        Set<Long> dealIdSet = new HashSet<>();
        if (StringUtils.isNotEmpty(dealIdStr)) {
            String[] dealIdArray = dealIdStr.split(",");
            for (String dealId : dealIdArray) {
                dealIdSet.add(Long.valueOf(dealId));
            }
        }

        dealIdSet.addAll(orderIdList);
        dealIdStr = Joiner.on(",").join(dealIdSet);
        boxAbnormalDO.setDealOrderIds(dealIdStr);
        if (orderIdSet.size() == dealIdSet.size()) {
            //修改为已处理
            boxAbnormalDO.setDealStatus(1);
        }
        boxAbnormalService.updateById(boxAbnormalDO);

        //需要更新订单
        if (type == 1) {
            for (Long orderId : orderIdList) {
                OrderRemindExceptionDto orderRemindExceptionDto = new OrderRemindExceptionDto();
                orderRemindExceptionDto.setType(OrderRemindExceptionEnum.CUSTOMS.getType());
                orderRemindExceptionDto.setReason(statusText);
                orderBusinessService.handleOrderRemindException(orderId, Collections.singletonList(orderRemindExceptionDto));
            }
        }
    }

    @Override
    public List<OrderBackPageVO> customsOrderList(Long shipmentId, String customsTypes) {
        Set<Long> orderIdList = boxPreloadGoodsService.getShipOrderIdList(shipmentId);
        if (CollectionUtil.isNotEmpty(orderIdList)) {
            OrderQueryVO queryVO = new OrderQueryVO();
            queryVO.setOrderIdList(new ArrayList<>(orderIdList));
            PageVO pageVO = new PageVO();
            pageVO.setPage(1);
            pageVO.setRows(10000);
            List<OrderBackPageVO> orderList = orderQueryService.orderPage(queryVO, pageVO).getList();
            if (StringUtils.isEmpty(customsTypes)) {
                return orderList;
            }
            String[] customsTypeArray = customsTypes.split(",");
            List<Integer> customsTypeList = new ArrayList<>();
            for (String customsTypeStr : customsTypeArray) {
                customsTypeList.add(Integer.valueOf(customsTypeStr));
            }
            orderList = orderList.stream()
                    .filter(t -> t.getCustomsType() != null)
                    .filter(t -> customsTypeList.contains(t.getCustomsType()))
                    .collect(Collectors.toList());
            return orderList;
        }
        return null;
    }

    @Override
    public void resetOrderTidanNo(Long orderId, boolean hasExit) {
        resetOrderTidanNo(orderId, true, hasExit);
    }

    @Override
    public void resetOrderTidanNo(Long orderId, boolean clearContainerNo, boolean hasExit) {
        orderService.update(null, Wrappers.<OrderDO>lambdaUpdate()
                .set(OrderDO::getTidanNo, null)
                .set(hasExit, OrderDO::getHasExitAndEntry, true)
                .set(clearContainerNo, OrderDO::getContainerNumber, null)
                .eq(OrderDO::getOrderId, orderId)
        );
    }

    @Override
    public void buildSpecialReceivable(Long shipmentId) {
        Set<Long> orderIdSet = boxPreloadGoodsService.getShipOrderIdList(shipmentId);
        for (Long orderId : orderIdSet) {
            orderSpecialNeedService.buildSpecialReceivable(orderId, 2);
        }
    }

    @Override
    public void sendCabinetMessage(Long shipmentId) {
        BoxBookSeaDO boxBookSeaDO = boxBookSeaService.getOne(new LambdaQueryWrapperX<BoxBookSeaDO>()
                .eq(BoxBookSeaDO::getShipmentId, shipmentId).orderByDesc(BoxBookSeaDO::getCreateTime).last(" limit 1"));
        String sailTime = DateUtils.formatDateTime(boxBookSeaDO.getSailTime());
        BoxDO boxDO = getBox(shipmentId);
        Set<Long> orderIdSet = boxPreloadGoodsService.getShipOrderIdList(shipmentId);
        for (Long orderId : orderIdSet) {
            orderInternalMessage(orderId, boxDO.getSelfNo(), sailTime, BoxStatusEnum.SEAL_EXAMINE_SUCCESS, Integer.parseInt(boxDO.getTransportType()));
        }
    }

    @Override
    public void sendPreloadMessage(Long shipmentId) {
        BoxApprovalDO boxApprovalDO = boxApprovalService.getOne(new LambdaQueryWrapper<BoxApprovalDO>()
                .eq(BoxApprovalDO::getShipmentId, shipmentId)
                .eq(BoxApprovalDO::getApprovalType, BoxApprovalTypeEnum.PRELOAD.getType())
                .last("limit 1")
                .orderByAsc(BoxApprovalDO::getId)
        );
        if (boxApprovalDO == null) return;
        Long noticeUserId = boxApprovalDO.getNoticeUser();
        if (noticeUserId == null) return;
        BoxDO boxDO = getBox(shipmentId);
        InternalMessageCreateDto dto = InternalMessageCreateDto.builder()
                .toIdList(Collections.singletonList(noticeUserId))
                .fromId("")
                .sendTime(new Date())
                .title("预装审核通过")
                .content("自编号:" + boxDO.getSelfNo() + "预装审核通过")
                .type(1).build();
        clientInternalMessageApi.createInternalMessage(dto);
    }

    @Override
    public void shipmentInternalMessage(Long shipmentId, String selfNo, String date, BoxStatusEnum boxStatusEnum, Integer transportType) {
        Set<Long> orderIdSet = boxPreloadGoodsService.getShipOrderIdList(shipmentId);
        for (Long orderId : orderIdSet) {
            orderInternalMessage(orderId, selfNo, date, boxStatusEnum, transportType);
        }
    }

    @Override
    public void shipmentAirInternalMessage(Long shipmentId, String selfNo, String date, BoxAirStatusEnum boxAirStatusEnum, Integer transportType) {
        Set<Long> orderIdSet = boxPreloadGoodsService.getShipOrderIdList(shipmentId);
        for (Long orderId : orderIdSet) {
            orderAirInternalMessage(orderId, selfNo, date, boxAirStatusEnum, transportType);
        }
    }

    @Override
    public void shipmentAirOrderInternalMessage(Collection<Long> orderList, String selfNo, String date, BoxAirStatusEnum boxAirStatusEnum, Integer transportType) {
        for (Long orderId : orderList) {
            orderAirInternalMessage(orderId, selfNo, date, boxAirStatusEnum, transportType);
        }
    }

    private void orderInternalMessage(Long orderId, String selfNo, String date, BoxStatusEnum boxStatusEnum, Integer transportType) {
        try {
            OrderDO orderDO = orderService.getById(orderId);
            OrderConsignorDO orderConsignorDO = orderConsignorService.getOne(new LambdaQueryWrapper<OrderConsignorDO>()
                    .eq(OrderConsignorDO::getOrderId, orderId)
                    .orderByDesc(OrderConsignorDO::getId)
                    .last("limit 1"));

            // 1.非控货-收件人、发货人手机号对应会员
            // 2.控货：控货方和收货方
            Set<Long> internalMsgUserIdSet = new HashSet<>();
            if (orderDO.getUserId() != null) {
                internalMsgUserIdSet.add(orderDO.getUserId());
            }

            //发货人
            Long consignorUserId = getUserId(orderConsignorDO.getCustomerId());
            if (consignorUserId != null) {
                internalMsgUserIdSet.add(consignorUserId);
            }

            //收货人
            OrderConsigneeDO orderConsigneeDO = orderConsigneeService.getOne(new LambdaQueryWrapper<OrderConsigneeDO>().eq(OrderConsigneeDO::getOrderId, orderDO.getOrderId())
                    .orderByDesc(OrderConsigneeDO::getId).last("limit 1"));
            if (orderConsigneeDO.getCustomerId() != null) {
                Long consigneeUserId = getUserId(orderConsigneeDO.getCustomerId());
                if (consigneeUserId != null) {
                    internalMsgUserIdSet.add(consigneeUserId);
                }
            }

            Set<Long> controlSet = new HashSet<>();

            //控货 就发给控货人
            if (orderDO.getIsCargoControl()) {
                OrderCargoControlDO orderCargoControlDO = orderCargoControlService.getActualOrderCargoControlByOrderId(orderDO.getOrderId());
                Long cargoControlUserId = getUserId(orderCargoControlDO.getCustomerId());
                if (cargoControlUserId != null) {
                    internalMsgUserIdSet.add(consignorUserId);
                    controlSet.add(cargoControlUserId);
                }
            }
            // TODO 站内信如果有中英文，这里的获取标题与文案业务需要修改
            String content = "";
            String title = "";
            String controlContent = "";
            switch (boxStatusEnum) {
                case SEAL_EXAMINE_SUCCESS:
                    title = String.format(I18nMessage.getMessage("app.message.cabinet.title"),
                            orderDO.getOrderNo());
                    content = String.format(I18nMessage.getMessage("app.message.cabinet.content"),
                            orderDO.getOrderNo(), orderDO.getMarks(), selfNo, date);
                    break;

                case SHIPPING:
                    title = String.format(I18nMessage.getMessage("app.message.shipping.title"),
                            orderDO.getOrderNo(), orderDO.getMarks(), selfNo);
                    content = String.format(I18nMessage.getMessage("app.message.shipping.content"),
                            orderDO.getOrderNo(), orderDO.getMarks(), selfNo, date);
                    break;

                case ARRIVAL_WAIT_DISCHARGE:
                    title = String.format(I18nMessage.getMessage("app.message.arrival.title"),
                            orderDO.getOrderNo());
                    content = String.format(I18nMessage.getMessage("app.message.arrival.content"),
                            orderDO.getOrderNo(), orderDO.getMarks());
                    break;

                case CLEARANCE_WAIT_UNLOAD:
                    title = String.format(I18nMessage.getMessage("app.message.clearance.title"),
                            orderDO.getOrderNo());
                    content = String.format(I18nMessage.getMessage("app.message.clearance.content"),
                            orderDO.getOrderNo(), orderDO.getMarks());
                    break;

                case UNLOADED:
                    title = String.format(I18nMessage.getMessage("app.message.unload.title"),
                            orderDO.getOrderNo());
                    content = String.format(I18nMessage.getMessage("app.message.unload.content"),
                            orderDO.getOrderNo(), orderDO.getMarks());
                    controlContent = String.format(I18nMessage.getMessage("app.message.unload.cargocontrol.content"),
                            orderDO.getOrderNo(), orderDO.getMarks());
                    break;
            }


            if (CollectionUtil.isNotEmpty(internalMsgUserIdSet)) {
                for (Long userId : internalMsgUserIdSet) {
                    UserRespDTO user = memberUserApi.getUser(userId);
                    if (user != null) {
                        //发送站内信
                        if (controlSet.contains(userId) && boxStatusEnum == UNLOADED) {
                            content = controlContent;
                        }
                        InternalMessageCreateDto dto = InternalMessageCreateDto.builder()
                                .toIdList(Collections.singletonList(userId))
                                .fromId("")
                                .sendTime(new Date())
                                .title(title)
                                .content(content)
                                .type(1).build();
                        clientInternalMessageApi.createInternalMessage(dto);
                    }
                }
            }
        } catch (Exception e) {
            log.error("出货发送短信出现异常", e);
        }
    }


    private void orderAirInternalMessage(Long orderId, String selfNo, String date, BoxAirStatusEnum boxAirStatusEnum, Integer transportType) {
        try {
            OrderDO orderDO = orderService.getById(orderId);
            OrderConsignorDO orderConsignorDO = orderConsignorService.getOne(new LambdaQueryWrapper<OrderConsignorDO>()
                    .eq(OrderConsignorDO::getOrderId, orderId)
                    .orderByDesc(OrderConsignorDO::getId)
                    .last("limit 1"));

            // 1.非控货-收件人、发货人手机号对应会员
            // 2.控货：控货方和收货方
            Set<Long> internalMsgUserIdSet = new HashSet<>();
            if (orderDO.getUserId() != null) {
                internalMsgUserIdSet.add(orderDO.getUserId());
            }

            //发货人
            Long consignorUserId = getUserId(orderConsignorDO.getCustomerId());
            if (consignorUserId != null) {
                internalMsgUserIdSet.add(consignorUserId);
            }

            //收货人
            OrderConsigneeDO orderConsigneeDO = orderConsigneeService.getOne(new LambdaQueryWrapper<OrderConsigneeDO>().eq(OrderConsigneeDO::getOrderId, orderDO.getOrderId())
                    .orderByDesc(OrderConsigneeDO::getId).last("limit 1"));
            if (orderConsigneeDO.getCustomerId() != null) {
                Long consigneeUserId = getUserId(orderConsigneeDO.getCustomerId());
                if (consigneeUserId != null) {
                    internalMsgUserIdSet.add(consigneeUserId);
                }
            }

            Set<Long> controlSet = new HashSet<>();

            //控货 就发给控货人
            if (orderDO.getIsCargoControl()) {
                OrderCargoControlDO orderCargoControlDO = orderCargoControlService.getActualOrderCargoControlByOrderId(orderDO.getOrderId());
                Long cargoControlUserId = getUserId(orderCargoControlDO.getCustomerId());
                if (cargoControlUserId != null) {
                    internalMsgUserIdSet.add(consignorUserId);
                    controlSet.add(cargoControlUserId);
                }
            }
            // TODO 站内信如果有中英文，这里的获取标题与文案业务需要修改
            String content = "";
            String title = "";
            String controlContent = "";
            switch (boxAirStatusEnum) {
                case WAREHOUSED:
                    // 订单关联出货单出仓
                    title = String.format(I18nMessage.getMessage("app.message.warehoused.title"),
                            orderDO.getOrderNo());
                    content = String.format(I18nMessage.getMessage("app.message.warehoused.content"),
                            orderDO.getOrderNo(), orderDO.getMarks(), selfNo, date);
                    break;
                case FLYING:
                    // 订单关联出货单起飞
                    title = String.format(I18nMessage.getMessage("app.message.flying.title"),
                            orderDO.getOrderNo(), orderDO.getMarks(), selfNo);
                    content = String.format(I18nMessage.getMessage("app.message.flying.content"),
                            orderDO.getOrderNo(), orderDO.getMarks(), selfNo, date);
                    break;

                case ARRIVAL_WAIT_DISCHARGE:
                    // 订单关联出货单到港
                    title = String.format(I18nMessage.getMessage("app.message.air.arrival.title"),
                            orderDO.getOrderNo());
                    content = String.format(I18nMessage.getMessage("app.message.air.arrival.content"),
                            orderDO.getOrderNo(), orderDO.getMarks());
                    break;

                case CLEARANCE_WAIT_WAREHOUSE:
                    // 订单关联出货单清关完成
                    title = String.format(I18nMessage.getMessage("app.message.air.clearance.title"),
                            orderDO.getOrderNo());
                    content = String.format(I18nMessage.getMessage("app.message.air.clearance.content"),
                            orderDO.getOrderNo(), orderDO.getMarks());
                    break;

                case TO_WAREHOUSED:
                    // 订单关联出货单到仓，订单为控货订单
                    title = String.format(I18nMessage.getMessage("app.message.to.warehoused.title"),
                            orderDO.getOrderNo());
                    content = String.format(I18nMessage.getMessage("app.message.to.warehoused.content"),
                            orderDO.getOrderNo(), orderDO.getMarks());
                    controlContent = String.format(I18nMessage.getMessage("app.message.to.warehoused.cargo.control.content"),
                            orderDO.getOrderNo(), orderDO.getMarks());
                    break;
            }


            if (CollectionUtil.isNotEmpty(internalMsgUserIdSet)) {
                for (Long userId : internalMsgUserIdSet) {
                    UserRespDTO user = memberUserApi.getUser(userId);
                    if (user != null) {
                        //发送站内信
                        if (controlSet.contains(userId) && boxAirStatusEnum == TO_WAREHOUSED) {
                            content = controlContent;
                        }
                        InternalMessageCreateDto dto = InternalMessageCreateDto.builder()
                                .toIdList(Collections.singletonList(userId))
                                .fromId("")
                                .sendTime(new Date())
                                .title(title)
                                .content(content)
                                .type(1).build();
                        clientInternalMessageApi.createInternalMessage(dto);
                    }
                }
            }
        } catch (Exception e) {
            log.error("出货发送短信出现异常", e);
        }
    }

    private Long getUserId(Long customerId) {
        List<CustomerContactsDO> customerContactsList = customerContactsService.getCustomerContactsListByCustomerId(customerId);
        if (CollectionUtil.isNotEmpty(customerContactsList)) {
            return customerContactsList.stream().filter(t -> t.getIsDefault().equals(1))
                    .map(CustomerContactsDO::getUserid).filter(Objects::nonNull).findFirst().orElse(null);
        }
        return null;
    }

    @Override
    public BoxCabinetDO getBoxCabinetDO(Long shipmentId) {
        return boxCabinetService.getByShipmentId(shipmentId);
    }

    @Override
    public BoxCabinetUnloadDO getBoxCabinetUnloadDO(Long shipmentId) {
        return boxCabinetUnloadService.getByShipmentId(shipmentId);
    }

    @Override
    public void clearOrderTidanNo(Long shipmentId, boolean clearContainerNo) {
        Set<Long> orderIdSet = boxPreloadGoodsService.getShipOrderIdList(shipmentId);
        //订单不存在
        if (CollectionUtil.isEmpty(orderIdSet)) return;

        for (Long orderId : orderIdSet) {
            resetOrderTidanNo(orderId, clearContainerNo, false);
        }
    }

    @Override
    public BoxDO checkOrderScheduling(Long orderId) {
        List<BoxPreloadGoodsDO> goodItemList = boxPreloadGoodsService.list(new LambdaQueryWrapperX<BoxPreloadGoodsDO>()
                .eq(BoxPreloadGoodsDO::getOrderId, orderId)
                .eq(BoxPreloadGoodsDO::getIsRemove, 0)
        );
        if (CollectionUtil.isNotEmpty(goodItemList)) {
            Long shipmentId = goodItemList.get(0).getShipmentId();
            return getBox(shipmentId);
        }
        return null;
    }

    @Override
    public void updateOrderArriveTime(String selfNo, Integer transportId, Date estTime) {
        orderTimeService.updateOrderEstShippingTime(selfNo, transportId, estTime);
    }

    @Override
    public void updateOrderSailTime(Long shipmentId, Integer transportId, Date sailTime) {
        BoxDO boxDO = getBox(shipmentId);
        orderTimeService.updateOrderEstBookSeaTime(boxDO.getSelfNo(), transportId, sailTime);
    }

    @Override
    @Async
    public void addOrderLog(Collection<Long> orderIdList, OrderShipmentLog orderShipmentLog, String message) {
        String extraMessage = StringUtils.isNotEmpty(message) ? "【" + message + "】" : "";
        for (Long orderId : orderIdList) {
            orderBusinessService.addOrderOperateLog(orderId, "出货操作", orderShipmentLog.getType() + extraMessage, "");
        }
    }

    @Override
    public void addOrderLogByShipmentId(Long shipmentId, OrderShipmentLog cabinetUnload, String message) {
        Set<Long> set = boxPreloadGoodsService.getShipOrderIdList(shipmentId);
        addOrderLog(new ArrayList<>(set), cabinetUnload, message);
    }

    @Override
    public void deleteSplitItem(Long orderId) {
        orderSplitService.removeByOrderId(orderId);
    }

    @Override
    @Async
    public void addInstallCompleteLog(Long shipmentId) {
        BoxGoodsStatistics boxStatistics = boxPreloadGoodsService.getBoxStatistics(shipmentId);
        long numSum = boxStatistics.getNum();
        long installNum = boxStatistics.getLoadNum();
        if (numSum == installNum) {
            //完成装柜日志
            addOrderLogByShipmentId(shipmentId, OrderShipmentLog.CABINET_COMPLETE, "");
        }
    }

    @Override
    public void updateTrailerCubNo(BoxDO boxDO) {
        List<BoxTrailerDO> trailerDOList = boxTrailerService.list(new LambdaQueryWrapperX<BoxTrailerDO>()
                .eq(BoxTrailerDO::getShipmentId, boxDO.getId())
        );
        trailerDOList.forEach(t -> {
            t.setTlContainerNo(boxDO.getCubNo());
        });
        boxTrailerService.updateBatch(trailerDOList);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void removeLadingBill(Collection<Long> orderIdList) {
        makeBillOfLadingService.clearOrderBillLadingByOrderIds(orderIdList);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void clearLadingBill(Long shipmentId) {
        Set<Long> orderIdSets = boxPreloadGoodsService.getShipOrderIdList(shipmentId);
        removeLadingBill(orderIdSets);
    }

    @Override
    public long getUnWriteOffCount(Long shipmentId) {
        Set<Long> orderIdSet = boxPreloadGoodsService.getShipOrderIdList(shipmentId);
        return orderService.getUnWriteOffCount(orderIdSet);
    }

    @Override
    public List<Long> checkOrdersScheduling(List<Long> orderIds) {
        List<BoxPreloadGoodsDO> preloadGoodsDOList = boxPreloadGoodsService.list(new LambdaQueryWrapperX<BoxPreloadGoodsDO>()
                .in(BoxPreloadGoodsDO::getOrderId, orderIds)
                .eq(BoxPreloadGoodsDO::getIsRemove, 0)
        );
        if (CollectionUtil.isNotEmpty(preloadGoodsDOList)) {
            return preloadGoodsDOList.stream().map(BoxPreloadGoodsDO::getOrderId).collect(Collectors.toList());
        }
        return null;
    }

    @Override
    public List<OrderSplitBackVO> partRefundSplitList(Long shipmentId, Long orderId) {
        //首先判断这个订单是否在拆单中
        checkApproval(shipmentId, null);
        BoxOrderExitDO orderExitDO = boxOrderExitService.getOne(new LambdaQueryWrapper<BoxOrderExitDO>()
                .eq(BoxOrderExitDO::getOrderId, orderId)
                .eq(BoxOrderExitDO::getShipmentId, shipmentId)
                .orderByDesc(BoxOrderExitDO::getId).last("limit 1"));
        if (Objects.isNull(orderExitDO)) {
            throw exception(THIS_ORDER_NOT_PART_REFUND_ORDER);
        }
        if (orderExitDO.getSplitStatus() == 0) {
            throw exception(THIS_ORDER_NOT_BE_PART_REFUND);
        }
        if (orderExitDO.getSplitStatus() == 2) {
            throw exception(THIS_ORDER_PART_REFUND_PENDING);
        }
        if (orderExitDO.getSplitStatus() == 3) {
            throw exception(THIS_ORDER_PART_REFUND_FINISH);
        }
        //首先删除已经生成的拆单
        orderSplitService.removeByOrderId(orderId);

        OrderDO orderDO = orderService.getById(orderId);
        Long lineId = orderDO.getLineId();
        WarehouseLineDO warehouseLineDO = warehouseLineMapper.selectById(lineId);

        //然后插入拆单项
        OrderSplitCreateReqVO createReqVO = new OrderSplitCreateReqVO();
        createReqVO.setDstWarehouseId(warehouseLineDO.getDestWarehouseId());
        createReqVO.setParentOrderId(orderId);
        createReqVO.setParentOrderNo(orderDO.getOrderNo());
        createReqVO.setTransportId(orderDO.getTransportId());
        createReqVO.setChannelId(orderDO.getChannelId());
        createReqVO.setCheckOrderScheduling(false);
        createReqVO.setPartRefundSplit(true);
        createReqVO.setRefundNum(orderExitDO.getRefundNum());
        orderSplitService.createSplit(createReqVO);

        //返回数据
        return orderSplitService.listByOrderId(orderId, 0);
    }


    @Override
    public void createCustomsSplitNotify(Long shipmentId, List<Long> orderIdList, Integer type) {
        BoxCustomsSplitDO boxCustomsSplitDO = new BoxCustomsSplitDO();
        boxCustomsSplitDO.setShipmentId(shipmentId);
        boxCustomsSplitDO.setType(type);
        boxCustomsSplitDO.setSplitOrderIds(Joiner.on(",").join(orderIdList));
        boxCustomsSplitService.save(boxCustomsSplitDO);
    }

    @Override
    public void dealCustomsSplitNotify(Long notifyId) {
        LambdaUpdateWrapper<BoxCustomsSplitDO> updateWrapper = new LambdaUpdateWrapper<>();
        updateWrapper.eq(BoxCustomsSplitDO::getId, notifyId);
        updateWrapper.set(BoxCustomsSplitDO::getDealStatus, 1);
        boxCustomsSplitService.update(null, updateWrapper);
    }

    @Override
    public void splitConsistencyCheck(List<OrderSplitItemDO> orderSplitItemDOList, Integer allNum, Integer quantity, BigDecimal weight, BigDecimal volume, BigDecimal chargeWeight, BigDecimal chargeVolume, BigDecimal chargeQuantity) {
        orderSplitCheckService.splitConsistencyCheck(orderSplitItemDOList, allNum, Objects.isNull(quantity) ? 0 : quantity, weight, volume, chargeWeight, chargeVolume, chargeQuantity);
    }

    @Override
    public void splitWorthConsistencyCheck(List<OrderSplitItemDO> orderAllSplitItemDOList, BigDecimal worth) {

    }

    @Override
    public void checkOrdersApprovaling(Long shipmentId, OrderApprovalTypeEnum orderApprovalTypeEnum) {
        Set<Long> orderIdSet = boxPreloadGoodsService.getShipOrderIdList(shipmentId);
        if (CollectionUtil.isEmpty(orderIdSet)) return;
        List<OrderDO> orderDOList = orderQueryService.getOrderList(orderIdSet);
        List<String> orderNoList = new ArrayList<>();
        orderDOList = orderDOList.stream()
                .filter(t -> t.getAuditType() != 0)
                .collect(Collectors.toList());
        for (OrderDO orderDO : orderDOList) {
            OrderApprovalTypeCheckEvent approvalTypeCheckEvent = new OrderApprovalTypeCheckEvent(orderDO.getOrderId(), null, orderApprovalTypeEnum.getValue(), null,false);
            applicationContext.publishEvent(approvalTypeCheckEvent);
            if (approvalTypeCheckEvent.getResult()) {
                orderNoList.add(orderDO.getOrderNo());
            }
        }
        if (CollectionUtil.isNotEmpty(orderNoList) && orderNoList.size() > 0) {
            String orderNoStrs = Joiner.on(",").join(orderNoList);
            throw new ServiceException(500, "出货有订单(" + orderNoStrs + ")在审核中");
        }
    }

    @Override
    public void splitUsed(Long spiltId) {
        orderSplitItemMapper.update(null, new LambdaUpdateWrapper<OrderSplitItemDO>().set(OrderSplitItemDO::getUsed, Boolean.TRUE).eq(OrderSplitItemDO::getOrderSplitId, spiltId));
        orderSplitService.update(new LambdaUpdateWrapper<OrderSplitDO>().set(OrderSplitDO::getUsed, Boolean.TRUE).eq(OrderSplitDO::getId, spiltId));
    }

    @Override
    public List<BoxNoticeVO> airNoticeList(BoxQueryVO boxQueryVO) {

        List<BoxNoticeVO> noticeList = new ArrayList<>();
        List<String> transportTypeList = boxQueryVO.getTransportTypeList();
        Long loginUserId = SecurityFrameworkUtils.getLoginUserId();

        //首先找到所有没有起运的出货列表
        List<BoxBookAirDO> boxBookList = boxBookAirService.getNoticeBookList();

        //1.出货时间相关提醒
        if (CollectionUtil.isNotEmpty(boxBookList)) {
            List<Long> shipmentIdList = boxBookList.stream()
                    .map(BoxBookAirDO::getShipmentId)
                    .collect(Collectors.toList());
            List<BoxDO> boxList = getBoxList(shipmentIdList);
            Map<Long, BoxDO> boxMap = boxList.stream()
                    .collect(Collectors.toMap(BoxDO::getId, v -> v));

            Date now = new Date();

            for (BoxBookAirDO boxBookAirDO : boxBookList) {
                Long shipmentId = boxBookAirDO.getShipmentId();
                Long createUserId = Long.valueOf(boxBookAirDO.getCreator());
                BoxDO boxDO = boxMap.get(shipmentId);

                String transportType = boxDO.getTransportType();
                if (CollectionUtil.isNotEmpty(transportTypeList)) {
                    if (!transportTypeList.contains(transportType)) continue;
                }


                //预计起飞时间
                Date flyTime = boxBookAirDO.getFlyTime();
                if (flyTime != null) {
                    Integer blStatus = boxDO.getBlStatus();
                    if (blStatus != BlStatueEnum.HAS_LADING_BILL.getBlStatus()) continue;

                    Integer flyStatus = boxDO.getFlyStatus();
                    if (flyStatus != FlyStatueEnum.FLYING.getDtStatus() && now.compareTo(flyTime) > 0) {
                        checkAddNotice(0L, loginUserId, createUserId, boxDO, NoticeTypeEnum.FLY, noticeList, flyTime);
                    }
                }

                //出货异常
                Date deliveryTime = boxBookAirDO.getDeliveryTime();
                if (deliveryTime != null) {
                    Integer mergePkgStatus = boxDO.getMergePkgStatus();
                    if (mergePkgStatus != MergePkgStatusEnum.MERGED.getStatus()) continue;

                    Integer airShipmentStatus = boxDO.getAirShipmentStatus();
                    if (airShipmentStatus != AirShipmentStatusEnum.SHIPMENT.getStatus() && now.getTime() - deliveryTime.getTime() > 2 * 60 * 60 * 1000) {
                        checkAddNotice(0L, loginUserId, createUserId, boxDO, NoticeTypeEnum.AIR_SHIPMENT, noticeList, flyTime);
                    }
                }
            }
        }

        //出货异常
        List<BoxAbnormalDO> abnormalList = getAbnormalList(true);

        if (CollectionUtil.isNotEmpty(abnormalList)) {
            List<Long> shipmentIdList = abnormalList.stream()
                    .map(BoxAbnormalDO::getShipmentId)
                    .collect(Collectors.toList());
            List<BoxDO> boxList = getBoxList(shipmentIdList);
            Map<Long, BoxDO> boxMap = boxList.stream()
                    .collect(Collectors.toMap(BoxDO::getId, v -> v));

            for (BoxAbnormalDO abnormalDO : abnormalList) {
                String notifyUsers = abnormalDO.getNotifyUsers();
                if (notifyUsers == null) continue;
                Long shipmentId = abnormalDO.getShipmentId();
                Integer opStep = abnormalDO.getOpStep();
                BoxDO boxDO = boxMap.get(shipmentId);
                String transportType = boxDO.getTransportType();
                if (CollectionUtil.isNotEmpty(transportTypeList)) {
                    if (!transportTypeList.contains(transportType)) continue;
                }

                String[] userArray = notifyUsers.split(",");
                NoticeTypeEnum typeEnum = null;
                if (opStep.equals(AbnormalStepAirEnum.CUSTOMS.getStep())) {
                    typeEnum = NoticeTypeEnum.ABNORMAL_CUSTOMS;
                } else if (opStep.equals(AbnormalStepAirEnum.FLYING.getStep())) {
                    typeEnum = NoticeTypeEnum.FLY;
                } else if (opStep.equals(AbnormalStepAirEnum.ARRIVAL.getStep())) {
                    typeEnum = NoticeTypeEnum.ABNORMAL_ARRIVAL;
                }
                Date noticeTime = abnormalDO.getAbnEndTime();
                for (String userId : userArray) {
                    if (!userId.equals(loginUserId.toString())) continue;
                    noticeList.add(addNotice(typeEnum, boxDO, noticeTime));
                }
            }
        }

        //3.agent提醒
        //查找已预装未设置agent的出货
        List<BoxDO> boxList = boxMapper.agentAirNoticeList();
        if (CollectionUtil.isNotEmpty(boxList)) {
            List<Long> shipmentIdList = boxList.stream()
                    .map(BoxDO::getId)
                    .collect(Collectors.toList());
            List<BoxApprovalDO> boxApprovalList = boxApprovalService.list(new LambdaQueryWrapperX<BoxApprovalDO>()
                    .in(BoxApprovalDO::getShipmentId, shipmentIdList)
                    .eq(BoxApprovalDO::getApprovalStatus, ApprovalResultStatusEnum.pass.getValue())
                    .eq(BoxApprovalDO::getApprovalType, BoxApprovalTypeEnum.AIR_SORTING.getType())
            );
            Map<Long, Long> boxNoticeIdMap = boxApprovalList.stream()
                    .collect(Collectors.toMap(BoxApprovalDO::getShipmentId, BoxApprovalDO::getNoticeUser, (v1, v2) -> v2));
            for (BoxDO boxDO : boxList) {
                String transportType = boxDO.getTransportType();
                if (CollectionUtil.isNotEmpty(transportTypeList)) {
                    if (!transportTypeList.contains(transportType)) continue;
                }

                Long noticeUserId = boxNoticeIdMap.get(boxDO.getId());
                if (!loginUserId.equals(noticeUserId)) continue;

                noticeList.add(addNotice(NoticeTypeEnum.AGENT, boxDO, null));
            }
        }

        //4.报关过机异常
        List<BoxDO> customsBoxList = boxMapper.overMachineNoticeList();
        for (BoxDO boxDO : customsBoxList) {
            String transportType = boxDO.getTransportType();
            if (CollectionUtil.isNotEmpty(transportTypeList)) {
                if (!transportTypeList.contains(transportType)) continue;
            }

            noticeList.add(addNotice(NoticeTypeEnum.OVER_MACHINE_WEIGHT, boxDO, null));
        }

        //5.报关退场提醒
        List<BoxCustomsSplitDO> boxCustomsSplitList = boxCustomsSplitService.list(new LambdaQueryWrapper<BoxCustomsSplitDO>()
                .eq(BoxCustomsSplitDO::getDealStatus, 0)
        );
        if (CollectionUtil.isNotEmpty(boxCustomsSplitList)) {
            List<Long> shipmentIdList = boxCustomsSplitList.stream()
                    .map(BoxCustomsSplitDO::getShipmentId)
                    .collect(Collectors.toList());
            List<BoxDO> customsSplitBoxList = getBoxList(shipmentIdList);
            Map<Long, BoxDO> boxMap = customsSplitBoxList.stream()
                    .collect(Collectors.toMap(BoxDO::getId, v -> v));

            for (BoxCustomsSplitDO boxCustomsSplitDO : boxCustomsSplitList) {
                BoxDO boxDO = boxMap.get(boxCustomsSplitDO.getShipmentId());
                NoticeTypeEnum typeEnum = NoticeTypeEnum.AIR_CUSTOMS_SPLIT;
                if (boxCustomsSplitDO.getType() == 1) {
                    typeEnum = NoticeTypeEnum.DELETE_CUSTOMS_SPLIT;
                }
                noticeList.add(addNotice(typeEnum, boxDO, null, boxCustomsSplitDO.getId()));
            }
        }
        return noticeList;
    }


    @Override
    public void updateExitOrderRefundNum(Long id, Integer refundNum) {
        BoxOrderExitDO boxOrderExitDO = boxOrderExitService.getById(id);
        if (Objects.isNull(boxOrderExitDO)) {
            throw exception(BOX_ORDER_EXIT_NOT_EXISTS);
        }
        if (Objects.isNull(boxOrderExitDO.getExitWarehouseIn()) || boxOrderExitDO.getExitWarehouseIn()) {
            throw exception(BOX_ORDER_EXIT_WAREHOUSE_IN_FINISH);
        }
        if (Objects.isNull(refundNum) || refundNum == 0) {
            throw exception(BOX_ORDER_EXIT_REFUND_NUM_NOT_NULL);
        }
        if (refundNum > boxOrderExitDO.getNum()) {
            throw exception(BOX_ORDER_EXIT_REFUND_NUM_MUST_LE_NUM);
        }
        // 兼容之前的数据业务，当退场箱数为0时以实装箱数全部退场为准
        boxOrderExitDO.setRefundNum(refundNum);
        if (Objects.nonNull(boxOrderExitDO.getNum()) && Objects.nonNull(boxOrderExitDO.getRefundNum())) {
            if (boxOrderExitDO.getNum() > boxOrderExitDO.getRefundNum()) {
                // 该订单不是整体退场，需要进行拆单后再操作退场
                boxOrderExitDO.setSplitStatus(1);
            }
            if (Objects.equals(boxOrderExitDO.getNum(), boxOrderExitDO.getRefundNum())) {
                // 该订单整体退场，不需要进行拆单
                boxOrderExitDO.setSplitStatus(0);
            }
        }
        boxOrderExitService.updateById(boxOrderExitDO);
    }

    @Async
    @Override
    public void asyncRemoveOrder(Collection<Long> orderIdCollection, Integer type, boolean hasExit, String transportType) {
        //从预装单移除的话修改订单状态为已入仓
        for (Long orderId : orderIdCollection) {
            // 此时变更状态不需要添加操作日志，有移除预装但操作日志即可
            updateOrderStatus(orderId, OrderStatusEnum.IN_WAREHOUSE.getValue(),
                    OrderWarehouseInStatusEnum.warehouse_finished.getValue(), 0, null, null, Boolean.FALSE, hasExit ? 1 : 0);
            //重置订单的提单号
            resetOrderTidanNo(orderId, hasExit);
        }
        //取消提单的审核
        List<MakeBillOfLadingDO> processingList = makeBillOfLadingService.list(new LambdaQueryWrapper<MakeBillOfLadingDO>()
                .in(MakeBillOfLadingDO::getOrderId, orderIdCollection)
                .eq(MakeBillOfLadingDO::getStatus, BpmProcessInstanceResultEnum.PROCESS.getResult())
        );
        if (CollectionUtil.isNotEmpty(processingList)) {
            processingList.forEach(t -> makeBillOfLadingService.cancel(t.getId()));
        }
        //删除提单
        removeLadingBill(orderIdCollection);
        //订单日志回退
        backOrderLog(transportType, orderIdCollection);
    }


    @Override
    public PageResult<BoxFinanceBackVO> getBoxSettlementPage(BoxSettlementQueryVO query, PageVO page) {
        RegionDO destRegion = regionService.getRegion(query.getDestCountryId());
        if (Objects.isNull(destRegion)) {
            throw exception(DEST_COUNTRY_NOT_EXITS);
        }
        List<Long> destWarehouseIdList = null;
        if (CollectionUtil.isNotEmpty(query.getDestWarehouseIdList())) {
            destWarehouseIdList = query.getDestWarehouseIdList();
        } else {
            Long destCountryId = query.getDestCountryId();
            if (destCountryId != null) {
                List<WarehouseDO> warehouseList = warehouseService.findByCountryIdList(Collections.singletonList(destCountryId));
                destWarehouseIdList = warehouseList.stream().map(WarehouseDO::getId).collect(Collectors.toList());
            }
        }
        query.setDestWarehouseIdList(destWarehouseIdList);
        IPage<BoxDO> boxIPage = boxMapper.selectSettlementPage(page, query);

        List<BoxDO> boxList = boxIPage.getRecords();

        List<BoxFinanceBackVO> boxBackList = BoxConvert.INSTANCE.convertPage1(boxList);


        PageResult<BoxFinanceBackVO> pageResult = new PageResult<>();
        pageResult.setList(boxBackList);
        pageResult.setPage(boxIPage.getCurrent());
        pageResult.setPages(boxIPage.getPages());
        pageResult.setTotal(boxIPage.getTotal());
        pageResult.setRows(boxIPage.getSize());


        List<BoxFinanceBackVO> dataList = pageResult.getList();
        List<Long> shipmentIdList = dataList.stream()
                .map(BoxFinanceBackVO::getId)
                .collect(Collectors.toList());
        if (CollectionUtil.isNotEmpty(shipmentIdList)) {
            //查出这些自编号排单的订单
            List<BoxPreloadGoodsDO> preloadGoodsDOList = boxPreloadGoodsService.list(new LambdaQueryWrapper<BoxPreloadGoodsDO>()
                    .in(BoxPreloadGoodsDO::getShipmentId, shipmentIdList)
                    .eq(BoxPreloadGoodsDO::getIsRemove, 0)
            );

            Map<Long, List<BoxPreloadGoodsDO>> shipmentOrderItemMap = preloadGoodsDOList.stream()
                    .collect(Collectors.groupingBy(BoxPreloadGoodsDO::getShipmentId));

            for (BoxFinanceBackVO boxFinanceBackVO : dataList) {
                boxFinanceBackVO.setDestRegionDO(destRegion);
                Long shipmentId = boxFinanceBackVO.getId();
                List<BoxPreloadGoodsDO> shipmentGoodsList = shipmentOrderItemMap.get(shipmentId);
                if (CollectionUtil.isEmpty(shipmentGoodsList)) continue;
                Set<Long> orderIdSets = shipmentGoodsList.stream()
                        .map(BoxPreloadGoodsDO::getOrderId)
                        .collect(Collectors.toSet());
                //查询订单的统计信息

                ContainerNumberSummaryDto containerNumberSummaryDto = orderQueryService.orderSummaryByDestRegionAndOrderIds(destRegion, orderIdSets);
                boxFinanceBackVO.setSummaryInfo(containerNumberSummaryDto);
            }
        }

        return pageResult;
    }

    @Override
    public BoxSettlementExcelVO getShipmentCostSummaryDto(BoxFinanceBackVO back) {
        BoxSettlementExcelVO excelVO = new BoxSettlementExcelVO();
        excelVO.setSelfNo(back.getSelfNo());
        Integer slStatus = back.getSlStatus();
        excelVO.setSlStatusName(SlStatueEnum.getTextName(slStatus));
        ContainerNumberSummaryDto summaryDto = back.getSummaryInfo();
        if (summaryDto != null) {
            excelVO.setReceivable(summaryDto.getReceivableTotalFeeGroup());

            excelVO.setFreightFeeDest(summaryDto.getNetReceiptsCollectFreightFeeGroup());
            excelVO.setClearanceFeeDest(summaryDto.getNetReceiptsCollectClearanceFeeGroup());
            excelVO.setExtraFeeDest(summaryDto.getNetReceiptsCollectOtherFeeGroup());

            excelVO.setFreightFee(summaryDto.getNetReceiptsAdvanceFreightFeeGroup());
            excelVO.setClearanceFee(summaryDto.getNetReceiptsAdvanceClearanceFeeGroup());
            excelVO.setExtraFee(summaryDto.getNetReceiptsAdvanceOtherFeeGroup());

            excelVO.setFreightFeeDiscount(summaryDto.getDiscountFreightFeeGroup());
            excelVO.setClearanceDiscount(summaryDto.getDiscountClearanceFeeGroup());
            excelVO.setExtraFeeDiscount(summaryDto.getDiscountOtherFeeGroup());
        }
        return excelVO;
    }


    @Override
    public void batchAddPriceSuccess(Long shipmentId, String details) {
        if (StringUtils.isEmpty(details)) {
            throw new ServiceException(500, "加价详情不能为空");
        }
        BoxOrderMarkUpVO boxOrderMarkUpVO =
                JSON.parseObject(details, BoxOrderMarkUpVO.class);

        zTest z = new zTest();
        z.setTestname("开始调用 handleAirOrderBatchMarkup");
        z.setCreatedate(new Date());
        zTestMapper2.insert(z);

        orderBusinessService.handleAirOrderBatchMarkup(
                boxOrderMarkUpVO.getOrderIds(),
                boxOrderMarkUpVO.getFreightFee(),
                boxOrderMarkUpVO.getFreightCurrencyId(),
                boxOrderMarkUpVO.getFreightUnitId(),
                boxOrderMarkUpVO.getClearanceFee(),
                boxOrderMarkUpVO.getClearanceCurrencyId(),
                boxOrderMarkUpVO.getClearanceUnitId());
    }

    @Override
    public void airLoadInfo(Long shipmentId) {
        boxLoadInfoService.createByShipment(shipmentId);
    }

    @Override
    public void deleteClearanceOrder(Long shipmentId, Long backOrderId) {
        boxClearanceOrderService.remove(new LambdaQueryWrapper<BoxClearanceOrderDO>()
                .eq(BoxClearanceOrderDO::getShipmentId, shipmentId)
                .eq(BoxClearanceOrderDO::getOrderId, backOrderId)
        );
    }

    @Override
    public void checkIsInClearance(Long shipmentId, Long orderId) {
        BoxClearanceOrderDO clearanceOrderDO =
                boxClearanceOrderService.getOne(new LambdaQueryWrapper<BoxClearanceOrderDO>()
                        .eq(BoxClearanceOrderDO::getShipmentId, shipmentId)
                        .eq(BoxClearanceOrderDO::getOrderId, orderId)
                );
        if (clearanceOrderDO == null) {
            throw new ServiceException(500, "订单不是已清关状态");
        }
    }


    @Override
    public void deleteArrivalOrderByShipment(Long shipmentId) {
        boxArrivalOrderService.remove(new LambdaQueryWrapper<BoxArrivalOrderDO>()
                .eq(BoxArrivalOrderDO::getShipmentId, shipmentId)
        );
    }

    @Override
    public void deleteClearanceOrderByShipment(Long shipmentId) {
        boxClearanceOrderService.remove(new LambdaQueryWrapper<BoxClearanceOrderDO>()
                .eq(BoxClearanceOrderDO::getShipmentId, shipmentId)
        );
    }


    @Override
    public void checkOrderPayStatus(BoxOrderMarkUpVO vo) {
        Collection<Long> orderIds = vo.getOrderIds();
        if (CollectionUtil.isEmpty(orderIds)) return;
        List<ReceivableDO> receivableList =
                receivableService.getOrderPayList(orderIds);
        List<OrderDO> orderList =
                orderQueryService.getOrderList(orderIds);
        Map<Long, OrderDO> orderMap = orderList.stream()
                .collect(Collectors.toMap(OrderDO::getOrderId, v -> v));
        Boolean freightMarkUp = Objects.nonNull(vo.getFreightFee()) && vo.getFreightFee().compareTo(BigDecimal.ZERO) > 0;
        Boolean clearanceMarkUp = Objects.nonNull(vo.getClearanceFee()) && vo.getClearanceFee().compareTo(BigDecimal.ZERO) > 0;
        List<String> payOrderNoList = new ArrayList<>();
        List<ReceivableDO> newReceivableList = new ArrayList<>();
        if (CollectionUtil.isNotEmpty(receivableList)) {
            newReceivableList = receivableList.stream().filter(r -> r.getFeeSource() == 1
                    && ((freightMarkUp && r.getFeeType() == 1) || (clearanceMarkUp && r.getFeeType() == 2))).collect(Collectors.toList());
        }
        if (CollectionUtil.isNotEmpty(newReceivableList)) {
            // 只判断订单自动计算的运费与清关费应收单, 且运费加价，只判断运费应收单，清关费加价，只判断清关费应收单
            Map<Long, List<ReceivableDO>> receivableMap = newReceivableList.stream()
                    .collect(Collectors.groupingBy(ReceivableDO::getOrderId));
            for (Map.Entry<Long,
                    List<ReceivableDO>> entry : receivableMap.entrySet()) {

                Long orderId = entry.getKey();
                OrderDO orderDO = orderMap.get(orderId);
                payOrderNoList.add(orderDO.getOrderNo());
            }
            throw new ServiceException(500,
                    Joiner.on(",").join(payOrderNoList) + "已预付核销，不允许修改价格");
        }
    }

    @Override
    public void updateUlBoxTime(Long shipmentId, Date ulBoxTime) {
        BoxDO boxDO = getById(shipmentId);
//        boolean air = boxDO.getTransportType().equals(TransportTypeEnum.AIR.getType());
        BoxCabinetUnloadDO boxCabinetUnloadDO = boxCabinetUnloadService.getOne(new LambdaQueryWrapperX<BoxCabinetUnloadDO>()
                .eq(BoxCabinetUnloadDO::getShipmentId, shipmentId)
                .last("limit 1")
        );
        if (boxCabinetUnloadDO == null) {
            boxCabinetUnloadDO = new BoxCabinetUnloadDO();
            boxCabinetUnloadDO.setShipmentId(shipmentId);
            boxCabinetUnloadDO.setUlBoxTime(ulBoxTime);
            boxCabinetUnloadService.save(boxCabinetUnloadDO);
        } else {
            boxCabinetUnloadDO.setUlBoxTime(ulBoxTime);
            boxCabinetUnloadService.updateById(boxCabinetUnloadDO);
        }

    }

    @Override
    public BoxApprovalDO getLatestApproval(Long shipmentId) {
        return boxApprovalService.selectOne(new LambdaQueryWrapperX<BoxApprovalDO>()
                .eq(BoxApprovalDO::getShipmentId, shipmentId)
                .eq(BoxApprovalDO::getApprovalStatus, BpmProcessInstanceResultEnum.APPROVE.getResult())
                .last("limit 1")
                .orderByDesc(BoxApprovalDO::getCreateTime)
        );
    }

    @Override
    public void backOrderLog(String transportType, String selfNo) {
        if (transportType.equals(TransportTypeEnum.AIR.getType())) {
            orderTimeService.sortingReverseReviewDeleteOrderTime(selfNo);
        } else {
            orderTimeService.preReverseReviewDeleteOrderTime(selfNo);
        }
    }

    @Override
    public void backOrderLog(String transportType, Collection<Long> orderIds) {
        if (transportType.equals(TransportTypeEnum.AIR.getType())) {
            for (Long orderId : orderIds) {
                orderTimeService.sortingReverseReviewDeleteOrderTime(orderId);
            }
        } else {
            for (Long orderId : orderIds) {
                orderTimeService.preReverseReviewDeleteOrderTime(orderId);
            }
        }
    }

    @Override
    public void lockOrderPrice(Long shipmentId) {
        Set<Long> orderIds = boxPreloadGoodsService.getShipOrderIdList(shipmentId);
        if (CollectionUtil.isEmpty(orderIds)) return;
        orderService.finishOrderSorting(null, orderIds);
    }

    @Override
    public void unlockOrderPrice(Long shipmentId) {
        Set<Long> orderIds = boxPreloadGoodsService.getShipOrderIdList(shipmentId);
        if (CollectionUtil.isEmpty(orderIds)) return;
        orderService.finishOrderSortingReverseReviewUnlock(null, orderIds);
    }

    /*
     获取实际数
     */
    @Override
    public Integer getRealNum(Long shipmentId) {
        int realNum = 0;
        List<BoxMergePkgDO> boxMergePkgDOS =
                boxMergePkgService.selectList(BoxMergePkgDO::getShipmentId, shipmentId);
        List<BoxPreloadGoodsDO> boxPreloadGoodsDOS =
                boxPreloadGoodsService.selectList(
                        new LambdaQueryWrapperX<BoxPreloadGoodsDO>().eq(BoxPreloadGoodsDO::getShipmentId, shipmentId).eq(BoxPreloadGoodsDO::getIsRemove, 0));

        List<Long> preloadOrderIds = boxPreloadGoodsDOS.stream().map(BoxPreloadGoodsDO::getOrderId).distinct().collect(Collectors.toList());
        if (CollectionUtil.isNotEmpty(boxMergePkgDOS)) {
            for (BoxMergePkgDO boxMergePkgDO : boxMergePkgDOS) {
                List<BoxPkgOrderDO> boxPkgOrderDOS = boxPkgOrderService.selectList(BoxPkgOrderDO::getPkgId, boxMergePkgDO.getId());
                if (CollectionUtil.isNotEmpty(boxPkgOrderDOS)) {
                    List<Long> orderIds = boxPkgOrderDOS.stream().map(BoxPkgOrderDO::getOrderId).collect(Collectors.toList());
                    preloadOrderIds.removeAll(orderIds);
                    List<OrderDO> orderDOS = orderService.selectList(OrderDO::getOrderId, orderIds);
                    int orderSumNum = orderDOS.stream().mapToInt(OrderDO::getSumNum).sum();
                    Long loadCount = boxLoadInfoService.selectCount(new LambdaQueryWrapper<BoxLoadInfoDO>()
                            .eq(BoxLoadInfoDO::getShipmentId, shipmentId)
                            .in(BoxLoadInfoDO::getOrderId, orderIds)
                    );
                    if (loadCount.intValue() == orderSumNum) {
                        realNum = realNum + 1;
                    }
                } else {
                    realNum = realNum + 1;
                }
            }
        }

        if (CollectionUtil.isNotEmpty(preloadOrderIds)) {
            Long notInMergeOrderCount =
                    boxLoadInfoService.selectCount(
                            new LambdaQueryWrapperX<BoxLoadInfoDO>()
                                    .eq(BoxLoadInfoDO::getShipmentId, shipmentId)
                                    .in(BoxLoadInfoDO::getOrderId, preloadOrderIds)
                    );
            realNum = realNum + (notInMergeOrderCount == null ? 0 : notInMergeOrderCount.intValue());
        }
        return realNum;
    }

    @Override
    public void clearUnloadCabinet(Long shipmentId) {
        boxLoadInfoService.update(null, new LambdaUpdateWrapper<BoxLoadInfoDO>()
                .eq(BoxLoadInfoDO::getShipmentId, shipmentId)
                .set(BoxLoadInfoDO::getIsUnload, 0)
        );
    }
}
